<?php

/**
 * @file
 * Provides common database-related functionalites for cloud management.
 * 
 * Copyright (c) 2010-2011 DOCOMO Innovations, Inc.
 * 
 */


/**
 * update cloud table with latest timestamp
 * @return unknown_type
 */
function cloud_update_host_entries_last_update_time($cloud_context) {
  
  db_query( 'update {' . CLOUD_CLOUDS_TABLE . "} set last_update_time  = CURRENT_TIMESTAMP where cloud_name  = '" . $cloud_context . "' ");
  
  // User Activity Log
  cloud_audit_user_activity( array(
      'type'    => 'user_activity', 
      'message' => t('Cloud has been modified: @cloud_context', array('@cloud_context' => $cloud_context)), 
      'link'    => '', //'design/alerts/create&id=' . $alert_id
    )
  ); 
    
  return;
}

/**
 * Add a cloud row into the cloud_clouds table
 * @param unknown_type $query_args
 */
function cloud_add_cloud_row($query_args) {
  return db_query("INSERT INTO {" . CLOUD_CLOUDS_TABLE . "}
    (cloud_name, cloud_display_name, last_update_time, host_entries_refresh_time, module, base_cloud)
    values ('%s', '%s', CURRENT_TIMESTAMP - 10, '%s', '%s', '%s')", $query_args);
}

/**
 * Get the module responsible for this cloud_context.
 */
function cloud_get_module($cloud_context) {
  static $modules;
  $return = NULL;
  if (isset($modules[$cloud_context])) {
    $return = $modules[$cloud_context];
  }
  else {
    $module = db_result(db_query('SELECT module from {' . CLOUD_CLOUDS_TABLE . '} where cloud_name = \'%s\'', array($cloud_context)));
    if ($module !== FALSE) {
      $return = $module;
      $modules[$cloud_context] = $return;
    }
  }
  return $return;
}

/**
 * Get the base cloud type for this cloud_context
 */
function cloud_get_base_cloud($cloud_context) {
  return db_result(db_query("SELECT base_cloud from {" . CLOUD_CLOUDS_TABLE . "} where cloud_name = '%s'", array($cloud_context)));
}

/**
 * Check for an existing cloud_name in the database
 * @param unknown_type $cloud_name
 */
function cloud_check_cloud_name($cloud_name) {
  return cloud_get_db_results("SELECT cloud_name from {" . CLOUD_CLOUDS_TABLE . "} where cloud_name = '%s'", array($cloud_name));
}

function cloud_get_all_scripts($type) {
 
  $query = _cloud_scripting_get_scripts() ;
  //$query .= tablesort_sql( array(array('field' => 'name', 'sort' => 'asc')) ) ;
  $script_options = array();
  $query_args[] = 'type' ;
  $query_args[] = $type ;
  $result = db_query( $query, $query_args ); 
  
  while ($script = db_fetch_object($result)) {
  
    $script_options[$script->script_id] = $script->name ;
  }
  //asort($script_options);
  return $script_options ;
}


