<?php

/**
 * @file
 * Provides cluster feature which enables to bundle server templates.
 * Works with Cloud and Server Templates module.
 *
 * Copyright (c) 2010-2011 DOCOMO Innovations, Inc.
 *
 */

/**
 * Updated   by yas   2011/03/03
 * Updated   by yas   2011/02/17
 * Updated   by yas   2011/02/14
 * Updated   by yas   2011/02/10
 * Updated   by yas   2011/02/02
 * Updated   by yas   2011/02/01
 * Updated   by Jamir 2011/02/01
 * Updated   by Jamir 2011/01/29
 * Formatted by yas   2011/01/28
 * Updated   by Jamir 2011/01/27
 * Updated   by Jamir 2011/01/26
 */

/**
 * Display Cluster List
 * 
 * @param $form_submit
 * @return
 */
function cloud_cluster_display_list($form_submit) {

  drupal_add_js(cloud_get_module_base() . 'js/cloud.js'               , 'module');
  drupal_add_js(cloud_get_module_base() . 'js/cloud_activity_audit.js', 'module');
  
  $column = 'cluster_nickname' ;

  $options = array(
    t('Nickname'),
    t('Creator' ),
  );
   
  $filter     = cloud_get_filter_value( $form_submit , 'filter'   );
  $filter     = trim($filter);

  $filter_col = cloud_get_filter_value( $form_submit , 'operation');
  $filter_col = isset($filter_col) && $filter_col ? $filter_col : 0; // default value: Nickname

  $sql_col = NULL ;

  if ( $filter_col == 0 )  {
    $column  = 'Nickname' ;
    $sql_col = 'cluster_nickname' ;
  }
  elseif ($filter_col == 1 ) {
    $column  = 'Creator' ;
    $sql_col = 'creator' ;
  }

  $query_args = array() ;
  if ( isset($filter) ) {

    $query_args[] = $sql_col ;
    $query_args[] = $filter  ;
  }
  else {
    $filter       = ' 1 ' ;
    $query_args[] = ' '   ;
  }

// asort($options);
  $cluster_count = _cloud_cluster_get_count_db() ;
  $filter_disabled = '' ;
  if ( $cluster_count < 2 ) {

    $filter_disabled = TRUE ;
  }
  
  $form = array() ;
  $form['operations'] = array(
    '#prefix' => '<div class="container-inline">',
    '#type'   => 'fieldset',
    '#suffix' => '</div>',
 // '#title' => t('Operations'), 
  );
  
  $form['operations']['label'    ] = array( '#type' => 'item'     , '#title'   => t('Filter'));
  $form['operations']['operation'] = array( '#type' => 'select'   , '#options' => $options  , '#disabled' => $filter_disabled, '#default_value' => $filter_col );
  $form['operations']['filter'   ] = array( '#type' => 'textfield', '#size'    => 40        , '#default_value' => $filter   , '#disabled' => $filter_disabled  );
  $form['operations']['submit'   ] = array( '#type' => 'submit'   , '#value'   => t('Apply'), '#disabled' => $filter_disabled  );

  if (user_access('create cluster') ) {

    $tmpl_active_count = _cloud_server_templates_get_active_template_count_by_cloud() ;
    
    if (isset($tmpl_active_count) && count($tmpl_active_count) > 0 ) {
    
      $form['operations']['cloud_cluster'] = array('#type' => 'submit', '#value' => t('Create'));
    }
    else {

      $form['operations']['cloud_cluster'] = array('#type' => 'submit', '#value' => t('Create') , '#disabled' => TRUE );
      $template_url = filter_xss( l( t('Design - Template'), 'design/server_templates' ) );
      drupal_set_message(check_plain(t('There are no Templates > ', array())) . $template_url );
    }
  }

  $form['header'] = array(

    '#type' => 'value',
    '#value' => array(
      array('data' => t('Nickname'   ), 'field' => 'cluster_nickname'
                                      , 'sort'  => 'asc'
                                      , 'class' => 'nickname-column' ),
      array('data' => t('Description'), 'field' => 'description'     ),
      array('data' => t('Creator'    ), 'field' => 'creator'         ),
      array('data' => t('Servers'    )                               ),
      array('data' => t('Running'    )                               ),
      array('data' => t('Action'     ), 'class' => 'action-column'   )
    )
  );

  $query  = _cloud_cluster_get_clusters_query()
          . tablesort_sql( $form['header']['#value'] ) ;

  $result = pager_query( $query, CLOUD_CLUSTER_PAGER_LIMIT, 0, NULL, $query_args );

  $destination = drupal_get_destination();

  $filter_params = array() ;
  $filter_params['filter_state'] = 'all' ;
  $all_instances_list = cloud_get_all_instances_list($filter_params) ;
  
  while ($cluster = db_fetch_object($result)) {

    $run_count = _cloud_cluster_get_running_instance_count($cluster->cluster_id , '' , $all_instances_list) ;
    $form['hdnName'    ][$cluster->cluster_id] = array('#type' => 'hidden', '#value' => addslashes($cluster->cluster_nickname) );
    if ( $run_count > 0 ) {
      $form['Nickname' ][$cluster->cluster_id] = array(array('#value' => l( $cluster->cluster_nickname , CLOUD_CLUSTER_PATH . '/describe/servers/' . $cluster->cluster_id ,  array() ) ) );
    }
    else {
      $form['Nickname' ][$cluster->cluster_id] = array(array('#value' => l( $cluster->cluster_nickname , CLOUD_CLUSTER_PATH . '/describe/cluster_templates/' . $cluster->cluster_id ,  array() ) ) );
    }

    $form['Description'][$cluster->cluster_id] = array(array('#value' => check_plain( $cluster->description ) ) );
    $form['Creator'    ][$cluster->cluster_id] = array(array('#value' => t( $cluster->creator ) ) );

    $servers_count = _cloud_cluster_get_servers_count($cluster->cluster_id , $all_instances_list) ;
    $form['Servers'    ][$cluster->cluster_id] = array(array('#value' => t( $servers_count ) ) );

    $form['Running'    ][$cluster->cluster_id] = array(array('#value' => t( $run_count ) ) );
  }
  
  $form['pager'    ] = array('#value' => theme('pager', NULL, CLOUD_CLUSTER_PAGER_LIMIT, 0));
  $form['#redirect'] = FALSE;

  return $form;
}


function theme_cloud_cluster_display_list($form) {
  
  $prop   = array() ;
  $form['Nickname'] = !empty($form['Nickname']) ? $form['Nickname'] : array();
  $form['pager']['#value'] = !empty($form['pager']['#value'])
                           ?        $form['pager']['#value']
                           : '';
  $rows = array();
  
  foreach (element_children($form['Nickname']) as $key) {
      
    $row = array(array('data' => 
      drupal_render($form['Nickname'   ][$key]), 'class' => 'nickname-column'),
      drupal_render($form['Description'][$key]),
      drupal_render($form['Creator'    ][$key]),
      drupal_render($form['Servers'    ][$key]),
      drupal_render($form['Running'    ][$key]),
    );
    
    $prop['onclick'] = cloud_get_messagebox('Are you sure you want to delete the cluster "@clueter_name" ?',
                                                                                    array('@cluster_name' => $form['hdnName'][$key]['#value'])) ;
    $action_data = '' ;
    if (user_access('delete cluster')) {
      $action_data .= cloud_display_action( 'images/icon_delete', t('Delete') , CLOUD_CLUSTER_PATH . '/delete/' . $key ,  array(), $prop['onclick']);
    }
    
    if (user_access('update cluster')) {
      $action_data  .= cloud_display_action( 'images/edit', t('Edit'), CLOUD_CLUSTER_PATH . '/describe/info/' . $key , array('html' => TRUE));
    }
      
    if (module_exists('cloud_inputs') ) { // Check if inputs exists

      if (user_access('update cluster')) {

        $action_data .= cloud_display_action( 'images/table_gear', 'Inputs' , 'design/cloud_cluster/' . urlencode($key) . '/inputs',  array('query' => 'cluster_id=' . urlencode($key) . '&module=cluster', 'html' => TRUE));
      }
    }
     
    $row[]  = array('data' => $action_data, 'class' => 'action-column' );     
    $rows[] = $row;
  }

  $reload_link = l('- Refresh Page -' , CLOUD_CLUSTER_PATH  ,  array( 'query' => 'src=' . CLOUD_CLUSTER_PATH  ) );
  $ref_link = array('#type' => 'item', '#prefix' => '<div id="link_reload" align="right">', '#suffix'  => '</div>', '#value' => $reload_link  );

  $output  = drupal_render($form['operations']);
  $output .= theme('table', $form['header']['#value'], $rows);
   
  if ($form['pager']['#value']) {
    $output .= drupal_render($form['pager']);
  }

  $output .= drupal_render($ref_link);
  $output .= drupal_render($form);

  return $output;
}


function cloud_cluster_display_list_submit($form_id, $form_values) {

  $form_values = $form_values['values'];
  
  if ( $form_values['op'] == t('Create')) {

    return drupal_goto( CLOUD_CLUSTER_PATH . '/create') ;
  }

  return;
}


function _cloud_cluster_callback_get_cluster_servers_list() {

  drupal_add_link(array(
    'type'  => 'text/css'  ,
    'rel'   => 'stylesheet',
    'media' => 'all'       ,
    'href'  => base_path()
             . drupal_get_path('module', 'cloud')
             . CLOUD_PATH_SEPARATOR
             . 'css/cloud.css')
  );

  drupal_add_js(cloud_get_module_base() . 'js/cloud.js', 'module');
  
  $cluster_id = isset($_REQUEST['cluster_id']) ? $_REQUEST['cluster_id'] : FALSE ;

  if ( empty($cluster_id) )   {

    $output = 'NULL' ;
    $html = $output ;
    print drupal_to_js(array('html' => $html));
    
    // The exit() call is critical!
    exit();
  }

  $query      = _cloud_cluster_servers_get_query() ;
  $query_args = array(
    $cluster_id,
  ) ;

  $result     = db_query( $query, $query_args );
  $total_rows = _cloud_cluster_servers_get_count_db($cluster_id)  ;

  $filter_params = array() ;
  $filter_params['filter_state'] = 'all' ;

  $q = $_GET['q'] ;
  $_GET['q'] = CLOUD_CLUSTER_PATH . '/describe/servers/' . $cluster_id ;
  $all_instances_list = cloud_get_all_instances_list($filter_params) ;
  $_GET['q'] = $q ;
  
  $table_data = array() ;
  
  $table_data['header'] = array(

    '#type' => 'value',
    '#value' => array(
      array('data' => t('Nickname'     ), 'field' => 'server_name'       ,
                                          'class' => 'nickname-column'  ),
      array('data' => t('Instance name'), 'field' => 'instance_nickname'),
      array('data' => t('Cloud'        ), 'field' => 'cloud_context'    ),
      array('data' => t('Zone'         ), 'field' => 'zone'             ),
      array('data' => t('Hostname'     ), 'field' => 'host_name'        ),
      array('data' => t('ID'           ), 'field' => 'instance_id'      ),
      array('data' => t('Template'     ), 'field' => 'server_template'  ),
      array('data' => t('State'        ), 'field' => 'state'            ),
      array('data' => t('Runtime'      ), 'field' => 'runtime'          ),
      array('data' => t('Action'       ), 'class' => 'action-column'    ),
    )
  );

  $count = 0 ;
  $cloud_name_list = cloud_get_all_clouds_display_name();
  $server_list     = array() ;

  $run_count = _cloud_cluster_get_running_instance_count($cluster_id) ;

  while ($clust = db_fetch_object($result)) { // Cluster server object

    if ($run_count == 0) {

        break ; // No instances running
    }

    $inst_count = 0 ;
    $inst_found = TRUE ;
    $instance_ids = array(0) ; // Dummy array
    $instance_ids_str = $clust->instance_id ;
    if ( empty($instance_ids_str) ) {

      $inst_found = FALSE ;
    }
    else {

      $instance_ids = explode( ',' , $instance_ids_str ) ;
    }

    foreach ($instance_ids as $instance_id ) {

      $inst_count++ ;
      $server_id =  $clust->server_id ;
      $index_id  =  $clust->server_id . '_' . $instance_id ;

      $server_list[$index_id]['index_id'           ] = $index_id ;
      $server_list[$index_id]['server_id'          ] = $server_id ;
      $server_list[$index_id]['server_name'        ] = $clust->server_nickname ;

      if ( $inst_found
      && count($instance_ids) > 1 ) {

          $server_list[$index_id]['server_name'        ] .= ' #' . $inst_count ; // Append #1, #2...
      }

      $tmpl = cloud_get_server_template_info($clust->template_id) ;
      $server_list[$index_id]['server_template_id' ] = $clust->template_id ;
      $server_list[$index_id]['server_template'    ] = $tmpl->template_nickname ;
      $server_list[$index_id]['cloud_context'      ] = $tmpl->cloud_type ;
      $server_list[$index_id]['cloud_context_name' ] = isset( $cloud_name_list[$tmpl->cloud_type] ) ? $cloud_name_list[$tmpl->cloud_type] : $tmpl->cloud_type ;

      if ( empty($instance_id) === FALSE
      && isset($all_instances_list[$instance_id]) ) {

        $instance_info = $all_instances_list[$instance_id] ;

        $server_list[$index_id]['instance_nickname' ] = trim($instance_info['name']) ;
        $server_list[$index_id]['host_name'         ] = $instance_info['hostname' ];
        $server_list[$index_id]['instance_id'       ] = $instance_id ;
        $server_list[$index_id]['state'             ] = ucwords($instance_info['state']);
        $server_list[$index_id]['zone'              ] = $instance_info['zone'];
        $server_list[$index_id]['runtime'           ] = $instance_info['runtime'];
        $server_list[$index_id]['lock_status'       ] = $instance_info['lock_status'];
      }
      else {

        $server_list[$index_id]['instance_nickname' ] = '' ;
        $server_list[$index_id]['host_name'         ] = '' ;
        $server_list[$index_id]['instance_id'       ] = '' ;
        $server_list[$index_id]['state'             ] = '' ;
        $server_list[$index_id]['zone'              ] = '' ;
        $server_list[$index_id]['runtime'           ] = '' ;
        $server_list[$index_id]['lock_status'       ] = '' ;
      }

      if ( empty($instance_id) === FALSE ) {
      
          $server_list[$index_id]['instance_id'       ] = $instance_id ;
      }
    } // End of foreach ($instance_ids as $instance_id ) {
  } // End of while

  $ts = tablesort_init( $table_data['header']['#value'] );
  if ($ts['sql']) {

    $field =  $ts['sql'] ;
    $server_list = _cloud_sort_by_value( $server_list, $field, $ts['sort'] ) ;
  }

  foreach ( $server_list as $cluster_server ) {

    $index_id        = $cluster_server['index_id'          ] ;
    $server_id       = $cluster_server['server_id'         ] ;
    $cloud_context   = $cluster_server['cloud_context'     ] ;
    $name            = $cluster_server['instance_nickname' ] ;
    $state           = $cluster_server['state'             ] ;
    $hostname        = $cluster_server['host_name'         ] ;
    $zone            = $cluster_server['zone'              ] ;
    $runtime         = $cluster_server['runtime'           ] ;
    $lock_status     = $cluster_server['lock_status'       ] ;
    $instance_id     = $cluster_server['instance_id'       ] ;

    $cloud_menu_path = cloud_get_menu_path($cloud_context) ;

    $table_data['server_name'][$index_id] = array( array(
        '#prefix' => '<span class=\'anchor\'>' ,
        '#value' => t( $cluster_server['server_name'] ) ,
        '#suffix' => '</span>'
      )
    );
    $table_data['hdnName'        ][$index_id] = array( '#type' => 'hidden', '#value' => t( $cluster_server['server_name'] ) );

    if ( !empty($state)
    && drupal_strtolower($state) == 'running' ) {

      $table_data['instance_nickname'][$index_id] = array(
        array(
          '#value' => l($name,
                          $cloud_menu_path . '/instances/describe/' . $instance_id . '/info',
                          array(
                            'query' => 'instance_id=' . urlencode($instance_id)))
                                                      . (($lock_status == 'Lock')
                                                      ? '<a class=lockIcon title=Lock>&nbsp;&nbsp;&nbsp;&nbsp;</a>'
                                                      : ''
                        ) // end 'l' function
        ) // end array
      ); // end $form
    }
    else {

      $table_data['instance_nickname'][$index_id] = array( array('#value' => $name ) );
    }

    $public_dns = substr( $hostname, 0, strpos($hostname,  '.') ) ;
    if ( strlen($public_dns) > 3 ) { // truncate only in case the name is long

      $public_dns = substr($hostname, 0, strpos($hostname,  '.')) . '...' ;
    }
    else {

      $public_dns = $hostname ;
    }
    
    $table_data['Cloud_type'     ][$index_id] = array( array('#value' => t( $cluster_server['cloud_context_name'] ) ) );
    $table_data['Zone'           ][$index_id] = array( array('#value' => t( $zone           ) ) );
    $table_data['Public_ip'      ][$index_id] = array( array('#value' => l($public_dns,
                                                                  'http://' . $hostname, array('attributes' => array('target' => '_blank'),
                                                                  'query' => '') ) ) );
 // $form['Public_ip'            ][$server_id] = array( array('#value' => t( $hostname  ) ) ) ;
    $table_data['Instanceid'     ][$index_id] = array( array('#value' => t( $instance_id    ) ) );
    $table_data['server_template'][$index_id] = array( array('#value' => l( $cluster_server['server_template'] ,  'design/server_templates/' . $cloud_context  . '/' . $cluster_server['server_template_id'] . '/view' , array('query' => 'id=' . urlencode($cluster_server['server_template_id'] )) ) ) );
    $table_data['State'          ][$index_id] = array( array('#value' => t( ucwords($state) ) ) );
    $table_data['Runtime'        ][$index_id] = array( array('#value' => t( ($runtime)
                                                                 ? cloud_get_runtime($runtime)
                                                                 : ''
                                                                 ) ) );
    $table_data['server_id'   ][$index_id] = array( array('#type' => 'hidden', '#value' => t( $server_id) ) );

  }
  
  // Theme for the table data
  $rows = array() ;

  if (isset($table_data['server_name']) )  {

    foreach (element_children($table_data['server_name']) as $deplkey) {

      $prop_delete = array() ;
      $prop_delete['onclick'] = cloud_get_messagebox('Are you sure you want to delete the server "' . $table_data['hdnName'][$deplkey]['#value'] . '" ?') ;

      $row = array(array('data' =>
        drupal_render($table_data['server_name'       ][$deplkey]), 'class' => 'nickname-column'),
        drupal_render($table_data['instance_nickname' ][$deplkey]),
        drupal_render($table_data['Cloud_type'        ][$deplkey]),
        drupal_render($table_data['Zone'              ][$deplkey]),
        drupal_render($table_data['Public_ip'         ][$deplkey]),
        drupal_render($table_data['Instanceid'        ][$deplkey]),
        drupal_render($table_data['server_template'   ][$deplkey]),
        drupal_render($table_data['State'             ][$deplkey]),
        drupal_render($table_data['Runtime'           ][$deplkey]),
      );

      $action_data = '' ;
      $server_id   = $table_data['server_id'][$deplkey][0]['#value'] ;

      if (empty($table_data['Instanceid'][$deplkey][0]['#value'])
      ||  drupal_strtolower( $table_data['State'][$deplkey][0]['#value']) == 'terminated'
      ||  drupal_strtolower( $table_data['State'][$deplkey][0]['#value']) == 'stopped'
      ||  empty( $table_data['State'][$deplkey][0]['#value'])) {

        if (user_access('update cluster') ) {

          $action_data .= cloud_display_action(
            'images/icon_play',
            'Launch',
            CLOUD_CLUSTER_PATH . '/describe/servers/launch_server/' . $cluster_id . '/' . $server_id ,
            array( 'query' => 'instance_id=' . $table_data['Instanceid'][$deplkey][0]['#value'] )
          );
        }

        /*if (user_access('delete cluster')) {
          $action_data .= cloud_display_action(
            'images/icon_delete',
            'Delete',
            CLOUD_CLUSTER_PATH . '/describe/servers/delete_server/' . $cluster_id . '/' . $server_id ,
            array('query' => 'server_id=' . urlencode($server_id), 'html' => TRUE),
            $prop_delete['onclick']);
        }*/
      }
      elseif (empty($table_data['Instanceid'][$deplkey][0]['#value']) === FALSE ) {

        $instance_id = $table_data['Instanceid'][$deplkey][0]['#value'] ;
        if (isset($all_instances_list[$instance_id]) ) {
        
          $action_data .= $all_instances_list[$instance_id]['action_data'] ;
        }
      }

      $row[]  = array('data' => $action_data, 'class' => 'action-column' );
      $rows[] = $row;
    }
  }

  $table_attr = array() ;
  $table_attr['id'] = 'cluster_servers_list_table' ;
  $table_attr['autoupdate_url'] = url( CLOUD_CLUSTER_PATH . '/callback_get_cluster_servers_list' ) ;
  $output = theme('table', $table_data['header']['#value'], $rows, $table_attr);
  
  // Send only the body do not send the headers
  $index_start = strrpos( $output , '<tbody>' ) ;
  $index_end   = strrpos( $output , '</tbody>' ) ;
  if ( empty($total_rows) || $run_count == 0 ) { // No element present

    $output = 'NULL' ;
  }
  else {

    $output = substr( $output , $index_start , $index_end - $index_start ) ;
    $output .= '</tbody>' ;
 }

  $html = $output ;

  print drupal_to_js(array('html' => $html));

  // The exit() call is critical!
  exit();
}


/**
 * Create a new Cluster
 * 
 * @param $page_submit
 * @return
 */
function cloud_cluster_create_new_cluster($page_submit='') {

  $form = array() ;
  
  $form['fieldset_cluster_info'             ] = array('#type' => 'fieldset', /* '#title' => t('Cluster Info') */);
  $form['nickname_details']['nickname_label'] = array('#type' => 'item', '#title' => t('Nickname') , '#required' => TRUE );
  $form['nickname_details']['nickname_text' ] = array('#type' => 'textfield' );

  $form['Description_details']['Description_label'] = array('#type' => 'item', '#title' => t('Description')  );
  $form['Description_details']['description_text' ] = array('#type' => 'textarea' );

  $form['submit_buttons'] = array(
    '#type'   => 'fieldset',
    '#prefix' => '<span class="clear"></span><div class="container-inline"><div class="buttons">',
    '#suffix' => '</div></div>'
  );

   $form['submit_buttons']['Next'  ] = array('#type' => 'submit', '#value' => t('Next'  ) );
   $form['submit_buttons']['Cancel'] = array('#type' => 'submit', '#value' => t('Cancel') );
  
   return $form ;
}


function theme_cloud_cluster_create_new_cluster($form) {

  $rows = array(
    array(
      drupal_render($form['nickname_details']['nickname_label'] ),
      drupal_render($form['nickname_details']['nickname_text' ] ),
    ),
    array(
      drupal_render($form['Description_details']['Description_label'] ),
      drupal_render($form['Description_details']['description_text' ] ),
    ),
  ) ;

  $table = theme('table', NULL, $rows );
  $form['fieldset_cluster_info']['#children'] = $table;

//cf. Waning by Coder module: Potential problem: when FAPI element '#type' is set to 'markup' (default), '#value' only accepts filtered text, be sure to use check_plain(), filter_xss() or similar to ensure your $variable is fully sanitized.
//$form['fieldset_cluster_info']['list'] = array('#type' => 'markup', '#value' => $table);
  
  $output  = '';
  $output .= drupal_render($form['fieldset_cluster_info']);
  $output .= drupal_render($form['submit_buttons'       ]);
  $output .= drupal_render($form);

  return $output;
}


function cloud_cluster_create_new_cluster_validate($form_id, $form_values) {
    
  $form_values = $form_values['values'];
  if ( $form_values['op'] == t('Next') )  {

    if ( empty( $form_values['nickname_text']) == TRUE) {
      form_set_error('',  t('Please enter Nickname'));
      return ;
    }
    else {

      // Check whether same name cluster exists
      $query = _cloud_cluster_get_cluster_by_filter_query();
      $query_args = array(
        'cluster_nickname',
        $form_values['nickname_text'],
      );
      $result = db_query( $query, $query_args );
      $t_count = is_object($result) ? $result->num_rows : 0 ;
     
      if ($t_count>0) {
        $db_obj = db_fetch_object($result);
        $cluster_id = $db_obj->cluster_id;

        if ($cluster_id!=$form_values['cluster_id']) {
          form_set_error('',  t('Name is already used by a Cluster.'));
        }
      }
    }
  }
}


function cloud_cluster_create_new_cluster_submit($form_id, $form_values) {
    
  $form_values = $form_values['values'];
  
  if ( $form_values['op'] == t('Cancel') ) {

    drupal_goto( CLOUD_CLUSTER_PATH ) ;

    return ;
  }
  elseif ($form_values['op'] == t('Next')) {

    global $user;

    $owner      = $user->name ;
    $cluster_id = _cloud_cluster_save_cluster_db($form_values, $owner) ;

    if ($cluster_id !== NULL ) {

      // $cluster_url = filter_xss( l( t('Cluster Design - Add Server(s)'), CLOUD_CLUSTER_PATH . '/describe/cluster_templates/' . $cluster_id ) );
      drupal_set_message( check_plain( t('Cluster successfully created. For the next step, add Server(s) based on Template to Cluster.' ))) ;
      $enabled_cloud_list = cloud_get_clouds() ;
      $tmpl_active_count  = _cloud_server_templates_get_active_template_count_by_cloud() ;
      for ($row_counter   = 0; $row_counter < count($enabled_cloud_list); $row_counter++) {

        $cloud_name = $enabled_cloud_list[$row_counter]["cloud_name"] ;
        if (isset($tmpl_active_count) == FALSE || isset($tmpl_active_count[$cloud_name]) == FALSE )  {

          // No templates repsent
          continue ;
        }
        // Goto the first cloud in the list

        drupal_goto( CLOUD_CLUSTER_PATH . '/describe/servers/add_server/' . $cloud_name . '/' . $cluster_id ) ;

        return ;
      }
    }
    else {

      drupal_set_message( t('There was an error while creating Cluster' )  );
    }
    
    drupal_goto( CLOUD_CLUSTER_PATH ) ;
  }

  return;
}


/**
 * Display Cluster details information
 *
 * @param $page_submit
 * @param $cluster_id
 *          Cluster Id which information is to be displayed
 * @return
 */
function cloud_cluster_display_detail_info($page_submit='' , $cluster_id='' ) {

  if (empty($cluster_id) || strlen($cluster_id) == 0  )  {

    drupal_goto( CLOUD_CLUSTER_PATH  ) ;

    return;
  }

  $query      = _cloud_cluster_get_cluster_by_id_query() ;
  $query_args = array(
    $cluster_id,
  ) ;
  
  $result = db_query( $query, $query_args );
  $count  = 0 ;

  $filter_params = array(
    'filter_state' => 'all',
  );

  $all_instances_list = cloud_get_all_instances_list($filter_params) ;

  $form = array() ;
  $form['fieldset_cluster_info'] = array('#type' => 'fieldset', '#title' => t('Details'));
  $form['cluster_info_header'  ] = array(
    '#prefix' => '<h2>',
    '#value'  => t('Cluster Info'),
    '#suffix' => '</h2>',
  );

  $txt_disabled = '' ;
  if (user_access('update cluster') === FALSE ) {

      $txt_disabled = TRUE ;
  }

  while ($key = db_fetch_object($result)) {

    $form['nickname_details'   ]['nickname_label'   ] = array('#type' => 'item', '#title' => t('Nickname')                       ) ;
    $form['nickname_details'   ]['nickname_text'    ] = array('#type' => 'textfield', '#default_value' => $key->cluster_nickname , '#disabled' => $txt_disabled ) ;

    $form['Description_details']['Description_label'] = array('#type' => 'item', '#title' => t('Description')                    ) ;
    $form['Description_details']['description_text' ] = array('#type' => 'textarea', '#default_value' => $key->description       , '#disabled' => $txt_disabled ) ;

    $form['Creator_details'    ]['creator_label'    ] = array('#type' => 'item', '#title' => t('Creator')                        ) ;
    $form['Creator_details'    ]['creator_text'     ] = array( array('#value' => t( $key->creator)                             ) ) ;

    $servers_count = _cloud_cluster_get_servers_count($key->cluster_id , $all_instances_list) ;
    $form['Servers_details'    ]['servers_label'    ] = array('#type' => 'item', '#title' => t('Servers')                        ) ;
    $form['Servers_details'    ]['servers_text'     ] = array( array('#value' => t( $servers_count)                            ) ) ;

    $run_count = _cloud_cluster_get_running_instance_count($key->cluster_id , '' , $all_instances_list) ;
    $form['Running_details'    ]['running_label'    ] = array('#type' => 'item', '#title' => t('Running')                        ) ;
    $form['Running_details'    ]['running_text'     ] = array( array('#value' => t( $run_count)                                ) ) ;
    
    $form['cluster_id'] = array( '#type' => 'hidden', '#value' => $key->cluster_id                                               ) ;
    
    $form['submit_buttons'] = array(
      '#prefix' => '<span class="clear"></span><div class="container-inline"><div class="buttons">',
      '#type'   => 'fieldset',
      '#suffix' => '</div></div>',
    );
    
    if (user_access('update cluster') ) {

      // Update button
      $form['submit_buttons']['Update'] = array( '#type' => 'submit', '#value' => t('Update') );
      $confirm_msg = cloud_get_messagebox('Are you sure you want to delete the Cluster?') ;
      $form['submit_buttons']['Delete'] = array( '#type' => 'submit', '#value' => t('Delete') , '#attributes' => array('onclick' => $confirm_msg ) );
    }

    $form['submit_buttons']['List Clusters'] = array( '#type' => 'submit', '#value' => t('List Clusters') );

    $count++ ;

    break ;
  }

  if ( $count == 0 ) {

    drupal_goto( CLOUD_CLUSTER_PATH ) ;

    return ;
  }

  return $form ;
}


function theme_cloud_cluster_display_detail_info($form) {

  $rows = array(
    array(
      drupal_render($form['nickname_details'   ]['nickname_label'   ] ),
      drupal_render($form['nickname_details'   ]['nickname_text'    ] ),
    ),
    array(
      drupal_render($form['Description_details']['Description_label'] ),
      drupal_render($form['Description_details']['description_text' ] ),
    ),
    array(
      drupal_render($form['Creator_details'    ]['creator_label'    ] ),
      drupal_render($form['Creator_details'    ]['creator_text'     ] ),
    ),
    array(
      drupal_render($form['Servers_details'    ]['servers_label'    ] ),
      drupal_render($form['Servers_details'    ]['servers_text'     ] ),
    ),
    array(
      drupal_render($form['Running_details'    ]['running_label'    ] ),
      drupal_render($form['Running_details'    ]['running_text'     ] ),
    ),
    array(
      drupal_render($form['options']),
    ),
  ); 

  $table = theme('table', NULL, $rows );
  $form['fieldset_cluster_info']['#children'] = $table;

//cf. Potential problem: when FAPI element '#type' is set to 'markup' (default), '#value' only accepts filtered text, be sure to use check_plain(), filter_xss() or similar to ensure your $variable is fully sanitized.
//$form['fieldset_cluster_info']['list'] = array('#type' => 'markup', '#value' => $table);
  
  $output  = drupal_render($form['cluster_info_header'] ) ;
  $output .= drupal_render($form['submit_buttons'     ] ) ;
  $output .= drupal_render($form['cluster_id'         ] ) ;
  $output .= drupal_render($form['fieldset_cluster_info']);
  $output .= drupal_render($form);
  
  return $output;
}


function cloud_cluster_display_detail_info_validate($form_id, $form_values) {

  $form_values = $form_values['values'];
  if ( $form_values['op'] == t('Update') )  {

    if ( empty( $form_values['nickname_text']) == TRUE) {

      form_set_error('', t('Please enter Nickname'));

      return ;
    }
    else {

      $query      = _cloud_cluster_get_cluster_by_filter_query();
      $query_args = array(
        'cluster_nickname',
        $form_values['nickname_text'],
      );

      $result = db_query( $query, $query_args );
      $t_count = is_object( $result ) ? $result->num_rows : 0 ;
      
      if ($t_count > 0) {

        $db_obj     = db_fetch_object($result);
        $cluster_id = $db_obj->cluster_id;

        if ($cluster_id!=$form_values['cluster_id']) {
          form_set_error('',  t('Name is already used by a Cluster.'));
        }
      }
    }
  }
}


function cloud_cluster_display_detail_info_submit($form_id, $form_values) {

  $form_values = $form_values['values'];
  
  if ( $form_values['op'] == t('List Clusters') ) {

    drupal_goto( CLOUD_CLUSTER_PATH ) ;
  }
  elseif ($form_values['op'] == t('Update')) {

    $cluster_id = $form_values['cluster_id'] ;
    _cloud_cluster_update_cluster_db($form_values , $cluster_id ) ;
    drupal_set_message(t('Cluster has been updated.'));

    drupal_goto(CLOUD_CLUSTER_PATH . '/describe/info/' . $cluster_id) ;
  }
  elseif ($form_values['op'] == t('Delete')) {

    $cluster_id = $form_values['cluster_id'] ;
    _cloud_cluster_delete_cluster($form_values , $cluster_id) ;

    drupal_goto(CLOUD_CLUSTER_PATH) ;
  }

  return;
}


function _cloud_cluster_stop_all_servers($cluster_id, $action, $all_instances_list=array()) {

    $run_count = _cloud_cluster_get_running_instance_count($cluster_id, '' , $all_instances_list) ;
    if ( $run_count < 1 ) {

      return NULL ; //No instances running. No action to be taken
    }
    
    if (empty($all_instances_list)) {

      $filter_params = array() ;
      $filter_params['filter_state'] = 'all' ;
      $all_instances_list = cloud_get_all_instances_list($filter_params) ;
    }

    $query      = _cloud_cluster_servers_get_query() ;
    $query_args = array(
                    $cluster_id,
                  ) ;
    
    $running_instance_count = 0 ;

    $result     = db_query( $query, $query_args );
    while ($key = db_fetch_object($result)) {

      $instance_ids_str = $key->instance_id ;
      if (empty($instance_ids_str)) {

          continue ;
      }

      $instance_ids = explode( ',' , $instance_ids_str );
      foreach ($instance_ids as $instance_id) {

        $instance_id = trim($instance_id) ;
        if (isset($all_instances_list[$instance_id])) {

          if (    isset($all_instances_list[$instance_id]['state'])
          && drupal_strtolower($all_instances_list[$instance_id]['state']) !== 'terminated'
          && drupal_strtolower($all_instances_list[$instance_id]['state']) !== 'halted'
          && drupal_strtolower($all_instances_list[$instance_id]['state']) !== 'stopped'
          && drupal_strtolower($all_instances_list[$instance_id]['state']) !== 'shutting-down') {

            if ($action == 'stop_all' ) {

              $result_terminate = cloud_perform_action( '', 'terminate' , $all_instances_list[$instance_id]['cloud_context'] , array($instance_id) ) ;
            }
            elseif ($action == 'count_running' ) {

              $running_instance_count++ ;
            }
          }
        }
      }
    }

    return $running_instance_count ;
}


function _cloud_cluster_get_servers_count($cluster_id, $all_instances_list=array()) {

  $servers_count = 0 ;
  $run_count  = _cloud_cluster_get_running_instance_count($cluster_id, '', $all_instances_list) ;
  $query      = _cloud_cluster_templates_get_query() ;
  $query_args = array(
                      $cluster_id,
                    ) ;

  $result     = db_query( $query, $query_args );

  if ( $run_count < 1 ) { // No servers running

    while ($clust = db_fetch_object($result)) { // Cluster server object

      $servers_count += $clust->count_instances ;
    }
  }
  else { // Servers running : Count the number of instances present

    while ($clust = db_fetch_object($result)) { // Cluster server object

      $instance_ids_str =  $clust->instance_id ;
      $instance_ids     =  explode( ',' , $instance_ids_str) ;
      $servers_count +=  sizeof($instance_ids) ;
    }
  }

  return $servers_count ;
}

function _cloud_cluster_get_servers_count_by_id($cluster_id, $server_id, $all_instances_list=array()) {

  $servers_count = 0 ;
  $run_count  = _cloud_cluster_get_running_instance_count($cluster_id, '', $all_instances_list) ;
  $query      = _cloud_cluster_templates_server_get_query() ;
  $query_args = array(
                      $cluster_id,
                      $server_id
                    ) ;

  $result     = db_query( $query, $query_args );

  if ( $run_count < 1 ) { // No servers running

    while ($clust = db_fetch_object($result)) { // Cluster server object
    
      $servers_count += $clust->count_instances ;
    }
  }
  else { // Servers running : Count the number of instances present

    while ($clust = db_fetch_object($result)) { // Cluster server object
    
      $instance_ids_str =  $clust->instance_id ;
      $instance_ids     =  explode( ',' , $instance_ids_str) ;
      $servers_count +=  sizeof($instance_ids) ;
    }
  }

  return $servers_count ;
}


function _cloud_cluster_get_running_instance_count($cluster_id, $server_id='', $all_instances_list=array()) {

  $filter_params = array() ;
  $filter_params['filter_state'] = 'all' ;
  if (empty($all_instances_list)) {
  
    $all_instances_list = cloud_get_all_instances_list($filter_params) ;
  }

  $query  = '' ;
  $query_args = array() ;
  
  if ( empty($server_id) ) {
    $query      = _cloud_cluster_servers_get_query() ;
    $query_args = array(
        $cluster_id,
    ) ;
  }
  else {

    $query      = _cloud_cluster_server_get_query() ;
    $query_args = array(
        $cluster_id,
        $server_id
    ) ;
  }

  $running_instance_count = 0 ;

  $result     = db_query( $query, $query_args );
  while ($key = db_fetch_object($result)) {

    $instance_ids_str = $key->instance_id ;
    if (empty($instance_ids_str)) {

        continue ;
    }

    $instance_ids = explode( ',' , $instance_ids_str );
    foreach ($instance_ids as $instance_id) {

      $instance_id = trim($instance_id) ;
      if (isset($all_instances_list[$instance_id])) {

        if (    isset($all_instances_list[$instance_id]['state'])
        && drupal_strtolower($all_instances_list[$instance_id]['state']) !== 'terminated'
        && drupal_strtolower($all_instances_list[$instance_id]['state']) !== 'halted'
        && drupal_strtolower($all_instances_list[$instance_id]['state']) !== 'stopped'   ) {

          $running_instance_count++ ;
        }
      }
    }
  }

  return $running_instance_count ;
}


/**
 * Display List of Templates present in a cluster
 *
 * @param $page_submit
 * @param $cluster_id
 *              Cluster ID who's server's are to be displayed
 * @return
 */
function cloud_cluster_display_templates_list( $page_submit='' , $cluster_id='' ) {
  $base = cloud_get_module_base() ;
  drupal_add_js(cloud_get_module_base() . 'js/cloud.js', 'module');
  drupal_add_js(cloud_get_module_base() . 'js/json2.js', 'module');
  
  if (empty($cluster_id) )  {

    drupal_goto( CLOUD_CLUSTER_PATH ) ;
    return;
  }

  $filter_params = array() ;
  $filter_params['filter_state'] = 'all' ;
  $all_instances_list = cloud_get_all_instances_list($filter_params) ;
  $run_count = _cloud_cluster_get_running_instance_count($cluster_id , '' , $all_instances_list) ;

  $form['submit_buttons'] = array(
    '#type'   => 'fieldset',
    '#prefix' => '<span class="clear"></span><div class="container-inline"><div class="buttons">',
    '#suffix' => '</div></div>',
  );

  if (user_access('update cluster')  ) {

    if ( $run_count < 1) {

      $tmpl_active_count = _cloud_server_templates_get_active_template_count_by_cloud() ;
      if (isset($tmpl_active_count) && count($tmpl_active_count) > 0 ) {
      
        $form['submit_buttons']['add_server'] = array( '#type' => 'submit', '#value' => t('Add Server') );
      }
      else {

        $form['submit_buttons']['add_server'] = array( '#type' => 'submit', '#value' => t('Add Server') , '#disabled' => TRUE );
        $template_url = filter_xss( l( t('Design - Template'), 'design/server_templates' ) );
        drupal_set_message(check_plain(t('There are no Templates > ', array())) . $template_url );
      }

      $count_servers = _cloud_cluster_servers_get_count_db($cluster_id) ;

      if ($count_servers > 0 ) {

        $form['submit_buttons']['start_all_servers']  = array( '#type' => 'submit', '#value' => t('Start All Servers') );
        // Delete all templates
        $confirm_msg = cloud_get_messagebox('Are you sure you want to delete all the templates ?') ;
        $onclick = $confirm_msg;
        $form['submit_buttons']['delete_all_servers'] = array( '#type' => 'submit', '#value' => t('Delete All Servers') , '#attributes' => array('onclick' => $onclick ) );
      }
      else {

        $form['submit_buttons']['start_all_servers' ] = array( '#type' => 'submit', '#value' => t('Start All Servers' ) , '#disabled' => TRUE );
        $form['submit_buttons']['delete_all_servers'] = array( '#type' => 'submit', '#value' => t('Delete All Servers') , '#disabled' => TRUE );
      }
    }
    else {

      $form['submit_buttons']['add_server']         = array( '#type' => 'submit', '#value' => t('Add Server') , '#disabled' => TRUE  );
      $form['submit_buttons']['start_all_servers']  = array( '#type' => 'submit', '#value' => t('Start All Servers' ) , '#disabled' => TRUE );
      $form['submit_buttons']['delete_all_servers'] = array( '#type' => 'submit', '#value' => t('Delete All Servers') , '#disabled' => TRUE );
    }
  }
  else {

    $form['submit_buttons']                         = array( '#type' => 'item', '#value' => t('') );
    /*$form['submit_buttons']['add_server']         = array( '#type' => 'item', '#value' => t('') );
    $form['submit_buttons']['start_all_servers']    = array( '#type' => 'item', '#value' => t('') );
    $form['submit_buttons']['delete_all_servers']   = array( '#type' => 'item', '#value' => t('') );
    */
  }

  $query      = _cloud_cluster_templates_get_query() ;
  $query_args = array(
    $cluster_id,
  ) ;

//$form['fieldset_cluster_design'] = array('#type' => 'fieldset', '#title' => 'Template List');
  
  $form['server_header'] = array(
    '#prefix' =>  '<h2>',
    '#value'  => t('Cluster Servers'),
    '#suffix' =>  '</h2>',
  );

  $form['header'] = array(
    '#type' => 'value',
    '#value' => array(
      array('data' => t('Nickname'       ) , 'field' => 'server_nickname'
                                           , 'class' => 'nickname-column'   ) ,
      array('data' => t('Cloud'          ) , 'field' => 'cloud_type'        ) ,
      array('data' => t('Template'       ) , 'field' => 'template_nickname' ) ,
      array('data' => t('Servers'        )                                  ) ,
      array('data' => t('Running'        )                                  ) ,
    )
  );

  $cloud_name_list = cloud_get_all_clouds_display_name();
  $server_list = array() ;
  
  $query .= tablesort_sql( $form['header']['#value'] ) ; 
  $result     = db_query( $query, $query_args );

  while ($clust = db_fetch_object($result)) { // Cluster server object

    $server_id =  $clust->server_id ;

    $server_list[$server_id]['server_id'          ] = $server_id ;
    $server_list[$server_id]['server_name'        ] = $clust->server_nickname ;
    $server_list[$server_id]['server_template_id' ] = $clust->template_id ;
    $server_list[$server_id]['server_template'    ] = $clust->template_nickname ;
    $server_list[$server_id]['cloud_context'      ] = $clust->cloud_type ;
    $server_list[$server_id]['cloud_context_name' ] = isset( $cloud_name_list[$clust->cloud_type] ) ? $cloud_name_list[$clust->cloud_type] : $clust->cloud_type ;
    $server_list[$server_id]['servers'            ] = _cloud_cluster_get_servers_count_by_id($cluster_id, $server_id, $all_instances_list=array()) ;
    $server_list[$server_id]['running'            ] = _cloud_cluster_get_running_instance_count($cluster_id , $server_id , $all_instances_list) ; ;
  }

  foreach ( $server_list as $cluster_server ) {

    $server_id       = $cluster_server['server_id'         ] ;
    $cloud_context   = $cluster_server['cloud_context'     ] ;

    $form['server_name'    ][$server_id] = array( array(
        '#prefix' => '<span class=\'anchor\'>' ,
        '#value' => t( $cluster_server['server_name'] ) ,
        '#suffix' => '</span>'
      )
    );
    $form['hdnName'        ][$server_id] = array( '#type' => 'hidden', '#value' => t( $cluster_server['server_name'] ) );
    $form['Cloud_type'     ][$server_id] = array( array('#value' => t( $cluster_server['cloud_context_name'] ) ) );
    $form['server_template'][$server_id] = array( array('#value' => l( $cluster_server['server_template'] ,
                                                                       'design/server_templates/' . $cloud_context  . '/' . $cluster_server['server_template_id'] . '/view' ,
                                                                        array('query' => 'id=' . urlencode($cluster_server['server_template_id'] )) ) ) );
    $form['server_id'      ][$server_id] = array( array('#type' => 'hidden', '#value' => t( $server_id) ) );
    $form['servers'        ][$server_id] = array( array('#value' => t( $cluster_server['servers'] ) ) );
    $form['running'        ][$server_id] = array( array('#value' => t( $cluster_server['running'] ) ) );
    $form['cloud_context'  ][$server_id] = array( array('#type' => 'value', '#value' => $cloud_context));
    $form['server_template_id'][$server_id] = array(array('#type' => 'value', '#value' => $cluster_server['server_template_id']));
  }
  
  $form['cluster_id'] = array( '#type' => 'hidden', '#value' => t( $cluster_id ) ) ;

  /*
  if ( module_exists('cloud_inputs') && user_access('update cluster')) {

    $location = check_url(url('design/inputs')) . '&cluster_id=' . $cluster_id .'&module=cluster';
    $action   = "document.forms[0].action='" . $location . "';";
    $onclick  = $action;
    $form['submit_buttons']['Inputs'] = array(
      '#type'       => 'submit',
      '#value'      => t('Inputs')
    );
  }*/

  return $form ;
}


function theme_cloud_cluster_display_templates_list($form) {

  $output  = drupal_render($form['server_header'     ]);
  $output .= drupal_render($form['submit_buttons']);
  
  $cluster_id = $form['cluster_id']['#value'] ;

  $rows = array() ;

  $run_count = _cloud_cluster_get_running_instance_count($cluster_id) ;
  if (isset($form['server_name']) )  {

    foreach (element_children($form['server_name']) as $deplkey) {

      $prop_delete = array() ;
      $prop_delete['onclick'] = cloud_get_messagebox('Are you sure you want to delete the template "' . $form['hdnName'][$deplkey]['#value'] . '" ?') ;

      $row = array(array('data' =>
        drupal_render($form['server_name'    ][$deplkey]), 'class' => 'nickname-column'),
        drupal_render($form['Cloud_type'     ][$deplkey]),
        drupal_render($form['server_template'][$deplkey]),
        drupal_render($form['servers'        ][$deplkey]),
        drupal_render($form['running'        ][$deplkey]),
      );

      $action_data = '' ;
      $server_id   = $form['server_id'][$deplkey][0]['#value'] ;

      if (user_access('delete cluster')
      && $run_count == 0 ) {

        $action_data .= cloud_display_action(
          'images/icon_delete',
          t('Delete'),
          CLOUD_CLUSTER_PATH . '/describe/servers/delete_server/' . $cluster_id . '/' . $server_id ,
          array('query' => 'server_id=' . urlencode($server_id), 'html' => TRUE),
          $prop_delete['onclick']);
      }
      
      if (user_access('edit server template') && module_exists('cloud_inputs') && $run_count == 0) {  
        $destination = 'destination=design/cluster/describe/cluster_templates/' . $cluster_id;
        $action_data .= cloud_display_action( 'images/table_gear', t('Inputs'), 'design/cloud_cluster_template/' . $cluster_id . '/inputs', array('query' => $destination . '&template_id=' . $form['server_template_id'][$deplkey][0]['#value'] . '&module=cluster&type=' . $form['cloud_context'][$deplkey][0]['#value'] . '&server_id=' . $form['server_id'][$deplkey][0]['#value'], 'html' => TRUE));//,  'template_id=' . urlencode($key) . '&module=server_templates&type=' . $form['cloud_type'][$key][0]['#value']);
        
        unset($form['cloud_context'][$deplkey]);
        unset($form['server_template_id'][$deplkey]);
      } 

      $row[]  = array('data' => $action_data, 'class' => 'action-column' );
      $rows[] = $row;
    }
  }

/*
  $table = theme('table', $form['header']['#value'], $rows );
  $form['fieldset_cluster_design']['#children'] = $table;

//cf. Waning by Coder module: Potential problem: when FAPI element '#type' is set to 'markup' (default), '#value' only accepts filtered text, be sure to use check_plain(), filter_xss() or similar to ensure your $variable is fully sanitized.
//$form['fieldset_cluster_design']['list'] = array('#type' => 'markup', '#value' => $table);
  
  $output .= drupal_render($form['fieldset_cluster_design']);
*/
  $output .= theme('table', $form['header']['#value'], $rows );
  $output .= drupal_render($form['cluster_id'] );
  $output .= drupal_render($form);

  return $output ;
}


function cloud_cluster_display_templates_list_submit($form_id, $form_values) {

  $form_values = $form_values['values'];

  // Check for the operation
  if ($form_values['op'] !== t('Stop All Servers')) {

    // Check if Instances already running then do nothing return
    $run_count = _cloud_cluster_get_running_instance_count($form_values['cluster_id']) ;
    if ( $run_count > 0 ) {

      drupal_set_message( check_plain( t( 'Cannot perform operation @operation . Instances are running.' , array('@operation' => $form_values['op'] ) ) ) , 'error' ) ;
      drupal_goto(CLOUD_CLUSTER_PATH . '/describe/cluster_templates/' . $form_values['cluster_id'] ) ;
      return ;
    }
  }

  if ( $form_values['op'] == t('Add Server') ) {

    $enabled_cloud_list = cloud_get_clouds() ;
    $tmpl_active_count  = _cloud_server_templates_get_active_template_count_by_cloud() ;
    for ($row_counter   = 0; $row_counter < count($enabled_cloud_list); $row_counter++) {

      $cloud_name = $enabled_cloud_list[$row_counter]["cloud_name"] ;
      if (isset($tmpl_active_count) == FALSE || isset($tmpl_active_count[$cloud_name]) == FALSE )  {

        // No templates repsent
        continue ;
      }
      // Goto the first cloud in the list
      
      drupal_goto( CLOUD_CLUSTER_PATH . '/describe/servers/add_server/' . $cloud_name . '/' . $form_values['cluster_id'] ) ;

      return ;
    }

    // No Cloud found
    drupal_set_message( t( 'There is no enabled cloud. First enable a Cloud and then try adding a template' ) , 'warning' ) ;
    drupal_goto( CLOUD_CLUSTER_PATH . '/describe/servers/' . $form_values['cluster_id'] ) ;
  }
  elseif ( $form_values['op'] == t('Start All Servers')) {

    drupal_goto( CLOUD_CLUSTER_PATH . '/describe/servers/start_all_servers/' . $form_values['cluster_id'] ) ;
  }
  elseif ( $form_values['op'] == t('Delete All Servers')) {

    $run_count = _cloud_cluster_get_running_instance_count($form_values['cluster_id']) ;
       
    if ($run_count > 0 )  {
    
      drupal_set_message(t('Unable to delete. Instances running') , 'error');
      drupal_goto(CLOUD_CLUSTER_PATH . '/describe/cluster_templates/' . $form_values['cluster_id'] ) ;
      return ;
    }
    else {
    
      _cloud_cluster_delete_all_server_db($form_values['cluster_id']) ;
      drupal_set_message(t('Templates deleted') );
      drupal_goto(CLOUD_CLUSTER_PATH . '/describe/cluster_templates/' . $form_values['cluster_id'] ) ;

      return ;
    }
  }
  elseif ( $form_values['op'] == t('Inputs')) {

    drupal_goto( CLOUD_CLUSTER_PATH . '/' . $form_values['cluster_id'] .  '/inputs') ;
    return ;
  }

  return;
}


/**
 * Display List of server's present in a cluster
 * 
 * @param $page_submit
 * @param $cluster_id
 *              Cluster ID who's server's are to be displayed
 * @return
 */
function cloud_cluster_display_server_list( $page_submit='' , $cluster_id='' ) {

  drupal_add_js(cloud_get_module_base() . 'js/cloud.js'                                   , 'module');
  drupal_add_js(cloud_get_module_base() . 'js/json2.js'                                   , 'module');
  drupal_add_js(cloud_get_module_base() . 'js/cloud_cluster_auto_refresh_list_servers.js' , 'module');

  if (empty($cluster_id) )  {
      
    drupal_goto( CLOUD_CLUSTER_PATH ) ;
    return;
  }

  $form = array() ;
  
  $query      = _cloud_cluster_servers_get_query() ;
  $query_args = array(
    $cluster_id,
  ) ;
  
  $result = db_query( $query, $query_args );
  
  $filter_params = array() ;
  $filter_params['filter_state'] = 'all' ;
  $all_instances_list = cloud_get_all_instances_list($filter_params) ; 

//$form['fieldset_cluster_instances'] = array('#type' => 'fieldset', '#title' => t('Instances'));
  $form['server_header'] = array(
    '#prefix' => '<h2>',
    '#value'  => t('Cluster Instances'),
    '#suffix' => '</h2>',
  );
  
  $form['header'] = array(

    '#type' => 'value',
    '#value' => array(
      array('data' => t('Nickname'      ) , 'field' => 'server_name'         ,
                                            'class' => 'nickname-column'   ) ,
      array('data' => t('Instance name' ) , 'field' => 'instance_nickname' ) ,
      array('data' => t('Cloud'         ) , 'field' => 'cloud_context'     ) ,
      array('data' => t('Zone'          ) , 'field' => 'zone'              ) ,
      array('data' => t('Hostname'      ) , 'field' => 'host_name'         ) ,
      array('data' => t('ID'            ) , 'field' => 'instance_id'       ) ,
      array('data' => t('Template'      ) , 'field' => 'server_template'   ) ,
      array('data' => t('State'         ) , 'field' => 'state'             ) ,
      array('data' => t('Runtime'       ) , 'field' => 'runtime'           ) ,
      array('data' => t('Action'        ) , 'class' => 'action-column'     ) ,
    )
  );
  
  $form['submit_buttons'] = array(
    '#type'   => 'fieldset',
    '#prefix' => '<span class="clear"></span><div class="container-inline"><div class="buttons">',
    '#suffix' => '</div></div>',
  );
  
  if (  _cloud_cluster_stop_all_servers($cluster_id, 'count_running' , $all_instances_list) > 0  ) {

    $confirm_msg = cloud_get_messagebox('Are you sure you want to stop all the servers ?') ;
    $onclick = $confirm_msg;
    $form['submit_buttons']['stop_all_servers'] = array( '#type' => 'submit', '#value' => t('Stop All Servers') , '#attributes' => array('onclick' => $onclick ) );
  }
  else {

    $form['submit_buttons']['stop_all_servers'] = array( '#type' => 'submit', '#value' => t('Stop All Servers') , '#disabled' => TRUE  );
  }
  
  $destination = drupal_get_destination();
  $count = 0 ;
  $failover_status = array();
  $cloud_name_list = cloud_get_all_clouds_display_name();
  $server_list     = array() ;

  $run_count = _cloud_cluster_get_running_instance_count($cluster_id) ;
  
  while ($clust = db_fetch_object($result)) { // Cluster server object

    if ($run_count == 0) {

      break ; // No instances running
    }

    $inst_count = 0 ;
    $inst_found = TRUE ;
    $instance_ids = array(0) ; // Dummy array
    $instance_ids_str = $clust->instance_id ;
    if ( empty($instance_ids_str) ) {

      $inst_found = FALSE ;
    }
    else {

      $instance_ids = explode( ',' , $instance_ids_str ) ;
    }

    foreach ($instance_ids as $instance_id ) {

      $inst_count++ ;
      $server_id = $clust->server_id ;
      $index_id  = $clust->server_id . '_' . $instance_id ;
      
      $server_list[$index_id]['index_id'           ] = $index_id ;
      $server_list[$index_id]['server_id'          ] = $server_id ;
      $server_list[$index_id]['server_name'        ] = $clust->server_nickname ;
      
      if ( $inst_found
      &&   count($instance_ids) > 1 ) {
      
        $server_list[$index_id]['server_name'        ] .= ' #' . $inst_count ; // Append #1, #2...
      }
      
      $tmpl = cloud_get_server_template_info($clust->template_id) ;
      $server_list[$index_id]['server_template_id' ] = $clust->template_id ;
      $server_list[$index_id]['server_template'    ] = $tmpl->template_nickname ;
      $server_list[$index_id]['cloud_context'      ] = $tmpl->cloud_type ;
      $server_list[$index_id]['cloud_context_name' ] = isset( $cloud_name_list[$tmpl->cloud_type] )  ? $cloud_name_list[$tmpl->cloud_type] : $tmpl->cloud_type ;
      
      
      if ( empty($instance_id) === FALSE
      && isset($all_instances_list[$instance_id]) ) {
      
        $instance_info = $all_instances_list[$instance_id] ;
      
        $server_list[$index_id]['instance_nickname' ] = trim($instance_info['name']) ;
        $server_list[$index_id]['host_name'         ] = $instance_info['hostname'];
        $server_list[$index_id]['instance_id'       ] = $instance_id ;
        $server_list[$index_id]['state'             ] = ucwords($instance_info['state']);
        $server_list[$index_id]['zone'              ] = $instance_info['zone'];
        $server_list[$index_id]['runtime'           ] = $instance_info['runtime'];
        $server_list[$index_id]['lock_status'       ] = $instance_info['lock_status'];
      }
      else {
      
        $server_list[$index_id]['instance_nickname' ] = '' ;
        $server_list[$index_id]['host_name'         ] = '' ;
        $server_list[$index_id]['instance_id'       ] = '' ;
        $server_list[$index_id]['state'             ] = '' ;
        $server_list[$index_id]['zone'              ] = '' ;
        $server_list[$index_id]['runtime'           ] = '' ;
        $server_list[$index_id]['lock_status'       ] = '' ;
      }
      
      if ( empty($instance_id) === FALSE ) {
      
        $server_list[$index_id]['instance_id'       ] = $instance_id ;
      }
        
    } // End of foreach ($instance_ids as $instance_id ) {
  } // End of while

  $ts = tablesort_init( $form['header']['#value'] );
  if ($ts['sql']) {

    $field =  $ts['sql'] ;
    $server_list = _cloud_sort_by_value( $server_list , $field , $ts['sort'] ) ;
  }
    
  foreach ( $server_list as $cluster_server ) {

    $index_id      = $cluster_server['index_id'          ] ;
    $server_id     = $cluster_server['server_id'         ] ;
    $cloud_context = $cluster_server['cloud_context'     ] ;
    $name          = $cluster_server['instance_nickname' ] ;
    $state         = $cluster_server['state'             ] ;
    $hostname      = $cluster_server['host_name'         ] ;
    $zone          = $cluster_server['zone'              ] ;
    $runtime       = $cluster_server['runtime'           ] ;
    $lock_status   = $cluster_server['lock_status'       ] ;
    $instance_id   = $cluster_server['instance_id'       ] ;
    
    $cloud_menu_path = cloud_get_menu_path($cloud_context) ;

    $form['server_name'    ][$index_id] = array( array(
        '#prefix' => '<span class=\'anchor\'>' ,
        '#value'  => t( $cluster_server['server_name'] ) ,
        '#suffix' => '</span>'
      )
    );
    $form['hdnName'        ][$index_id] = array( '#type' => 'hidden', '#value' => t( $cluster_server['server_name'] ) );

    if ( !empty($state)
    && drupal_strtolower($state) == 'running' ) {

      $form['instance_nickname'][$index_id] = array(
        array(
          '#value' => l($name,
                          $cloud_menu_path . '/instances/describe/' . $instance_id . '/info',
                          array(
                            'query' => 'instance_id=' . urlencode($instance_id)))
                                                      . (($lock_status == 'Lock')
                                                      ? '<a class=lockIcon title=Lock>&nbsp;&nbsp;&nbsp;&nbsp;</a>'
                                                      : ''
                        ) // end 'l' function
        ) // end array
      ); // end $form
    }
    else {

      $form['instance_nickname'][$index_id] = array( array('#value' => $name ) );
    }

    $public_dns = substr( $hostname, 0, strpos($hostname,  '.') ) ;
    if ( strlen($public_dns) > 3 ) { // truncate only in case the name is long

      $public_dns = substr($hostname, 0, strpos($hostname,  '.')) . '...' ;
    }
    else {

      $public_dns = $hostname ;
    }

    $form['Cloud_type'     ][$index_id] = array( array('#value' => t( $cluster_server['cloud_context_name'] ) ) );
    $form['Zone'           ][$index_id] = array( array('#value' => t( $zone           ) ) );
    $form['Public_ip'      ][$index_id] = array( array('#value' => l($public_dns,
                                                                  'http://' . $hostname, array('attributes' => array('target' => '_blank'),
                                                                  'query' => ''   ) ) ) );
 // $form['Public_ip'      ][$server_id] = array( array('#value' => t( $hostname       ) ) );
    $form['Instanceid'     ][$index_id] = array( array('#value' => t( $instance_id    ) ) );
    $form['server_template'][$index_id] = array( array('#value' => l( $cluster_server['server_template'] ,  'design/server_templates/' . $cloud_context  . '/' . $cluster_server['server_template_id'] . '/view' , array('query' => 'id=' . urlencode($cluster_server['server_template_id'] )) ) ) );
    $form['State'          ][$index_id] = array( array('#value' => t( ucwords($state) ) ) );
    $form['Runtime'        ][$index_id] = array( array('#value' => t( ($runtime)
                                                                 ? cloud_get_runtime($runtime)
                                                                 : ''
                                                                 ) ) );
    $form['server_id'   ][$index_id] = array( array('#type' => 'hidden', '#value' => t( $server_id) ) );
  }
  
  $form['cluster_id']   = array( '#type' => 'hidden', '#value' => t( $cluster_id ) ) ;
  
  return $form ;
}


function theme_cloud_cluster_display_server_list($form) {

  $output  = drupal_render($form['server_header'     ]);
  $output .= drupal_render($form['submit_buttons']);
  
  $cluster_id = $form['cluster_id']['#value'] ;
  
  $filter_params = array() ;
  $filter_params['filter_state'] = 'all' ;
  $all_instances_list = cloud_get_all_instances_list($filter_params) ; 

  $rows = array() ;

  if (isset($form['server_name']) )  {
  
    foreach (element_children($form['server_name']) as $deplkey) {
  
      $prop_delete = array() ;
      $prop_delete['onclick'] = cloud_get_messagebox('Are you sure you want to delete the server "' . $form['hdnName'][$deplkey]['#value'] . '" ?') ;
  
      $row = array(array('data' =>
        drupal_render($form['server_name'       ][$deplkey]), 'class' => 'nickname-column'),
        drupal_render($form['instance_nickname' ][$deplkey]),
        drupal_render($form['Cloud_type'        ][$deplkey]),
        drupal_render($form['Zone'              ][$deplkey]),
        drupal_render($form['Public_ip'         ][$deplkey]),
        drupal_render($form['Instanceid'        ][$deplkey]),
        drupal_render($form['server_template'   ][$deplkey]),
        drupal_render($form['State'             ][$deplkey]),
        drupal_render($form['Runtime'           ][$deplkey]),
      );
  
      $action_data = '' ;
      $server_id   = $form['server_id'][$deplkey][0]['#value'] ;
      
      if (empty($form['Instanceid'][$deplkey][0]['#value'])
      ||  drupal_strtolower( $form['State'     ][$deplkey][0]['#value']) == 'terminated'
      ||  drupal_strtolower( $form['State'     ][$deplkey][0]['#value']) == 'stopped'
      ||  empty( $form['State'][$deplkey][0]['#value'])) {
        
        if (user_access('update cluster') ) {
            
          $action_data .= cloud_display_action(
            'images/icon_play',
            'Launch',
            CLOUD_CLUSTER_PATH . '/describe/servers/launch_server/' . $cluster_id . '/' . $server_id ,
            array( 'query' => 'instance_id=' . $form['Instanceid'][$deplkey][0]['#value'] )
          );
        }
  
        // Do not delete servers from here. Delete from Templates
        /*if (user_access('delete cluster')) {
          $action_data .= cloud_display_action(
            'images/icon_delete',
            t('Delete'),
            CLOUD_CLUSTER_PATH . '/describe/servers/delete_server/' . $cluster_id . '/' . $server_id ,
            array('query' => 'server_id=' . urlencode($server_id), 'html' => TRUE),
            $prop_delete['onclick']);
        }
        */
      }
      elseif (empty($form['Instanceid'][$deplkey][0]['#value']) === FALSE ) {
  
        $instance_id  = $form['Instanceid'][$deplkey][0]['#value'] ;
        if (isset($all_instances_list[$instance_id]) ) {
        
          $action_data .= $all_instances_list[$instance_id]['action_data'] ;
        }
      }
    
      $row[]  = array('data' => $action_data, 'class' => 'action-column' );
      $rows[] = $row;
    }
  }

  $table_attr = array() ;
  $table_attr['id'] = 'cluster_servers_list_table' ;
  $table_attr['autoupdate_url'] = url( CLOUD_CLUSTER_PATH . '/callback_get_cluster_servers_list' ) ;
  
/*
  $table = theme('table', $form['header']['#value'], $rows, $table_attr );
  $form['fieldset_cluster_instances']['#children'] = $table;

//cf. Waning by Coder module: Potential problem: when FAPI element '#type' is set to 'markup' (default), '#value' only accepts filtered text, be sure to use check_plain(), filter_xss() or similar to ensure your $variable is fully sanitized.
//$form['fieldset_cluster_instances']['list'] = array('#type' => 'markup', '#value' => $table);

  $output .= drupal_render($form['fieldset_cluster_instances']);
*/  
  $output .= theme('table', $form['header']['#value'], $rows, $table_attr );

  if (count($rows) > 0) {

    $reload_link = l( t( '- Refresh Page -' ), CLOUD_CLUSTER_PATH . '/get_data/' . $cluster_id  ,  array( ) );
    $ref_link    = array(
                     '#type'   => 'item',
                     '#prefix' => '<div id="link_reload" align="right">',
                     '#suffix' => '</div>',
                     '#value'  => $reload_link
               );
    
    $output .= drupal_render($ref_link);
  }
  
  $output .= drupal_render($form['cluster_id'] );
  $output .= drupal_render($form);

  return $output ;
}


function cloud_cluster_display_server_list_submit($form_id, $form_values) {

  $form_values = $form_values['values'];

  if ( $form_values['op'] == t('Stop All Servers')) {

    _cloud_cluster_stop_all_servers($form_values['cluster_id'] , 'stop_all' ) ;
    drupal_goto(CLOUD_CLUSTER_PATH . '/describe/servers/' . $form_values['cluster_id'] ) ;
    return ;
  }

  return;
}


function _cloud_cluster_get_data($cluster_id) {

  cloud_update_all_cloud_data() ;
  drupal_goto( CLOUD_CLUSTER_PATH . '/describe/servers/' . $cluster_id  ) ;

  return ;
}


function _cloud_cluster_describe() {

  drupal_goto( CLOUD_CLUSTER_PATH ) ;

  return ;
}


/**
 * Delete a server from Cluster
 *
 * @param $form_values
 * @param $cluster_id
 *              Cluster from which server is to be deleted
 * @param $server_id
 *              Server to be deleted
 * @return <type>
 */
function _cloud_cluster_delete_server($form_values, $cluster_id='', $server_id='') {

  $run_count = _cloud_cluster_get_running_instance_count($cluster_id, $server_id) ;
  
  if ($run_count > 0 )  {

    drupal_set_message(t('Cannot delete template. Instances running for this Template') , 'error');
    drupal_goto(CLOUD_CLUSTER_PATH . '/describe/cluster_templates/' . $cluster_id ) ;

    return ;
  }

  _cloud_cluster_delete_server_db($server_id) ;
  drupal_set_message(t('Template deleted from Cluster'));
  drupal_goto(CLOUD_CLUSTER_PATH . '/describe/cluster_templates/' . $cluster_id ) ;

  return;
}


/**
 * Launch a server from Cluster
 * 
 * @param $page_submit
 * @param $cluster_id
 *          Cluster from which server is to be launched
 * @param $server_id
 *          Server which is to be launched
 * @return 
 */
function _cloud_cluster_launch_server( $page_submit='' , $cluster_id='' , $server_id='' ) {

  $query = _cloud_cluster_get_server_query() ;
  $query_args = array(
    $server_id,
  ) ;

  $launch_params = array() ;
  $result        = db_query( $query, $query_args );

  $cluster_id  = FALSE ;
  $server_name = '' ;
  $template_id = '' ;

  $server_obj = NULL ;
  
  while ($depl = db_fetch_object($result)) {

    $launch_params['template_id'   ] = $depl->template_id           ;
    $launch_params['nickname'      ] = $depl->server_nickname       ;
    $launch_params['key_name'      ] = $depl->server_sshkey         ;
    $launch_params['security_group'] = $depl->server_security_group ;
    $launch_params['placement'     ] = $depl->server_zone           ;


    if ( isset($depl->instance_id)
    &&   empty($depl->instance_id) === FALSE ) {
    
      $launch_params['count_instances'] = 1 ; 
    }

    $cluster_id  = $depl->cluster_id      ;
    $server_name = $depl->server_nickname ;
    $template_id = $depl->template_id     ;
    
    $server_obj  = $depl                  ;
    $instance_id = $depl->instance_id     ;
    
  }

  if (!$cluster_id || empty($template_id) ) { // The server configuration not found or the server was deleted

    drupal_set_message(t('Server ID not found') , 'error' );
    drupal_goto(CLOUD_CLUSTER_PATH ) ;

    return ;
  }
  
  $cloud_context = _cloud_server_templates_get_cloud($template_id);

  // Launch the instance
  $result_launch = cloud_perform_action( '' , 'launch_using_params' , $cloud_context , $launch_params ) ;

  
  if ( $result_launch) { // Successfully launched the instance
    
    $new_instance_ids = isset( $_REQUEST['new_instance_ids'] ) ? $_REQUEST['new_instance_ids'] : array() ;    

    if ( isset($new_instance_ids[0]) ) 
      $new_instance_id = $new_instance_ids[0] ;
    else 
      $new_instance_id = FALSE ;

    if (empty($instance_id)) {

      $instance_id = $new_instance_id ;
    }
    else {
    
      $instance_id = str_replace( $_REQUEST['instance_id'] , $new_instance_id, $instance_id);
    }
    $update_query = _cloud_cluster_update_cluster_server_query() ;
    $query_args   = array(
      'instance_id',
      $instance_id ,
      $server_id   ,
    ) ;
    
    $result = db_query( $update_query, $query_args );

    // add corresponding records in database if no of launched instances > 1
    /*if ( isset($launch_params['count_instances']) == FALSE &&
            sizeof($new_instance_ids) > 1 ) {

      $count_launched = 0 ;
      foreach ($new_instance_ids as $key => $instance_id) {

        $count_launched++ ;
        $values = array(
          'cluster_id'      => $cluster_id ,
          'template_select' => $server_obj->template_id ,
          'nickname_text'   => $server_obj->server_nickname . '#' . $count_launched ,
          'ssh_keys_select' => $server_obj->server_sshkey ,
          'SG_select'       => $server_obj->server_security_group ,
          'zone_select'     => $server_obj->server_zone ,
          'failover_select' => $server_obj->failover_flag ,
          'instance_id'     => $instance_id         ,
        ) ;
        _cloud_cluster_save_cluster_template_db($values) ;
      }

      // Delete the existing server since added new server
       _cloud_cluster_delete_server_db($server_id) ;
    }*/
    

    drupal_set_message( check_plain(t('Server launched: @server_name', array('@server_name' => $server_name) ) ) );
    drupal_goto(CLOUD_CLUSTER_PATH . '/describe/servers/' . $cluster_id ) ;
  }
  else {

    // Failed launch instance
    drupal_set_message( check_plain(t('Server launch failed: @server_name', array('@server_name' => $server_name) ) ) , 'error' );
    drupal_goto(CLOUD_CLUSTER_PATH . '/describe/servers/' . $cluster_id ) ;
  }
  
  return ;
}


/**
 * Launch all the server's present in a Cluster
 * 
 * @param $page_submit
 * @param $cluster_id
 *          Cluster from which server's are to be launched
 * @return
 */
function _cloud_cluster_launch_server_all( $page_submit='' , $cluster_id='' ) {

  if (empty($cluster_id) ) {

    drupal_goto(CLOUD_CLUSTER_PATH) ;

    return ;
  }
  
  $query = _cloud_cluster_servers_get_query() ;
  $query_args = array(
    $cluster_id,
  ) ;
  $result = db_query( $query, $query_args );

    
  // Get the list of all instances
  $cloud_list = cloud_get_all_clouds();

  $all_instances_list = array() ;
  $filter_params = array() ;
  foreach ($cloud_list as $cloud_context) {

    $filter_params['filter_state'] = 'all' ;
    $instances_list                = cloud_get_instances($cloud_context , $filter_params ) ;
    $all_instances_list            = array_merge( $all_instances_list , $instances_list ) ;
  }

  $runningserver_cnt = 0 ;
  while ($depl = db_fetch_object($result)) { // Cluster server object

    $instance_ids_str = $depl->instance_id ;
    if (empty($instance_ids_str) ) { // Launch the instance

        $state = '' ;
    }
    else {

      $instance_ids = explode( ','  , $instance_ids_str ) ;
      foreach ($instance_ids as $instance_id ) {

        if (isset($all_instances_list[$instance_id]) ) {

          $instance_info = $all_instances_list[$instance_id] ;
          $state         = $instance_info['state'] ;
          if ( drupal_strtolower($state) === 'running') { // Found a ruuning instance Skip this instance

            $runningserver_cnt += 1 ;
            continue ;
          }
        }
      }
    }

    $server_obj = NULL ;

    // Launch instance
    $launch_params = array() ;
    $launch_params['template_id'   ] =  $depl->template_id           ;
    $launch_params['nickname'      ] =  $depl->server_nickname       ;
    $launch_params['key_name'      ] =  $depl->server_sshkey         ;
    $launch_params['security_group'] =  $depl->server_security_group ;
    $launch_params['placement'     ] =  $depl->server_zone           ;

    $server_name                     =  $depl->server_nickname       ;
    $template_id                     =  $depl->template_id           ;
    $server_id                       =  $depl->server_id             ;

    $server_obj                      = $depl ;
    
    $cloud_context = _cloud_server_templates_get_cloud($template_id);

    // Launch the instance
    $result_launch = cloud_perform_action( '' , 'launch_using_params' , $cloud_context , $launch_params ) ;


    if ( $result_launch) { // Successfully launched the instance

      $new_instance_ids = isset( $_REQUEST['new_instance_ids'] ) ? $_REQUEST['new_instance_ids'] : array() ;
      $instance_id  = implode(',', $new_instance_ids ) ;
      $update_query = _cloud_cluster_update_cluster_server_query() ;
      $query_args   = array(
        'instance_id',
        $instance_id ,
        $server_id   ,
      ) ;

      $result_launch_db = db_query( $update_query, $query_args );

    }
    else {

      // Failed launch instance
      drupal_set_message( check_plain(t('Server launch failed: @server_name', array('@server_name' => $server_name) ) ) , 'error' );
      drupal_goto(CLOUD_CLUSTER_PATH . '/describe/cluster_templates/' . $cluster_id ) ;
      return ;
    }
  }

  drupal_goto(CLOUD_CLUSTER_PATH . '/describe/servers/' . $cluster_id ) ;
}


/**
 * Delete a Cluster
 * Check whether any Server is running if a server is running do not delete the Cluster.
 *
 * @param $form_values
 * @param $cluster_id
 *              Cluster to be deleted
 * @return 
 */
function _cloud_cluster_delete_cluster($form_values , $cluster_id='') {

  $run_count = _cloud_cluster_get_running_instance_count($cluster_id) ;
  
  if ( $run_count > 0 ) {

    drupal_set_message(check_plain('Cannot delete cluster. Instance(s) of cluster are still active. ') ,  'error');

    if (isset($form_values['cluster_id']) && $form_values['cluster_id'] == $cluster_id ) {

      drupal_goto(CLOUD_CLUSTER_PATH . '/describe/info/' . $cluster_id ) ;
    }
    else {
    
      drupal_goto(CLOUD_CLUSTER_PATH) ;
    }
  }
  else {

    _cloud_cluster_delete_by_id($cluster_id)  ;
    drupal_set_message('Cluster deleted successfully') ;
    drupal_goto(CLOUD_CLUSTER_PATH) ;
  }
}


/**
 * Add a server to a Cluster
 * 
 * @param $cloud_context
 *        Server added from this Sub-cloud
 * @param $cluster_id
 *        Cluster to which server is to be added
 * @return 
 */
function _cloud_cluster_add_server( $cloud_context , $cluster_id) {

  if (empty($cluster_id) ) {

    drupal_goto(CLOUD_CLUSTER_PATH) ;

    return ;
  }

  $query      = _cloud_cluster_get_cluster_by_id_query() ;
  $query_args = array(
    $cluster_id,
  ) ;

  $result = db_query( $query, $query_args );
  $count = 0 ;

  $cluster_nickname = '' ;
  while ($key = db_fetch_object($result)) {

    $cluster_nickname = $key->cluster_nickname ;
    $count++ ;
  }
  
  $params = array() ;
  $params['cluster_id'      ] = $cluster_id       ;
  $params['cluster_nickname'] = $cluster_nickname ;
  

  $cloud_list = cloud_get_all_clouds_display_name() ;
  $is_cloud_enabled = cloud_is_settings_done($cloud_context) ;
  if ($is_cloud_enabled === FALSE ) {
    cloud_set_config_error_message($cloud_list[$cloud_context], $cloud_context);
  }
  else {

      $tmpl_active_count = _cloud_server_templates_get_active_template_count_by_cloud() ;
      if ( isset($tmpl_active_count[$cloud_context]) == FALSE ||  $tmpl_active_count[$cloud_context] < 1 ) {

            $template_url = filter_xss( l( t('Design - Template'), 'design/server_templates/' . $cloud_context . '/list' ) );
            drupal_set_message(check_plain(t('There are no Templates for @cloud_name > ', array( '@cloud_name' => $cloud_list[$cloud_context] ))) . $template_url );
      }
    
  }
  
  return cloud_server_templates_notify( '', 'cluster_form', $cloud_context, $params ) ;
}