<?php

/**
 * @file
 * Contains all the Database Queries functionalites for cloud_dashboard.module.
 * Works with Cloud Metering Module
 * 
 * Copyright (c) 2011 DOCOMO Innovations, Inc.
 * 
 */

/**
 * 
 * Function to get the Clound Instance types pricing details with specific Dates
 * @param $start = Start Date
 * @param $end = End Date
 * @param $cloud_context = Clound Context Type
 * @param $instance_id = Cloud Instance Id
 */
 
function _cloud_dashboard_generate_instance_data($cloud_context = '', $instance_id = '') {
  
  if ($cloud_context) {
    $search_where = ' and a.cloud_type="' . $cloud_context . '"';
  }
  else {
    $search_where ='';
  }
  
  if ($instance_id) {
    $search_instance = ' and a.instance_id ="' . $instance_id . '"';
  }
  else {
    $search_instance = '';
  }
   
  //Construct a query for getting the Clound Instance Pricing details with total hours in running
  $query = 'SELECT a.instance_id, a.instance_type, a.instance_nickname, a.instance_state_name, a.cloud_type as cloud_context, a.launch_time as runtime, a.terminated_date, b.linux_or_unix_usage, b.windows_usage '. 
   'FROM  {' . CLOUD_BILLING_INSTANCES_DETAILS_TABLE . '} a LEFT JOIN {' . CLOUD_PRICING_INSTANCES_TABLE . '} b ON a.instance_type=b.instance_type where (a.instance_state_name = "running" OR a.instance_state_name = "terminated") AND a.cloud_type=b.cloud_type ' . $search_instance . $search_where;
   
  $query_result = cloud_get_db_results($query);
  
  $instances_details = array();    
  foreach ($query_result as $values) {
    $instances_details[$values['instance_id']] = $values;
  }
  
  return $instances_details;

}

function _cloud_dashboard_generate_instance_data_query($cloud_context = NULL) {
  
  if (!empty($cloud_context)) {
    if (is_array($cloud_context)) {
      $in_query = '';
      foreach ($cloud_context as $cloud) {
        $in_query .= (empty($in_query) ? '"' : ', "') . $cloud . '"';
      }
      $search_where = ' and a.cloud_type IN (' . $in_query . ')';
    }
    else {
      $search_where = ' and a.cloud_type="' . $cloud_context . '"';
    }
  }
  else {
    $search_where ='';
  }
    
  $query = 'SELECT a.instance_id, a.instance_type, a.instance_nickname, a.instance_state_name, a.cloud_type, a.launch_time, a.terminated_date, b.linux_or_unix_usage, b.windows_usage FROM  {' . CLOUD_BILLING_INSTANCES_DETAILS_TABLE . '} a LEFT JOIN {' . CLOUD_PRICING_INSTANCES_TABLE . '} b ON a.instance_type = b.instance_type where a.launch_time IS NOT NULL AND a.launch_time != "0000-00-00 00:00:00" AND a.launch_time != "" AND (a.instance_state_name = "running" OR a.instance_state_name = "terminated") AND a.cloud_type = b.cloud_type ' . $search_where ;
  
  return $query;
}

