<?php

/**
 * @file
 * Provides Interactive User Interface for Cloud Usage, Pie Char and Bar Graph.
 * Works with Cloud Metering Module
 *  
 * Copyright (c) 2011 DOCOMO Innovations, Inc.
 *  
 */


/**
 * Function to display the usage and charts of cloud
 */

function _cloud_dashboard_chart_data() {
  //Global $user object of Drupal
  global $user;
  
  //Get the names of the Cloud instances
  $cloud_name_list = cloud_get_all_clouds_display_name();
  
  //Get the page arguments
  $page_argument = filter_xss(arg(2));
  $page_argument_display = filter_xss(arg(3));
  
  $class_all = $class_life = $class_year = $cloud_list = '';
  
  
  //Total usage hours
  $total_clouds_usage = _cloud_dashboard_total_usage();
  
  $filter_data = $total_clouds_usage['from_data']; 
   
  if (empty($page_argument) || $page_argument == 'all') {
   $cloud_list = cloud_get_all_clouds();
   $page_argument = 'all';
   $cloud_name = 'All Clouds';
   $display_all = 1;
  }
  else {
    $cloud_list[$page_argument] = $page_argument;
    $cloud_name = $cloud_name_list[$page_argument];
    $display_all = 0;
  }
  $xaxis_label = t('Days');
  
  //Date Ranges
  $end_date_value = date('c');
  $start_period = strtotime($end_date_value .' - 29 days');
  $start_month  = strtotime($end_date_value .' - 11 months');
  $get_date_format = variable_get('cloud_dashboard_date_format', 'Y/m/d');
  
  if (empty($page_argument_display) || $page_argument_display == 'daily') {
    //$start = date('c', strtotime(date('Y') . '-' . date('m') . '-01 00:00:00'));
    $start = date('c', strtotime(date('Y', $start_period) . '-' . date('m', $start_period) . '-' . date('d', $start_period) . ' 00:00:00'));
    $class_all = 'active';
    $display_cloud_info = t('@cloud_name usage from @month_start to @month_end', array('@cloud_name' => $cloud_name, '@month_start' => date($get_date_format, strtotime($start)), '@month_end' => date($get_date_format, strtotime($end_date_value))));
    
    if (!empty($filter_data)) {
      $display_cloud_info = $cloud_name . ' usage '. $filter_data;
    }
  }
  elseif ($page_argument_display == 'monthly') {
    //$start = date('c', strtotime(date('Y') . '-01-01 00:00:00'));
    $start = date('c', strtotime(date('Y', $start_month) . '-' . date('m', $start_month) . '-01 00:00:00'));
    $class_year = 'active';
    $display_cloud_info = t('@cloud_name usage from @month_start to @month_end', array('@cloud_name' => $cloud_name, '@month_start' => date($get_date_format, strtotime($start)), '@month_end' => date($get_date_format, strtotime($end_date_value))));
        
    if (!empty($filter_data)) {
      $display_cloud_info = $cloud_name . ' usage '. $filter_data;
    }
    $xaxis_label = t('Months');
  }
  elseif ($page_argument_display == 'yearly') {
    $start = _cloud_dashboard_least_runtime_date();
    $class_life = 'active';
    $display_cloud_info = t('@cloud_name lifetime usage since @time', array('@cloud_name' => $cloud_name, '@time' => date($get_date_format, strtotime($start))));
    $xaxis_label = t('Years');
  }
  
  if (module_exists('date_popup') && isset($_REQUEST['date_start'   ]) && isset($_REQUEST['date_end'   ])) {
    $filter_start_date = isset($_REQUEST['date_start'   ]) ? $_REQUEST['date_start'   ] : '' ;
    $filter_end_date = isset($_REQUEST['date_end'   ]) ? $_REQUEST['date_end'   ] : '' ;
      
    $get_start_date_filter = strtotime($filter_start_date['date']);
    $get_start_date = date('c', $get_start_date_filter);
  
    $get_end_date_filter = strtotime($filter_end_date['date'] . ' 23:59:59');
    $get_end_date = date('c', $get_end_date_filter);
  }
  else {
    $filter_start_date['year'] = isset($_REQUEST['date_start_year']) ? $_REQUEST['date_start_year'   ] : '' ;
    $filter_start_date['month'] = isset($_REQUEST['date_start_month']) ? $_REQUEST['date_start_month'   ] : '' ;
    $filter_start_date['day'] = isset($_REQUEST['date_start_day']) ? $_REQUEST['date_start_day'   ] : '' ;
      
    $filter_end_date['year'] = isset($_REQUEST['date_end_year']) ? $_REQUEST['date_end_year'   ] : '' ;
    $filter_end_date['month'] = isset($_REQUEST['date_end_month']) ? $_REQUEST['date_end_month'   ] : '' ;
    $filter_end_date['day'] = isset($_REQUEST['date_end_day']) ? $_REQUEST['date_end_day'   ] : '' ;
    
    $get_start_date_filter = strtotime($filter_start_date['year'] . '-' . $filter_start_date['month'] . '-' . $filter_start_date['day'] );
    $get_start_date = date('c', $get_start_date_filter);
  
    $get_end_date_filter = strtotime($filter_end_date['year'] . '-' . $filter_end_date['month'] . '-' . $filter_end_date['day'] . ' 23:59:59');
    $get_end_date = date('c', $get_end_date_filter);
         
  }
    
  if (isset($_REQUEST['date_start_year']) || isset($_REQUEST['date_start'])) {
    $start_date_data = $get_start_date;
    $end_date   = $get_end_date;
    $period_start = 1;
    $period_end = ($get_end_date_filter - $get_start_date_filter) / (60 * 60 * 24);
    
    if ($period_end <= 31) {
      $xaxis_label = t('Days');
    }
    elseif ($period_end > 31 && $period_end <= 365) {
      $xaxis_label = t('Months');
    }
    elseif ($period_end > 365) {
      $xaxis_label = t('Years');
    }
    
    $display_cloud_info = $cloud_name . ' usage from ' . date($get_date_format, $get_start_date_filter) . ' to ' . date($get_date_format, $get_end_date_filter);   
  }
  
  //Get the cloud costing
  $display_cost = 0;
  $cloud_costing = $total_clouds_usage['cost'];
  
  foreach ($cloud_costing as $value) {
    $display_cost += $value;
  }
  
  if ($display_cost > 0) {
    $clouds_usage = number_format($total_clouds_usage['volume'], 2) . t(' GB');
  }
  else {
    $clouds_usage =  t('0 GB');
  }
  
  if ($display_cost > 0) {
    $display_state = t('<div class="instance_green"></div>');
  }
  else {
    $display_state = t('<div class="instance_red"></div>');
  }
  
  $output = '<div class="dashboard_graph">';
  $output .= '<div id="tabs-wrapper"><ul style="float: none;" class="tabs primary"><li style="display: inline;" class = "' . $class_all . '">' . l(t('Daily'), 'reports/cloud_dashboard/' . $page_argument . '/daily', array('attributes' => array('class' => $class_all)) ) . '</li><li style="display: inline;" class = "' . $class_year . '">' . l(t('Monthly'), 'reports/cloud_dashboard/' . $page_argument . '/monthly', array('attributes' => array('class' => $class_year)) ) . '</li><li style="display: inline;" class = "' . $class_life . '">' . l(t('Yearly'), 'reports/cloud_dashboard/' . $page_argument . '/yearly', array('attributes' => array('class' => $class_life)) ) . '</li></ul></div>';
  $output .= '<div class="dashboard-usage-data">';
  $output .= '<div class="cloud_usage_info">' . $display_cloud_info . '</div>';
  $output .= '<div class="cloud_usage"><div class="usage_data">' . t('Status') . '<br/>' . $display_state . '</div><div class="usage_data">' . t('CPU Hours') . '<br/><span class="status_value">' . number_format($total_clouds_usage['hours'], 2) .'</span></div><div class="usage_data">' . t('Disk Vol Size') . '<br/><span class="status_value">' . $clouds_usage . '</span></div><div class="usage_data">' . t('Estimated Cost') . '<br/><span class="status_value">$' . number_format($display_cost, 2) . '</span></div>';
  $output .= '</div></div>';
  
  $output .= '<div class="dashboard-usage-charts">';
  
  //If there is Total Cost value of the Cloud, show the Pie Chart
  if ($display_cost > 0) {
    if ($display_all == 1) {
      $output .= '<div class="dashboard-usage-charts-pie">';
      $output .= '  <div id="dashboard-usage-charts-pie-chart">';
      $output .= '  </div>';
      $output .= ' </div>';
      _cloud_dashboard_render_pie_chart();
    }
  }
  
  //If there is Total Cost value of the Cloud, show the Bar Graph
  if ($display_cost > 0) {
    $output .= '<div class="dashboard-usage-charts-bar"><div class="bar-chart-y-axis-label">' . t('Cost ($)') . '</div><div id="dashboard_usage_charts-bar-data">';
    $output .=  _cloud_dashboard_render_bar_chart(); // Display the bar-chart
    $output .= '</div><div class="bar-chart-x-axis-label">' . $xaxis_label . '</div></div>';
  }
  $output .= '</div><div style="clear: both"></div>';
  
  return $output;

}


/**
 * Function to get the total usage for each month
 */
function _cloud_dashboard_total_usage() {
  
  $clouds = array();
    
  //Get the page arguments
  $page_argument = check_plain(filter_xss(arg(2)));
  $page_argument_display = check_plain(filter_xss(arg(3)));
  
  if (!$page_argument || $page_argument == 'all') {
    $cloud_list = cloud_get_all_clouds();
  }
  else {
    $cloud_list[$page_argument] = $page_argument;
  }
    
  $total_cpu_hours = 0;
  $total_usage_cost = array();
  $total_vol_size = 0;
  $all_instances_list = array();
  
  foreach ($cloud_list as $cloud_context) {
    
    $instances_list_data = array();    
    $instances_list = _cloud_dashboard_generate_instance_data($cloud_context);

    if (is_array($instances_list) ) {
      //Validate the Instances for empty Instances and Terminated Instances
      //Add into Instance array the Instance Terminated date
      //Add into Instance array the Instance runtime cost
      $instances_list_data = _cloud_dashboard_get_instances_details($instances_list);
    }
    
    $all_instances_list = array_merge( $all_instances_list , $instances_list_data ) ;
    
    $total_usage_cost[$cloud_context] = 0;
  }
  
  foreach ($all_instances_list as $key => $value) {
      //Total Hours     
      $total_cpu_hours  += $value['total_hours'];
      
      //Total cost
      $total_usage_cost[$value['cloud_context']] += $value['total_cost'];
      //drupal_set_message($value.'--'.);
            
      //Calculate the Volume of Instances
      //Get the Volume details for each instance
      $get_volumes = cloud_get_instance_volumes($value['cloud_context'] , $value['instance_id'] );
      
      $vol_size = 0;
      if (!empty($get_volumes)) {
        foreach ($get_volumes as $key => $volume) {
          $created_date = $volume['created'];
          $attached_date = $volume['attached'];
          $vol_value = preg_replace("/[^0-9]/", '', $volume['size']); // remove anything that is not a number 
                
          $vol_size += $vol_value;
        }
      }
      
      $total_vol_size += $vol_size;      
    }
  
  $usage_data['hours'] = $total_cpu_hours;
  $usage_data['cost'] = $total_usage_cost;
  $usage_data['volume'] = $total_vol_size;
  $usage_data['from_data'] = (isset($search_from) ? $search_from : '');
  
  return $usage_data;
}



/**
 * Function to display the PopUp for each clound instance in dashboard
 */
      
function _cloud_dashboard_instance_popup($instance_details) {
    
    $launch_time     = $instance_details['launch_time'];
    $terminated_date = $instance_details['terminated_date'];    
    $get_unit_price   = $instance_details['linux_or_unix_usage'];
    $end = date('c');
    
    //Estimating Expiry Date
    if (!empty($terminated_date)) {      
      $get_cost_hours = _cloud_dashboard_instance_total_cost($instance_details['launch_time'], $end, $instance_details['launch_time'], $terminated_date, $get_unit_price);
    }
    else {      
      $get_cost_hours = _cloud_dashboard_instance_total_cost($instance_details['launch_time'], $end, $instance_details['launch_time'], $terminated_date, $get_unit_price);
    }
    
    $total_hours = $get_cost_hours['total_hours'];  
    $total_cost_value = $get_cost_hours['total_cost'];
    $total_cost       =  t( '$' . number_format($total_cost_value, 2));
    
    //Calculate the instance runtime
    $days = $total_hours / 24;
    $hours = $total_hours % 24;
    
    $total_time = 0;
    if ($days > 365 ) {
      $year = number_format(($days / 365), 1);      
      $total_time = t( $year . ' years'); 
    }
    elseif ($days < 365 && $days > 1) {
      $days = number_format($days, 1);
      $total_time = t( $days . ' days');
    }
    elseif ($days < 1 && $total_hours > 1) {
      $total_time = t( number_format($total_hours, 1) . ' hours');
    }
    elseif ($total_hours < 1) {
      $total_time = t( number_format(($total_hours * 60), 1) . ' minutes');
    }
        
    //State of the Cloud Instance
    $instance_state = strtolower($instance_details['instance_state_name']);
    
    if ($instance_state === 'running') {
      $display_state = t('<div class="instance_green"></div>');
    }
    else {
      $display_state = t('<div class="instance_red"></div>');
    }
    
    //Get the Instance Object details from Cloud API
    $instance_value = cloud_get_instance($instance_details['cloud_type'], $instance_details['instance_id']) ;
                
    $get_instance_id   = $instance_details['instance_id'];    
    $get_instance_name_data = $instance_details['instance_nickname'] ? $instance_details['instance_nickname'] : $get_instance_id ;    
       
    $get_instance_type = $instance_details['instance_type'];
    $get_cloud_context = $instance_details['cloud_type'];
    
    if ( strlen($get_instance_name_data) > 50 ) { // truncate only in case the name is long
      $get_instance_name = substr($get_instance_name_data, 0, 50) . ' ...' ;
    }
    else {
      $get_instance_name = $get_instance_name_data ;
    }
        
    //Check if threshold is configured for the Instance
    $budget_data = _cloud_metering_get_instance_budget($get_cloud_context, $get_instance_id);
    
    if (is_null($budget_data['instance_id']) && empty($terminated_date)) {
      $configure_threshold = l(t('Here'), 'admin/settings/cloud_metering/threshold/' . $get_cloud_context . '/' . $get_instance_id, array('attributes' => array('target' => '_blank'), array('query' => drupal_get_destination())));
      $instance_threshold_config = '        <div id="configure_threshold">Instance Budget threshold is not configured yet. Click ' . $configure_threshold . ' to configure.</div>';
    }
    else {
      $configure_threshold = '';
      $instance_threshold_config = '';
    }
    
    //Calculating estimated expiry date
    $get_budget = $budget_data['budget'];
    
    //Get the Date and Time Format Settings value
    $get_date_format = variable_get('cloud_dashboard_date_format', 'Y/m/d');
            
    if (is_numeric($get_budget) && empty($terminated_date)) {    
      //Calculating estimated Expiry Date
      $estimated_unit_cost = (1 / $get_unit_price);
      
      //If the Initial Budget is marked as 0(Zero) meaning Unlimited Budget
      if ($get_budget == 0) {
        //Create the Date format display for PopUp
        $date_display = t('<div class="no_date"><br/>Unlimited Budget</div>');
        $extend_expiry = l('Allocate Budget', 'clouds/' . $get_cloud_context . '/instances/describe/' . $get_instance_id . '/info', array('attributes' => array('target' => '_blank') , 'query' => 'instance_id=' . urlencode($get_instance_id)));
      }
      else {
        $estimated_expiry_hours = ($estimated_unit_cost * $get_budget);
        
        $estimated_days_tmp = round($estimated_expiry_hours / 24); 
        $estimated_days = ($estimated_days_tmp - $days);
        
        $mk_exp_date = 'now +' . number_format($estimated_days, 0) .' days';        
        $expiry_time = strtotime($mk_exp_date);
        
        //Create the Date format display for PopUp
        $date_display = date($get_date_format, $expiry_time);
        $extend_expiry = l('Extend Budget', 'clouds/' . $get_cloud_context . '/instances/describe/' . $get_instance_id . '/info', array('attributes' => array('target' => '_blank') , 'query' => 'instance_id=' . urlencode($get_instance_id)));
      }
    }
    elseif (!empty($terminated_date)) {
      //Create the Date format display for PopUp       
      $date_display = date($get_date_format, strtotime($terminated_date));
      $extend_expiry = '';
    }
    else {
      //Create the Date format display for PopUp    
      $date_display = t('<div class="no_date">No Initial Budget</div>');
      $extend_expiry = l('Allocate Budget', 'clouds/' . $get_cloud_context . '/instances/describe/' . $get_instance_id . '/info', array('attributes' => array('target' => '_blank') , 'query' => 'instance_id=' . urlencode($get_instance_id)));
    }
    
    //Generate the cost usage meter for Cloud Instance PopUp
    if ($get_budget == 0) {
      $get_usage_val = 0; 
    }
    elseif ($get_budget > 0) {
      $get_usage_val = ($total_cost_value / $get_budget) * 100;
    }
    $disk_meter_val = 337;//width of the DIV
    
    $disk_meter = 'width: ' . $disk_meter_val . 'px';
    $disk_unit = ($disk_meter_val / 100);
    
    $usage_marker = ($get_usage_val * $disk_unit);
    $meter_marker = ($get_usage_val * $disk_unit) + 10;
    
    if ($get_usage_val > 100 ) {
      $usage_marker = $disk_meter_val;
      $meter_marker = $disk_meter_val + 10;
    }
    
    $disk_usage_value = 'width: ' . $usage_marker . 'px';
    $disk_meter_value = 'width: ' . $meter_marker . 'px';
    //End of meter calculations
    
    $display_icon = '';
    $display_message = '';
    //Icon display on crossing 80% on Initial Budget
    if ($get_usage_val >= 80) {
      $display_icon = '<span class="notice">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>';
      $display_message = '<span>' . t('Current Cost has crossed @usage % of Initial Budget!', array('@usage' => number_format($get_usage_val, 0))) . '</span>';
    }
    
    //Cost Usage Meter bar color class
    $cost_usage_color = '';
    if ($get_usage_val > 0 && $get_usage_val <= 60) {
      $cost_usage_color = 'cost_usage_60';
    }
    elseif ($get_usage_val > 60 && $get_usage_val <= 80) {
      $cost_usage_color = 'cost_usage_80';
    }
    elseif ($get_usage_val > 80 && $get_usage_val <= 100) {
      $cost_usage_color = 'cost_usage_100';
    }
      
    //Construct the Div Data
    $div_container_data  = '<div class="cloud_popup">';
    $div_container_data .= '  <div class="cloud_popup_block_title">' . t('Instance: @instance_id', array('@instance_id' => $get_instance_name)) . '<span><b>X</b></span></div>';
    $div_container_data .= '  <div class="cloud_popup_container">';
    $div_container_data .= '    <div class="left_block">';
    $div_container_data .= '      <div class="left_upper_block">';
    $div_container_data .= '        <ul class="ul_upper">';
    $div_container_data .= '          <li class="li_upper">' . t('Status') . ' <br/>' . $display_state . '</li>';
    $div_container_data .= '          <li class="li_upper">' . t('Total Runtime') . ' <br/><span>' . $total_time . '</span></li>';
    $div_container_data .= '          <li class="li_upper">' . t('Estimated Cost') . ' <br/><span>' . $total_cost . '</span>' . $display_icon . '</li>';
    $div_container_data .= '        </ul>';
    $div_container_data .= '      </div>';
    $div_container_data .= '      <div class="left_lower_block">';
    $div_container_data .= '        <div class="cost_usage_display">';
    $div_container_data .= '          <div id="cost_meter" style="' . $disk_meter . '">';
    $div_container_data .= '            <div style="' . $disk_meter_value . '"></div>';
    $div_container_data .= '          </div>';
    $div_container_data .= '          <div id="' . $cost_usage_color . '" style="' . $disk_meter . '">';
    $div_container_data .= '            <div style="' . $disk_usage_value . ' "></div>';
    $div_container_data .= '          </div>';
    $div_container_data .= '        </div>';
    $div_container_data .= '        <div class="disk_meter_description">' . t('Percentage Usage') . '</div>';
    $div_container_data .= '        <div class="meter_notice">' . $display_icon . $display_message . '</div>';
    $div_container_data .= '      </div>';
    $div_container_data .= '    </div>';
    $div_container_data .= '    <div class="right_block">';
    
    if (!empty($terminated_date)) {
      $div_container_data .= '      <div class="date_disp">' . t('Instance Terminated On') . ' <br/><span class="date_value">' . $date_display . '</span></div>';
    }
    else {
      $div_container_data .= '      <div class="date_disp">' . t('Estimated Expiry Date') . ' <br/><span class="date_value">' . $date_display . '</span></div>';
    }
    $div_container_data .= '    </div>';
    $div_container_data .= '    <div class="extend_expiry">' . $extend_expiry . '</div>';
    $div_container_data .= '  </div>';    
    $div_container_data .= '</div>';
    $div_container_data .=    $instance_threshold_config;
    
    return $div_container_data;
}



/**
 *  Theme the pie-chart (Updated - 6-28-11 - Abhijit)
 *  @return string The themed pie-chart
 */
function _cloud_dashboard_render_pie_chart() {
  
  // Get the clouds
  $clouds = cloud_get_clouds();
  $pie_data = array();
      
  foreach ($clouds as $key => $cloud) {
    $cloud_context = $cloud['cloud_name'];
    $cloud_display_name = $cloud['cloud_display_name'];
    $cloud_total_cost = 0;
    $total_clouds_usage = array();
    
    //Get the Dashboard Usage Value
    $total_clouds_usage = _cloud_dashboard_total_usage();
    $cloud_costing = $total_clouds_usage['cost'];
       
    foreach ($cloud_costing as $key => $value) {      
      if ($key == $cloud_context) {
        
        if (is_numeric($value)) {
          $cloud_total_cost += $value;
        } 
        
        if ($value > 0) {
          $labels[] = $cloud_display_name;
          $data[]   = $value;
          $pie_data[$cloud_display_name] = round($value, 2);
        }       
      }
    }  
  }
  
  //Sort the Pie Data from bigger to smaller value
  asort($pie_data);
  
  foreach ($pie_data as $key => $value) {      
    $labels_data[] = $key;
    $cost_data[]   = $value;
  }  
  
  // Add raphael js file
  drupal_add_js(drupal_get_path('module', 'cloud') . '/js/raphael-min.js');
  // Add the data and the labels as Drupal js settings
  // The dashboard js will render the pie using the data
  drupal_add_js(array('cloudDashboardPieData' => array('data' => $cost_data, 'labels' => $labels_data)), 'setting');
}



/**
 *  Theme the usage bar-chart
 *  @return string The themed bar-chart
 */
function _cloud_dashboard_render_bar_chart() {
  
  // Get the clouds
  $clouds = cloud_get_clouds();
  
  if (sizeof($clouds) == 0) {
    return FALSE;
  }
  
  // Check whether we are in "All" tab or a single cloud's tab
  $selected_cloud = '';
  if (arg(2) && arg(2) != 'all') {
    $selected_cloud = check_plain(arg(2));
  }
  
  if (!empty($selected_cloud)) {
    foreach ($clouds as $key => $cloud) {
      if ($cloud['cloud_name'] == $selected_cloud) {
        $clouds = array($clouds[$key]);
        break;
      }
    }
  }
  
  if (!empty($selected_cloud) && sizeof($clouds) > 1) {
    return FALSE;
  }
  
  // Add raphael js file
  drupal_add_js(drupal_get_path('module', 'cloud') . '/js/raphael-min.js');
  drupal_add_js(drupal_get_path('module', 'cloud') . '/js/ico-min.js');
  
  // Check whether we need to show Daily, Monthly or Yearly data
  // Default is Daily (Bar range: Last 30 days)
  $period       = check_plain(arg(3));
  
  $earliest_date = _cloud_dashboard_least_runtime_date();
  
  if (empty($period)) {
    $period = 'daily';
  }
  
  // Raphael based bar chart
  $data = array();
  $labels = array();
  $colors = array();
  
  $get_start_date = $earliest_date;
  $get_end_date   = $get_end_date   = date('c');;
  
  switch ($period) {
    
    case 'monthly':
      // 12 months ago from today
      $get_start_date = date_parse(date('c', strtotime('-11 months')));
      $get_start_date = date('c', strtotime($get_start_date['year'] . '-' . $get_start_date['month'] . '-1 00:00:00'));
      break;
    
    case 'daily':
      // 30 days ago from today
      $get_start_date = date_parse(date('c', strtotime('-29 days')));
      $get_start_date = date('c', strtotime($get_start_date['year'] . '-' . $get_start_date['month'] . '-' . $get_start_date['day'] . ' 00:00:00'));
      break;
  }
  
  $display_state = $period;
  
  if (module_exists('date_popup') && isset($_REQUEST['date_start'   ]) && isset($_REQUEST['date_end'   ])) {
    
    $filter_start_date = _cloud_metering_filter_input($_REQUEST['date_start'   ]['date']) ;
    $filter_end_date   = _cloud_metering_filter_input($_REQUEST['date_end'     ]['date']) ;
      
    $get_start_date_filter = strtotime($filter_start_date . ' 00:00:00');
    $get_start_date        = date('c', $get_start_date_filter);
  
    $get_end_date_filter = strtotime($filter_end_date . ' 23:59:59');
    $get_end_date        = date('c', $get_end_date_filter);
    
  }
  elseif (isset($_REQUEST['date_start_year'])) {
    
    $filter_start_date['year']  = _cloud_metering_filter_input($_REQUEST['date_start_year'   ]) ;
    $filter_start_date['month'] = _cloud_metering_filter_input($_REQUEST['date_start_month'  ]) ;
    $filter_start_date['day']   = _cloud_metering_filter_input($_REQUEST['date_start_day'    ]) ;
      
    $filter_end_date['year']    = _cloud_metering_filter_input($_REQUEST['date_end_year'     ]) ;
    $filter_end_date['month']   = _cloud_metering_filter_input($_REQUEST['date_end_month'    ]) ;
    $filter_end_date['day']     = _cloud_metering_filter_input($_REQUEST['date_end_day'      ]) ;
    
    $get_start_date_filter      = strtotime($filter_start_date['year'] . '-' . $filter_start_date['month'] . '-' . $filter_start_date['day'] . ' 00:00:00');
    $get_start_date             = date('c', $get_start_date_filter);
  
    $get_end_date_filter        = strtotime($filter_end_date['year'] . '-' . $filter_end_date['month'] . '-' . $filter_end_date['day'] . ' 23:59:59');
    $get_end_date               = date('c', $get_end_date_filter);
    
  }
    
  if (isset($_REQUEST['date_start_year']) || isset($_REQUEST['date_start'])) {
    $start_date_data = $get_start_date;
    $end_date   = $get_end_date;
    $period_end_calc = ($get_end_date_filter - $get_start_date_filter) / (60 * 60 * 24);
    
    $month_diff = gmdate('n', $get_end_date_filter) - gmdate('n', $get_start_date_filter);
    $year_diff = gmdate('Y', $get_end_date_filter) - gmdate('Y', $get_start_date_filter);
    
    if ($period_end_calc <= 30) {
      $display_state = 'daily';
    }
    elseif ($period_end_calc > 30 && $period_end_calc <= 365) {
      $display_state = 'monthly';
    }
    else {
      $display_state = 'yearly';
    }
  }
  
  $range = _cloud_dashboard_get_bar_date_range($get_start_date, $get_end_date, $display_state);
  
  $j = 0;  
  for ($i = 0; $i < sizeof($range); $i++) {
    $bar_total = 0;
    
    $label = '';
    
    switch ($display_state) {
      case 'monthly':
        $month           = $range[$i]['month'];
        $year            = $range[$i]['year'];
        
        $last_day        = date('d', strtotime('-1 second', strtotime('+1 month' , strtotime($year . '-' . $month . '-01 00:00:00'))));
        $start_date_data = date('c', strtotime($year . '-' . $month . '-01 00:00:00')); // First day of month
        $end_date        = date('c', strtotime($year . '-' . $month . '-' . $last_day . ' 23:59:59')); // Last day of month
        
        $label = sprintf('%02d', $month);
        
        break;
      case 'yearly':
        $year            = $range[$i]['year'];
        
        $start_date_data = date('c', strtotime($year . '-01-01 00:00:00')); // First day of the year
        $end_date        = date('c', strtotime($year . '-12-31 23:59:59')); // Last day of the year
        
        $label = sprintf('%04d', $year);
        
        break;
      default: // Default period is daily 
        $month           = $range[$i]['month'];
        $year            = $range[$i]['year'];
        $day             = $range[$i]['day'];
        
        if (sizeof($range) <= 15 || $day % 5 == 0) {
          $label = sprintf('%02d', $day);
        }
        else {
          $label = '';
        }
        
        $start_date_data = date('c', strtotime($year . '-' . $month . '-' . $day . ' 00:00:00'));
        $end_date        = date('c', strtotime($year . '-' . $month . '-' . $day . ' 23:59:59'));
    }
    
    if (isset($_REQUEST['date_start_year']) || isset($_REQUEST['date_start'])) {
      if ($display_state == 'daily') {
        $start_date_data = date('c', strtotime($year . '-' . $month . '-' . $day . ' 00:00:00'));
        $end_date   = date('c', strtotime($year . '-' . $month . '-' . $day . ' 23:59:59'));
        $period = 'daily';
      }
      elseif ($display_state == 'monthly') {
        $last_day =   date('d', strtotime('-1 second', strtotime('+1 month' , strtotime($year . '-' . $month . '-01 00:00:00'))));
        
        $start_date_data = date('c', strtotime($year . '-' . $month . '-01 00:00:00'));
        
        $end_date   = date('c', strtotime($year . '-' . $month . '-' . $last_day . ' 23:59:59'));
        $period = 'monthly';
      }
      elseif ($display_state == 'yearly' && $period_end_calc > 365) {
        $start_date_data = date('c', strtotime($year . '-01-01 00:00:00')); // First day of the year
        $end_date   = date('c', strtotime($year . '-12-31 23:59:59')); // Last day of the year
        $period = 'yearly';
      }
      elseif ($display_state == 'yearly' && $period_end_calc <= 365) {
        if ($year_diff != 0) {          
          if ($j > 0) {
            $start_date_data = date('c', strtotime($year . '-01-01 00:00:00')); // First day of the year
            $end_date        = date('c', strtotime($year . '-' . $month . '-' . $day . ' 23:59:59'));
          }
          else {
            $start_date_data = date('c', strtotime($year . '-' . $month . '-' . $day . ' 00:00:00'));
            $end_date        = date('c', strtotime($year . '-12-31 23:59:59'));
          }
        }
        else {
          $start_date_data = date('c', strtotime($year . '-' . $month . '-' . $day . ' 00:00:00'));
          $end_date        = date('c', strtotime($year . '-' . $month . '-' . $day . ' 23:59:59'));
        }        
        $period = 'yearly';
      }
      
      if (strtotime($start_date_data) < $get_start_date_filter) {
        $start_date_data = date('c', $get_start_date_filter);
      }
      
      if (strtotime($end_date) > $get_end_date_filter) {
        $end_date = date('c', $get_end_date_filter);
      }
      $j++; 
    }
    
    //Get the page argument
    $page_argument = filter_xss(arg(2));
    if (!$page_argument || $page_argument == 'all') {
      $cloud_list = cloud_get_all_clouds();
    }
    else {
      $cloud_list[$page_argument] = $page_argument;
    }
    $all_instances_list = array();
    
    
    foreach ($cloud_list as $cloud_context) {
    
      $instances_list_data = array();    
      $instances_list = _cloud_dashboard_generate_instance_data($cloud_context);
     
      if (is_array($instances_list) ) {
        //Validate the Instances for empty Instances and Terminated Instances
        //Add into Instance array the Instance Terminated date
        //Add into Instance array the Instance runtime cost
        $instances_list_data = _cloud_dashboard_get_instances_details($instances_list);      
      }
      else {      
        $instances_list_data = $instances_list;
      }     
      $all_instances_list = array_merge( $all_instances_list , $instances_list_data ) ;
    }
    
    foreach ($all_instances_list as $instance_id => $instance) {
      
      // If start date is before launch date, set it to launch date
      $launch_time = $instance['runtime'];
        
      if (empty($launch_time)) {
        continue;
      }
      
      $start_date = $start_date_data;
        
      // If end date is a future date, set it to current time
      if (time() < strtotime($end_date)) {
        $end_date = date('c');
      }
        
      if (strtotime($start_date) <= strtotime($end_date)) {
        
        if (strtotime($end_date) >= strtotime($launch_time)) {        
          $linux_or_unix_usage = $instance['linux_or_unix_usage'];
          
          $start = gmdate('c', strtotime($start_date));
          $end   = gmdate('c', strtotime($end_date));
                
          $get_cost_hours = _cloud_dashboard_instance_total_cost($start, $end, $instance['runtime'], $instance['terminated_date'], $instance['linux_or_unix_usage']);
          
          $total_hours = $get_cost_hours['total_hours'];
          $instance_cost = $get_cost_hours['total_cost'];
        
          if (!empty($period_start_check)) {
            if ($i >= $period_start_check) {
              if (is_numeric($instance_cost) && $total_hours > 0) {
                $bar_total += $instance_cost;
              }
            }
            else {
              $bar_total += 0;
            } 
          }
          else {
            if (is_numeric($instance_cost) && $total_hours > 0) {
              $bar_total += $instance_cost;
            } 
          }
        }         
      }
    }
    
    $labels[] = $label;
    
    $data[]   = ($bar_total >= 0) ? round($bar_total, 2) : 0;
    $cost[]   = ($bar_total >= 0) ? number_format($bar_total, 2) : 0;
  }
  
  // Add the data and the labels as Drupal js settings
  // The dashboard js will render the chart using the data
  drupal_add_js(array('cloudDashboardBarData' => array('data' => $data, 'costing' => $cost, 'labels' => $labels)), 'setting');
}

