<?php

/**
 * @file
 * 
 */


module_load_include('inc', 'cloud_failover', 'cloud_failover_db'       ) ;


/**
 *
 * @param type $form_submit
 * @return boolean 
 */
function cloud_failover_scenario_list($form_submit) {
  
  drupal_add_js(cloud_get_module_base() . 'js/cloud.js'               , 'module');
  
  $filter     = cloud_get_filter_value( $form_submit , 'filter'   );
  $filter     = trim($filter);

  $filter_col = cloud_get_filter_value( $form_submit , 'operation');
  $filter_col = isset($filter_col) && $filter_col ? $filter_col : 0; // default: Script Name

  $column      = 'template_nickname' ;
  $form_values = !empty($form_values['values']) ? $form_values['values'] : '';
  $filter      = !empty($form_values['filter']) ? $form_values['filter'] : '';  
  
  
  $form['options'] = array(
    '#type' => 'fieldset',
    '#prefix' => '<div class="container-inline">',
    '#suffix' => '</div>',
  // '#title' => t('Filter'), 
  );
  
  $options = array();
  $options['nickname'    ] = t('Name') ;
  $options['action_desc' ] = t('Failover Action') ;
  $options['command_desc'] = t('Failover Command') ;
  $options['user_name'   ] = t('User') ;
  
  $filter     = cloud_get_filter_value( $form_submit , 'filter'   );
  $filter     = trim($filter);
  
  if ($filter_col == 'nickname' )  {
    $column  = 'Nickname' ;
    $sql_col = 'a.nickname'        ;
  }
  elseif ( $filter_col == 'action_desc' )  {
    $column = 'Failover Action' ;
    $sql_col = 'c.description' ;
  }
  elseif ( $filter_col == 'command_desc' )  {
    $column = 'Failover Command' ;
    $sql_col = 'b.description' ;
  }
  elseif ( $filter_col == 'user_name' )  {
    $column = 'User' ;
    $sql_col = 'd.name' ;
  }

  if ( isset($filter) ) {
    $query_args[] = $sql_col ;
    $query_args[] = $filter  ;
  }
  else {
    $filter = ' 1 ' ;
    $query_args[] = ' ' ;
  }

  $form = array() ;
  $form['options'] = array(
    '#prefix' => '<div class="container-inline">',
    '#type'   => 'fieldset',
    '#suffix' => '</div>',
  );
  
  $scenario_count = _cloud_failover_get_count_db() ;
  $filter_disabled = '' ;
  if ( $scenario_count < 2 ) {

    $filter_disabled = TRUE ;
  }
  
  $form['options']['label'    ] = array( '#type' => 'item'     , '#title'   => t('Filter'));
  $form['options']['operation'] = array( '#type' => 'select'   , '#options' => $options, '#default_value' => $filter_col, '#disabled' => $filter_disabled );
  $form['options']['filter'   ] = array( '#type' => 'textfield', '#size'    => 40      , '#default_value' => $filter    , '#disabled' => $filter_disabled  );
  $form['options']['submit'   ] = array( '#type' => 'submit'   , '#value'   => t('Apply')                               , '#disabled' => $filter_disabled );
  if (user_access('create failover scenario') ) {
    $form['options']['cloud_failover'] = array('#type' => 'submit', '#value' => t('Create Scenario'));
  }  

  
  $form['header'] = array(  
    '#type' => 'value',  
    '#value' => array(
            array('data' => t('Nickname') ,  'field' => 'nickname', 'sort' => 'asc', 'class' => 'nickname-column'), 
            array('data' => t('Check Interval') ,  'field' => 'check_interval'), 
            array('data' => t('Retry Interval') ,  'field' => 'retry_interval' ), 
            array('data' => t('Max Check Attempts') , 'field' => 'max_check_attempts'), 
            array('data' => t('User') , 'field' => 'd.name'), 
            array('data' => t('Failover Command') , 'field' => 'b.description'), 
            array('data' => t('Failover Action') , 'field' => 'c.description') 
          )
  );

  $query = _cloud_failover_get_scenarios() ;
  $query .= tablesort_sql( $form['header']['#value']); 
  $result = pager_query( $query, CLOUD_FAILOVER_PAGER_LIMIT, 0 , NULL, $query_args );
  
  $destination = drupal_get_destination();
  
  while ($failover_obj = db_fetch_object($result)) {
      
  $fsid = $failover_obj->fsid;
  $form['Name'                  ][$fsid] = array( array('#value' => l( $failover_obj->nickname , CLOUD_FAILOVER_PATH . '/view',  array('query' => 'id=' . urlencode($fsid)) ) ) );//,  array(),   'id=' . urlencode($fsid) ,  NULL,  FALSE,  TRUE ) ) );
  $form['hdnName'               ][$fsid] = array('#type' => 'hidden', '#value' => addslashes($failover_obj->nickname) );
  $form['check_interval'        ][$fsid] = array( array('#value' => t( (int)$failover_obj->check_interval ) ) );
  $form['retry_interval'        ][$fsid] = array( array('#value' => t( (int)$failover_obj->retry_interval ) ) );
  $form['max_check_attempts'    ][$fsid] = array( array('#value' => t( (int)$failover_obj->max_check_attempts ) ) );
  $form['user'                  ][$fsid] = array( array('#value' => t( $failover_obj->user_name ) ) );
  $form['cloud_failover_command'][$fsid] = array( array('#value' => t( $failover_obj->command_desc ) ) );
  $form['cloud_failover_action' ][$fsid] = array( array('#value' => t( $failover_obj->action_desc ) ) );
  }
  $form['pager'] = array('#value' => theme('pager', NULL, CLOUD_FAILOVER_PAGER_LIMIT, 0));
  
  $form['#redirect']  = FALSE;
  return $form;
}




function theme_cloud_failover_scenario_list($form) {

  //$output = drupal_render($form['options']);
  $prop = array();
  //$form['Name'] = !empty($form['Name']) ? $form['Name'] : '';
  
  $form['pager']['#value'] = !empty($form['pager']['#value']) 
                             ? $form['pager']['#value'] 
                             : '';
  $rows = array();
  if ( !empty($form['Name']) ) { 
      foreach (element_children($form['Name']) as $key) {

         $row = array(array('data' => 
           drupal_render($form['Name'                  ][$key]), 'class' => 'nickname-column'),
           drupal_render($form['check_interval'        ][$key]),
           drupal_render($form['retry_interval'        ][$key]),
           drupal_render($form['max_check_attempts'    ][$key]),
           drupal_render($form['user'                  ][$key]),
           drupal_render($form['cloud_failover_command'][$key]),
           drupal_render($form['cloud_failover_action' ][$key]),
         );

        $prop['onclick'] = cloud_get_messagebox('Are you sure you want to delete the Scenario "' . $form['hdnName'][$key]['#value'] . '" ?') ;
        $action_data = '' ;

        if (user_access('delete failover scenario')) {
          $action_data .= cloud_display_action( 'images/icon_delete', t('Delete') , CLOUD_FAILOVER_PATH . '/delete' ,  array('query' => 'id=' . urlencode($key), 'html' => TRUE), $prop['onclick']);
        }

        if (user_access('edit failover scenario')) {
          $action_data .= cloud_display_action( 'images/icon_clear', t('Edit'), CLOUD_FAILOVER_PATH . '/create' ,  array('query' => 'id=' . urlencode($key), 'html' => TRUE));
        }

        //$row[] =  $action_data ;
        $row[] = array('data' => $action_data, 'class' => 'action-column' );
        $rows[] = $row;
      }
  }

  $reload_link = l('- Refresh Page -' , CLOUD_FAILOVER_PATH . '/scenarios' ,  array( 'query' => 'src=' . CLOUD_FAILOVER_PATH . '/scenarios' ) );  
  $ref_link = array('#type' => 'item', '#prefix'  => '<div id="link_reload" align="right">', '#suffix'  => '</div>', '#value' => $reload_link  );  

    

  $output  = drupal_render($form['options']);
  $output .= theme('table', $form['header']['#value'], $rows);
    
  if ($form['pager']['#value']) {
    $output .= drupal_render($form['pager']);
  }    
    
  $output .= drupal_render($ref_link);
  $output .= drupal_render($form);

  return $output; 
}

/**
 *  Implementation of hook_cloud_action_notify()
 */
function cloud_failover_cloud_action_notify($op, $params) {
  
  switch ($op) {
    
    case 'launch':
      if (isset($params['cloud_context']) && isset($params['instance_id']) && isset($params['template_id'])) {
        
          //_cloud_failover_info_insert($params['cloud_context'], $params['instance_id'], $params['template_id']);
          //_cloud_failover_update_monitoring_server_entries($params['cloud_context']);
      }
      break;      
    case 'enable_failover':
        
        if (isset($params['cloud_context']) && isset($params['instance_id'])) {
            
          $cloud_context = $params['cloud_context'];
          
          $instance_id   = $params['instance_id'];
          $params['instance_id'] = $instance_id;
          
          $cloud  = cloud_get_module_name($cloud_context);
          
          $pub_ip = cloud_get_instance_pub_ip($cloud, $cloud_context, $params);
          
          $dns    = cloud_get_dns_name       ($instance_id, $cloud_context);
                  
          if (empty($pub_ip) && !empty($dns)) {  
            
            _cloud_failover_update_failover_flag($params['cloud_context'], $params['instance_id'], CLOUD_FAILOVER_FLAG_READY_FOR_CHECK);
            _cloud_failover_update_monitoring_server_entries($params['cloud_context']);
          }
          else {
            _cloud_failover_update_failover_flag($params['cloud_context'], $params['instance_id'], CLOUD_FAILOVER_FLAG_INITIATED);
            _cloud_failover_update_eip_info($params['cloud_context'], $params['instance_id'], $pub_ip,  CLOUD_FAILOVER_FLAG_INITIATED);
          }
        }
        break;
        
    case 'disable_failover':
        
        if (isset($params['cloud_context']) && isset($params['instance_id'])) {
            
          _cloud_failover_update_failover_flag($params['cloud_context'], $params['instance_id'], CLOUD_FAILOVER_FLAG_NO_FAILOVER);
          _cloud_failover_update_eip_info     ($params['cloud_context'], $params['instance_id'], '',  CLOUD_FAILOVER_FLAG_NO_FAILOVER);
          _cloud_failover_update_monitoring_server_entries($params['cloud_context']);
          
        }
        break;
        
     case 'update_eip_info':
         
        if (isset($params['cloud_context']) && isset($params['instance_id'])) {
          //Lets start from scratch because it is going to take some time for eip assignment.   
          _cloud_failover_update_eip_info($params['cloud_context'], $params['instance_id'], $params['ip'],  CLOUD_FAILOVER_FLAG_INITIATED); 
        }
        break;    
        
  }
  
}

/**
 *
 * @param type $cloud_context
 * @return type 
 */
function _cloud_failover_update_monitoring_server_entries($cloud_context) {
    
  $cloud_array = cloud_get_clouds();
  for ($row_counter = 0; $row_counter < count($cloud_array); $row_counter++) {
      
    $module = $cloud_array[$row_counter]["cloud_name"];
    if ($module == $cloud_context) {
        
      $cloud  = $cloud_array[$row_counter]["cloud_name"];
      $url    = $cloud_array[$row_counter]["monitoring_server_url"];
        
      _cloud_failover_start_monitoring_instances($cloud_context, $cloud, $url);
    }
  }
  
  return;
}

/**
 *
 * @param type $cloud_context
 * @param type $instance_id
 * @return type 
 */
function _cloud_failover_get_instance_failover_flag($cloud_context , $instance_id) {
    
    return _cloud_failover_instance_failover_flag($cloud_context , $instance_id);
}