<?php

/**
 * @file
 * Provides failover feature.
 * Works with Cloud, Cluster and Scripting module.
 *
 * Copyright (c) 2010-2011 DOCOMO Innovations, Inc.
 *
 */
function _cloud_failover_get_scenarios($params=array()) {
  
  $query =
     'SELECT *, a.port as port,  a.fsid as cloud_failover_command_id,  e.name as script_name, d.name as user_name, b.name as command_desc, c.description as action_desc FROM 
                {' . CLOUD_FAILOVER_SCENARIO_TABLE     . '} a
      LEFT JOIN {' . CLOUD_FAILOVER_COMMANDS_TABLE     . '} b on a.script_id=b.script_id 
      LEFT JOIN {' . CLOUD_FAILOVER_ACTIONS_TABLE      . '} c on a.faid=c.faid
      LEFT JOIN {' . CLOUD_FAILOVER_DRUPAL_USERS_TABLE . '} d on a.uid=d.uid
      LEFT JOIN {' . CLOUD_SCRIPTING_TABLE             . '} e on a.script_id=e.script_id
    WHERE %s like \'%%%s%%\' group by a.fsid ';
  
  return $query;  
}


/**
 *
 * @return string 
 */
function _cloud_failover_get_all_scenarios() {

  $query = 'SELECT * FROM {' . CLOUD_FAILOVER_SCENARIO_TABLE . '} a' ;
  
  return $query ;
}

/**
 *
 * @return type 
 */
function _cloud_failover_get_count_db() {

   $script_count = 0 ;
   $query =  'SELECT count(*) as script_count FROM {' . CLOUD_FAILOVER_SCENARIO_TABLE . '} c ' ;
   $result = db_query( $query, NULL );
   while ($script = db_fetch_object($result)) {

       $script_count = $script->script_count ;
   }

  return $script_count ;
}


function _cloud_failover_get_command_info() {
  
  return $query = 'SELECT * FROM {' . CLOUD_FAILOVER_PROTOCOL_TABLE . '} c WHERE %s like \'%%%s%%\' ' ;
}


function _cloud_failover_delete_scenario($module) {

  //print 'here';die;

  // User Activity Log
  cloud_audit_user_activity( array(
      'type'    => 'user_activity', 
      'message' => t('Failover Scenario has been deleted: @failover_id', array('@failover_id' => $id)),
      'link'    => '',
    )
  );
  
  $delete_query = 'delete from {' . CLOUD_FAILOVER_SCENARIO_TABLE . '}
                  where fsid=\'%s\'
          '; 
  db_query( $delete_query, $_REQUEST['id'] );
  
  drupal_set_message(t('Scenario has been deleted successfully.'));
  drupal_goto(CLOUD_FAILOVER_PATH . '/scenarios') ;
}


function _cloud_failover_save_server_scenario($server_id, $scenario_arr) {

  $insert_query = 'INSERT INTO {' . CLOUD_FAILOVER_SCENARIO_DEPLOYMENT_SERVER_TABLE . '}
                  ( `serverid` ,  
                    `fsid`
                  )  values 
          '; 
  
  $cnt = 0 ;
  foreach ($scenario_arr as $scenario ) {  
  
    $insert_query = $insert_query . "  (  '%s', '%s' ) ," ; 
    $query_args[] = $server_id ;
    $query_args[] = $scenario ;
    $cnt++ ;
  }
  
  if ($cnt == 0 ) {
  
    // No Failover Scenario selected.
    return ;
  }
  
  
  $insert_query = substr($insert_query,  0,  -1);    
  
  db_query( $insert_query, $query_args );  
  
}


function _cloud_failover_get_service_status_of_server($dns, $service) {
  
  $select_query = 'SELECT * FROM ' . CLOUD_FAILOVER_PREFIX . CLOUD_FAILOVER_MONITORING_LOGS_TABLE
                                   . "} WHERE `alias`='%s' and `service`='%s' and `last_update` = 
            ( SELECT max( `last_update` ) FROM cloud_failover_nagios_service_logs where `alias`='%s' and `service`='%s' and  TIMESTAMPDIFF(MINUTE,  `record_timestamp`,  CURRENT_TIMESTAMP ) < 1 ) " ;
  $query_args = array(
    $dns     , // First Parameter
    $service , // Second Parameter
    $dns     , // Third Parameter
    $service , // Fourth Parameter
  ) ;
  $failover_monitering_result = db_query( $select_query, $query_args );    
  while ($row = db_fetch_object($failover_monitering_result)) {  
  
    return $row ;
  }
  
  return NULL ;
}


function _cloud_failover_insert_scenario($form_values) {
  
  global $user;

  //print 'here';die;
  $insert_query = 'INSERT INTO {' . CLOUD_FAILOVER_SCENARIO_TABLE . '} 
    ( `nickname` ,  
      `check_interval` , 
      `retry_interval` , 
      `max_check_attempts` , 
      `faid` , 
      `csid`, 
      `script_id` , 
      `port` , 
      `uid` 
    )  values 
  '; 
          
 
  
  $insert_query = $insert_query . "  ( '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s') " ; 
  $query_args[] = $form_values['name_text'                    ] ;
  $query_args[] = $form_values['check_interval_text'          ] ;
  $query_args[] = $form_values['retry_interval_text'          ] ;
  $query_args[] = $form_values['max_check_attempts_text'      ] ;
  $query_args[] = $form_values['cloud_failover_action_select' ] ;
  $query_args[] = $form_values['cloud_failover_command_select'] ;
  $query_args[] = $form_values['cloud_failover_script_select' ] ;
  $query_args[] = $form_values['port_text'                    ] ;
  $query_args[] = (int)$user->uid;

  db_query( $insert_query, $query_args );  
  
  // User Activity Log
  cloud_audit_user_activity( array(
      'type'    => 'user_activity', 
      'message' => t('New Failover Scenario has been added: @failover_scenario', array('@failover_scenario' => $form_values['name_text'])), 
      'link'    => '',
    )
  );

  return;
}


function _cloud_failover_update_scenario($form_values, $fsid='') {
  
  $update_query = 'UPDATE {' . CLOUD_FAILOVER_SCENARIO_TABLE . '} 
    set `nickname`=\'%s\' ,  
        `check_interval`=\'%s\' ,  
        `retry_interval`=\'%s\' ,  
        `max_check_attempts`=\'%s\' ,  
        `faid`=\'%s\' ,  
        `csid`=\'%s\' ,  
        `script_id`=\'%s\' , 
        `port`=\'%s\'
    where fsid=\'%s\'
    '; 
          
  $query_args[] = $form_values['name_text'                    ] ;
  $query_args[] = $form_values['check_interval_text'          ] ;
  $query_args[] = $form_values['retry_interval_text'          ] ;
  $query_args[] = $form_values['max_check_attempts_text'      ] ;
  $query_args[] = $form_values['cloud_failover_action_select' ] ;
  $query_args[] = $form_values['cloud_failover_command_select']
                ? $form_values['cloud_failover_command_select']
                : $form_values['command_id'                   ] ;
  $query_args[] = $form_values['cloud_failover_script_select' ] ;
  $query_args[] = $form_values['port_text'                    ] ;
  $query_args[] = $fsid ;

  db_query( $update_query, $query_args );  
  
  // User Activity Log
  cloud_audit_user_activity( array(
      'type'    => 'user_activity', 
      'message' => t('Failover Scenario has been modified: @failover_scenario', array('@failover_scenario' => $fsid)), 
        'link'  => '',
    )
  );
  return;
}


function _cloud_failover_scenario_get_all() {
 
  $query  = _cloud_failover_get_all_scenarios() ;
  $query_args = array(
    'nickname',
    ''    ,
  );
  $result = db_query( $query, $query_args ); 
  
  $failover_scenarios = array();
  while ($failover = db_fetch_object($result)) {
      
    $failover_scenarios[$failover->fsid] = $failover->nickname ;
  }
  
  return $failover_scenarios ;
}


function _cloud_failover_get_commands() {
  
  $query  =  'SELECT * FROM {' . CLOUD_FAILOVER_PROTOCOL_TABLE . '} ';
  $query .= tablesort_sql( array(array('field' => 'description', 'sort' => 'asc')) ) ;         
  $command_list_result = db_query( $query ); 
  $command_list[''] = '- Select -' ;
  while ($command = db_fetch_object($command_list_result)) {
      
      $command_list[$command->fpid] = $command->description ;
  }
  
  return $command_list ;          
}


function _cloud_failover_get_actions() {
  
  $query  = 'SELECT * FROM {' . CLOUD_FAILOVER_ACTIONS_TABLE . '} ';
  $query .= tablesort_sql( array(array('field' => 'description', 'sort' => 'asc')) ) ;         
  $action_list_result = db_query( $query ); 
  $action_list[''] = '- Select Action -' ;
  while ($action = db_fetch_object($action_list_result)) {
    
      $action_list[$action->faid] = $action->description ;
  }
  //asort($actionList);
  return $action_list ;          
}


function _cloud_failover_get_executable_scripts() {//Check failed servers with fail over Enabled.
  
  $query =  _cloud_scripting_get_scripts();
  //print $query;die;
  $query_args[] = 'name' ;  
  $query_args[] = '' ;         
  $query .= tablesort_sql( array(array('field' => 'name', 'sort' => 'asc')) ) ;
  $script_list_result = db_query($query, $query_args) ; 
     
  $script_list[''] = '- Select Script -' ;
  while ($script = db_fetch_object($script_list_result)) {
    
      $script_list[$script->script_id] = $script->name ;
  }
  //asort($scriptList);
  return $script_list ;   
}


function _cloud_failover_get_scenario() {
  
  return $query = 'SELECT * FROM {' . CLOUD_FAILOVER_SCENARIO_TABLE . '} c WHERE %s = \'%s\' ' ;
}

/**
 *
 * @param type $cloud_context
 * @param type $old_instance_id
 * @param type $new_instance_id
 * @return type 
 */
function _cloud_failover_update_failover_instance_id($cloud_context, $old_instance_id, $new_instance_id) {
    
  $status_update_query = 'update {' . CLOUD_FAILOVER_INFO_TABLE . '} set `instance_id`=\'%s\' where `instance_id`=\'%s\' and cloud_context = \'%s\' ' ;    
     
  $query_args[] = $new_instance_id;
  $query_args[] = $old_instance_id;
  $query_args[] = $cloud_context;
  
  db_query($status_update_query, $query_args);
  
  return;
}


/**
 *
 * @param type $cloud_context
 * @param type $instance_id
 * @param type $template_id
 * @return type 
 */
function _cloud_failover_update_failover_flag($cloud_context, $instance_id, $failover_flag) {
  
  $query = "select count(*) as count from {" . CLOUD_FAILOVER_INFO_TABLE . '} where `instance_id`=\'%s\' and `cloud_context`=\'%s\' ';
  
  $query_args[] = $instance_id;
  $query_args[] = $cloud_context;
  
  $result = db_query($query, $query_args);
  
  $row = db_fetch_object($result);

  
  if ($row->count == '0') {

    $insert_query = 'insert into {' . CLOUD_FAILOVER_INFO_TABLE . '} (`cloud_context`,`instance_id`, `failover`) values';
    $insert_query = $insert_query . "  ( '%s', '%s', '%s' ) " ;
    
    $insert_query_args[] = $cloud_context;
    $insert_query_args[] = $instance_id  ;
    $insert_query_args[] = $failover_flag; 
    
    db_query($insert_query, $insert_query_args);
  }
  else{
      
    $status_update_query = 'update {' . CLOUD_FAILOVER_INFO_TABLE . '} set failover=\'%s\' where instance_id=\'%s\' and cloud_context = \'%s\' ' ;    
    
    $status_update_query_args[] = $failover_flag;
    $status_update_query_args[] = $instance_id;
    $status_update_query_args[] = $cloud_context;
  
    db_query($status_update_query, $status_update_query_args);
      
  }
  
  return;
}


/**
 *
 * @param type $cloud_context
 * @param type $instance_id
 * @param type $failover_flag
 * @return type 
 */
function _cloud_failover_update_eip_info($cloud_context, $instance_id, $pub_ip, $failover_flag) {
  
     
  $query = "select count(*) as count from {" . CLOUD_FAILOVER_INFO_TABLE . '} where `instance_id`=\'%s\' and `cloud_context`=\'%s\' ';
  
  $query_args[] = $instance_id;
  $query_args[] = $cloud_context;
  
  $result = db_query($query, $query_args);
  
  $row = db_fetch_object($result);

  
  if ($row->count == '0') {
      //Means no failover is enabled for this instance.
  }
  else{
      
    $status_update_query = 'update {' . CLOUD_FAILOVER_INFO_TABLE . '} set failover=\'%s\', public_ip = \'%s\' where instance_id=\'%s\' and cloud_context = \'%s\' ' ;    
    
    $status_update_query_args[] = $failover_flag;
    $status_update_query_args[] = $pub_ip;
    $status_update_query_args[] = $instance_id;
    $status_update_query_args[] = $cloud_context;
  
    db_query($status_update_query, $status_update_query_args);
      
  }
  
  return;
}

/**
 *
 * @param type $cloud_context
 * @param type $instance_id
 * @return type 
 */
function _cloud_failover_instance_failover_flag($cloud_context, $instance_id) {
    
    $failover_flag_query = 'SELECT failover from {' . CLOUD_FAILOVER_INFO_TABLE . '} WHERE instance_id=\'%s\' AND cloud_context = \'%s\' ';
    
    $query_args = array(
      $instance_id     , 
      $cloud_context ,
    ) ;
    
    $result = db_query($failover_flag_query, $query_args);
    
    if ( $row = db_fetch_object($result) ) {

        return $row->failover;
    }
    return 'Disabled';
    
}