<?php

/**
 * @file
 * Contains the constants used by the Cloud Metering module
 * Works with Cloud Metering module
 * 
 * Copyright (c) 2011 DOCOMO Innovations, Inc.
 * 
 */

// Generic constants
define('CLOUD_METERING_MODULE_NAME'                     , 'cloud_metering') ;
define('CLOUD_METERING_MODULE_DISPLAY_NAME'             , 'Cloud Metering') ;

// Database related constants
define('CLOUD_METERING_PREFIX'                          , 'cloud_') ;
define('CLOUD_METERING_THRESHOLDS_TABLE'                , CLOUD_METERING_PREFIX . 'metering_thresholds') ;
define('CLOUD_METERING_MAILS_TABLE'                     , CLOUD_METERING_PREFIX . 'metering_mails') ;
define('CLOUD_METERING_USER_BUDGET_TABLE'               , CLOUD_METERING_PREFIX . 'metering_budget_users') ;
define('CLOUD_METERING_BUDGET_GROUP_TABLE'              , CLOUD_METERING_PREFIX . 'metering_budget_groups') ;
define('CLOUD_METERING_INSTANCES_BUDGET_TABLE'          , CLOUD_METERING_PREFIX . 'metering_instances_budget') ;
define('CLOUD_METERING_TEMPLATES_BUDGET_TABLE'          , CLOUD_METERING_PREFIX . 'metering_templates_budget') ;
define('CLOUD_METERING_QUEUE_TABLE'                     , CLOUD_METERING_PREFIX . 'metering_queue') ;

// Mail related constants
define('CLOUD_METERING_DEFAULT_THRESHOLD_MAIL_SUBJECT'  , 'The instance !instance-name has crossed the cost threshold') ;
define('CLOUD_METERING_DEFAULT_THRESHOLD_MAIL_BODY'     , "Dear !username,\n\nThe cost for your cloud instance named !instance-name has crossed the cost threshold set by you. You should either increase the budget for the instance or terminate it. Please login to your account and take the necessary steps.\n\n-- !site") ;
define('CLOUD_METERING_DEFAULT_TERMINATE_MAIL_SUBJECT'  , 'The instance !instance-name has crossed the allocated budget') ;
define('CLOUD_METERING_DEFAULT_TERMINATE_MAIL_BODY'     , "Dear !username,\n\nYour cloud instance named !instance-name has crossed the budget allocated to it. The instance will be automatically terminated after a backup and detaching of it's volumes, if any.\n\n-- !site") ;
define('CLOUD_METERING_DEFAULT_USER_MAIL_SUBJECT'       , 'The total cost of your cloud instances has gone past your budget') ;
define('CLOUD_METERING_DEFAULT_USER_MAIL_BODY'          , "Dear !username,\n\nThe total cost of your cloud instances has gone past your budget. Please consider terminating some instances or increasing your budget.\n\n-- !site") ;
define('CLOUD_METERING_DEFAULT_GROUP_MAIL_SUBJECT'      , "The total cost of your group's cloud instances has gone past the budget") ;
define('CLOUD_METERING_DEFAULT_GROUP_MAIL_BODY'         , "Dear !username,\n\nThe total cost of your group's cloud instances has gone past the allocated budget. Please consider terminating some instances or increasing the group's budget.\n\n-- !site") ;
define('CLOUD_METERING_MAIL_INTERVAL'                   , 7) ; // 7 days

// Queue related constants
define('CLOUD_METERING_QUEUE'                           , 'cloud_metering_queue') ;

define('CLOUD_METERING_QUEUE_STATUS_INITIATED'          , 'initiated') ;
define('CLOUD_METERING_QUEUE_STATUS_IN_PROGRESS'        , 'in progress') ;
define('CLOUD_METERING_QUEUE_STATUS_COMPLETED'          , 'completed') ;
define('CLOUD_METERING_QUEUE_STATUS_FAILED'             , 'failed') ;
define('CLOUD_METERING_QUEUE_STATUS_WAITING'            , 'waiting') ;

define('CLOUD_METERING_BACKUP'                          , 'backup') ;
define('CLOUD_METERING_BACKUP_CHECK'                    , 'backup check') ;
define('CLOUD_METERING_DETACH'                          , 'detach') ;
define('CLOUD_METERING_DETACH_CHECK'                    , 'detach check') ;
define('CLOUD_METERING_TERMINATE'                       , 'terminate') ;
define('CLOUD_METERING_TERMINATE_CHECK'                 , 'terminate check') ;