<?php

/**
 * @file
 * AWS Cloud database functions
 * 
 * Copyright (c) 2010-2011 DOCOMO Innovations, Inc.
 *  
 */

function aws_cloud_get_all_clouds($sort_string = NULL) {
  //Only return sub-clouds that are defined by aws_cloud or other clouds
  //using the same mechanism
  $base_clouds = aws_cloud_get_cloud_data();
  
  $keys = array();
  foreach (array_keys($base_clouds) as $key) {
    $keys[] = "'{$key}'";
  }
  
  $query = "SELECT c.cloud_name, c.cloud_id, c.start_duration, c.cloud_display_name, c.start_duration, c.scaling_server_url, c.last_update_time, c.host_entries_refresh_time, c.module, c.base_cloud,
        cd.api_version, cd.host_uri, cd.aws_access_key, cd.aws_secret_key, cd.user_id, cd.image_upload_url, cd.image_register_url, cd.certificate from {" . CLOUD_CLOUDS_TABLE . "} c 
        left join {" . AWS_CLOUD_DETAILS_TABLE . "} cd on cd.cloud_name = c.cloud_name ";
  
  if (count($keys) > 0) {
    $query .= "where c.base_cloud in (" .  implode(',', $keys) .")";
  }
  if (isset($sort_string)) {
    $query .= $sort_string;
  }
  return cloud_get_db_results($query);
}

/**
 * Get an entire cloud row from the database 
 */
function aws_cloud_get_cloud($cloud_name) {
  $cloud = array();
  $query = "SELECT c.base_cloud, c.cloud_name, c.cloud_id, c.start_duration, c.cloud_display_name, c.start_duration, c.scaling_server_url, c.last_update_time, c.host_entries_refresh_time, c.module, c.base_cloud,
        cd.api_version, cd.host_uri, cd.aws_access_key, cd.aws_secret_key, cd.user_id, cd.image_upload_url, cd.image_register_url, cd.certificate,
        c.monitoring_server_url, c.monitoring_server_user_id, c.monitoring_server_password from {" . CLOUD_CLOUDS_TABLE . "} c 
        inner join {" . AWS_CLOUD_DETAILS_TABLE . "} cd on cd.cloud_name = c.cloud_name and c.cloud_name = '%s'";
  //print $query; die;
  $results =  cloud_get_db_results($query, array($cloud_name));
 
  //there should only be one
  if (count($results) == 1) {
    $cloud = array_shift($results);    
  }  
  return $cloud;
}

/**
 * Delete a cloud details data from the aws cloud table
 */
function aws_cloud_delete_cloud($cloud_name) {
  db_query("DELETE from {" . AWS_CLOUD_DETAILS_TABLE . "} where cloud_name = '%s'", array($cloud_name));
}

function aws_cloud_check_host_uri($host_uri, $user_id) {
  return db_result(db_query("SELECT host_uri from {" . AWS_CLOUD_DETAILS_TABLE . "} where host_uri = '%s' and user_id = '%s'", array($host_uri, $user_id)));
}

function aws_cloud_get_info($cloud_name, $key) {

  //monitor_url needs refactoring, ignore for now
  if ($key == 'monitor_url') {
    return FALSE; 
  } 
  return db_result(db_query("SELECT %s from {" . AWS_CLOUD_DETAILS_TABLE . "} where cloud_name = '%s'", array($key, $cloud_name)));
}

