<?php

/**
 * @file
 * Enables users to access Xen Cloud Platform (XCP).
 *
 * Copyright (c) 2010-2011 DOCOMO Innovations, Inc.
 *
 */

/**
 * Updated by Abhijit   2011/09/08
 * Updated by Abhijit   2011/09/07
 * Updated by yas       2011/02/25
 * Updated by Jamir     2011/02/25
 * Updated by yas       2011/02/17
 * Updated by yas       2011/02/16
 * Updated by yas       2011/02/14
 */

function xcp_display_instances_list($form_submit='' , $cloud='') {

  drupal_add_js(cloud_get_module_base() . 'js/cloud.js', 'module');
  drupal_add_js(drupal_get_path('module', XCP_CONTEXT)
              . CLOUD_PATH_SEPARATOR
              . 'js/xcp_auto_refresh_vm_list.js'
              , 'module') ;
  
  // _xcp_download_instances_info_xcp();die;

  $options   = array(
    t('Nickname') ,
    t('User'    ) ,
    t('Host'    ) ,
    t('RDC IP'  ) ,
  );

  $filter     = cloud_get_filter_value( $form_submit , 'filter'   );
  $filter     = trim($filter);

  $filter_col = cloud_get_filter_value( $form_submit , 'operation');
  $filter_col = isset($filter_col) && $filter_col ? $filter_col : 0; // default: Nickname

  if ( $filter_col == 0 )     {
    $column  = 'Nickname'     ;
    $sql_col = 'vm_name'      ;
  }
  elseif ($filter_col == 1  ) {
    $column  = 'User'         ;
    $sql_col = 'assigned_to'  ;
  }
  elseif ( $filter_col == 2 ) {
    $column  = 'Host'         ;
    $sql_col = 'host_ip'      ;
  }
  elseif ($filter_col == 3  ) {
    $column  = 'RDC IP'       ;
    $sql_col = 'vm_ip'        ;
  }

  $query_args = array()       ;
  if ( isset($filter) )       {

    $query_args[] = $sql_col  ;
    $query_args[] = $filter   ;
  }
  else {
    $filter       = ' 1 '     ;
    $query_args[] = 'vm_name' ;
    $query_args[] = ''        ;
  }

//asort($options);
  
  $form['options'] = array(
    '#prefix' => '<div class="container-inline">',
    '#type'   => 'fieldset',
    '#suffix' => '</div>',
// '#title' => t('Operations'), 
  );
  
  $form['options']['label'    ] = array( '#type' => 'item'     , '#title' => t('Filter'));
  $form['options']['operation'] = array( '#type' => 'select'   , '#options' => $options, '#default_value' => $filter_col );
  $form['options']['filter'   ] = array( '#type' => 'textfield', '#size'    => 40      , '#default_value' => $filter     );
  $form['options']['submit'   ] = array( '#type' => 'submit'   , '#value'   => t('Apply'));

  if (user_access('administer xcp') ) {

    $form['options']['server_temaplate'] = array('#type' => 'submit', '#value' => t('Create VM'));
  }

  $xcp_host_arr = _xcp_get_host_cpu_info_query() ;

  $form['header'] = array(
    '#type' => 'value', 
    '#value' => array(
      array('data' => t('Nickname') , 'field' => 'vm_name'        ,
                                      'class' => 'nickname-column',
                                      'width' => '250'            , ) ,
      array('data' => t('ID'      ) , 'field' => 'vmid'           , ) , 
      array('data' => t('RDC-IP'  ) , 'field' => 'vm_ip'          , ) , 
      array('data' => t('State'   ) , 'field' => 'statename'      , 
                                      'sort'  => 'desc'             ) ,
      array('data' => t('Host'    ) , 'field' => 'host_ip'        , ) ,
      array('data' => t('User'    ) , 'field' => 'assigned_to'    , ) , 
      array('data' => t('Runtime' ) , 'field' => 'launchtime'     , ) , 
      array('data' => t('Actions' ) , 'class' => 'action-column'  , ) ,
    )
  );

  if (user_access('administer xcp') == FALSE ) {
    $query  = _xcp_get_describe_instances_query() ;
    $query .= tablesort_sql( $form['header']['#value'] ) ;
    $result = pager_query( $query, XCP_PAGER_LIMIT, 0 , NULL, $query_args );
  }
  else {

    if (empty($_REQUEST['sort']) && !$filter) {
      $query  = _xcp_get_describe_all_instances_query_manual_sort() ;
    }
    elseif (empty($_REQUEST['sort']) === FALSE && $_REQUEST['sort'] === 'desc' && $_REQUEST['order'] === 'State' ) {

        $query  = _xcp_get_describe_all_instances_query_manual_sort() ;
    }
    else {
        $query  = _xcp_get_describe_all_instances_query() ;
        $query .= tablesort_sql( $form['header']['#value'] ) ;
    }
    $result = pager_query( $query, XCP_PAGER_LIMIT, 0 , NULL, $query_args );
  }

  // Fetch Console information
  $console_arr = _xcp_get_console_info_query() ;
  $task_list   = _xcp_get_all_queued_task_list() ;

  $lock_status = _xcp_get_lock_status_all() ;
  
  while ($node = db_fetch_object($result)) {

    $form['Nickname'][$node->vmid]   = array( array( '#value' => l( $node->vm_name , XCP_PATH . '/describe/' . $node->vmid . '/vm_details'  ) . (
                                                ( !empty($lock_status[$node->vmid]) && $lock_status[$node->vmid] == 'Lock' )
                                            ? '<a class=lockIcon title=Lock>&nbsp;&nbsp;&nbsp;&nbsp;</a>'
                                            : '' ) ) );
    
    $instance_idFormatted = (strlen($node->vmid)>10)
    ? substr($node->vmid, 0, 8) . '...'
    : $node->vmid;
    $form['hdnName'   ][$node->vmid] = array('#type' => 'hidden', '#value' => addslashes($node->vm_name) );
    $form['ID'        ][$node->vmid] = array( array( '#value' => t( $instance_idFormatted) ) );
    $form['Public_DNS'][$node->vmid] = array( array( '#value' => l( $node->vm_ip, 'http://' . $node->vm_ip,  array('attributes' => array('target' => '_blank')) ) ) );

     if (isset($task_list[$node->vmid] ) === FALSE ) {
    
       $form['State'  ][$node->vmid] = array( array( '#value' => t( $node->vm_state ) ) );
     }
     else {

       $form['State'  ][$node->vmid] = array( array( '#value' => t( 'Operation in Progress' ) ) );
    }

    $xcp_host_str = isset( $xcp_host_arr[$node->host_ip]['hostname'] )
                  ? $xcp_host_arr[$node->host_ip]['hostname']
                  : '' ;
    $form['Host'      ][$node->vmid] = array( array( '#value' => $xcp_host_str ) );

    $form['User'      ][$node->vmid] = array( array( '#value' => t( $node->assigned_to ) ) );
    $form['Runtime'   ][$node->vmid] = array( array( '#value' => t( cloud_get_runtime($node->launchtime) ) ) );

    $console_str = isset($console_arr[$node->opaquereference]['location'] )
                 ? $console_arr[$node->opaquereference]['location']
                 : '' ;
    $form['Console'   ][$node->vmid] = array( array( '#type'  => 'hidden', '#value' => t( $console_str ) ) );

    $form['vm_ip'     ][$node->vmid] = array( array( '#type'  => 'hidden', '#value' => $node->vm_ip ) );
  }

  $form['pager'    ] = array('#value' => theme('pager', NULL, XCP_PAGER_LIMIT, 0));
  $form['#redirect']  = FALSE;
  
  return $form;
}


function theme_xcp_display_instances_list($form) {

  $output = drupal_render($form['options']);
//$sesid  = _xcp_login() ;
  $sesid  = _xcp_session_get() ;
  
  $task_list       = _xcp_get_all_queued_task_list() ;
  $vm_monitor_info = _xcp_get_vm_monitor_info() ;

  $form['Nickname']           = !empty($form['Nickname']) ? $form['Nickname'] : array();
  $form['pager'   ]['#value'] = !empty($form['pager']['#value']) ? $form['pager']['#value'] : '';

  $rows = array();
  $lock_status = _xcp_get_lock_status_all() ;
  foreach (element_children($form['Nickname']) as $key) {

    $row = array(array('data' => 
      drupal_render($form['Nickname'  ][$key]), 'class' => 'nickname-column'),
      drupal_render($form['ID'        ][$key]),
      drupal_render($form['Public_DNS'][$key]),
      drupal_render($form['State'     ][$key]),
      drupal_render($form['Host'      ][$key]),
      drupal_render($form['User'      ][$key]),
      drupal_render($form['Runtime'   ][$key]),
    );

    $is_locked = FALSE ;
    if (isset($lock_status[$key]) && $lock_status[$key] ===  'Lock' )
        $is_locked = TRUE ;

    $form['hdnName'][$key]['#value'] = !empty($form['hdnName'][$key]['#value'])
                                     ? $form['hdnName'][$key]['#value']
                                     : '';
    $inst_name =  trim($form['hdnName'][$key]['#value']);
    $action_data = '' ;
    $prop['onclick'] = cloud_get_messagebox('Are you sure you want to destroy the VM?') ;
  //if (user_access('administer xcp')) {
    $action_data  .= cloud_display_action( 'images/icon_clear', t('Edit'), XCP_PATH . '/describe/' . $key . '/vm_details',  array('html' => TRUE));
  //}
     
    if ($form['State'][$key][0]['#value'] == 'Halted' ) {

      if (user_access('administer xcp') ) {

        $action_data .= cloud_display_action( 'images/icon_play', 'Launch', XCP_PATH . '/' . $key . '/launch'  , array('html' => TRUE));
        $action_data .= cloud_display_action( 'images/icon_copy', 'Clone' , XCP_PATH . '/' . $key . '/clone_vm', array('html' => TRUE));
      }
      else {

        $action_data  .= cloud_display_action( 'images/icon_play', 'Launch' , XCP_PATH . '/' . $key . '/launch_default' ,  array('query' => 'name=' . $inst_name , 'html' => TRUE));
      }
    }
    elseif ($form['State'][$key][0]['#value'] == 'Running'
         || $form['State'][$key][0]['#value'] == 'Suspended') {
       
      $monitor_enabled = 'gray monitor disabled' ;
      //monitor actions
      $vm_ip = $form['vm_ip'][$key][0]['#value'] ;
      if ( empty($vm_monitor_info) === FALSE
      &&   isset($vm_monitor_info[$vm_ip] )
      &&         $vm_monitor_info[$vm_ip] ) {
        $monitor_enabled = 'Monitor Enabled' ;
      }

      $action_data .= cloud_display_action( 'images/icon_monitor' , $monitor_enabled , XCP_PATH . '/describe/' . $key . '/vm_monitor' ,  array('query' => 'name=' . $inst_name . "&action=Monitor", 'html' => TRUE));

      //console should be available for running state only
      if ($form['State'][$key][0]['#value'] == 'Running'
      && user_access('administer xcp')) {

        $console_location  = $form['Console'][$key][0]['#value'] ;
        $xcp_relative_path = drupal_get_path('module', XCP_CONTEXT ) ;
        $console_url       = $xcp_relative_path . "/xcp_console.inc" ;
        // Use stylesheet (by Jamir)
        $console_data      = '<H1>Console : ' . $form['Nickname'][$key][0]['#value'] . '</H1>';
        $close_window      = "<input type=button value=\"Close Console\" onClick=\"javascript:window.close();\">" ;

        $console_applet    = "<applet archive=\"/" . $xcp_relative_path . "/XenServerConsole.jar\" code=com.citrix.xenserver.console.Initialize.class width=800 height=600><param name=SESSION value=\"$sesid\"><param name=URL value=\"$console_location\"><PARAM NAME=USEURL VALUE=\"true\"></applet>" ;
//      $console_applet    = "<applet archive=\"/sites/all/modules/iass/xcp/XenServerConsole.jar\" code=com.citrix.xenserver.console.Initialize.class width=800 height=600><param name=SESSION value=\"$sesid\"><param name=URL value=\"$console_location\"><PARAM NAME=USEURL VALUE=\"true\"></applet>" ;
          
        $arr = array() ;
        $arr['onclick'] = ' popWin = open(\'' . $console_url . '\', \'Console\', \'width=900, height=800\');  popWin.focus();
        popWin.document.write(\'' . $console_data . $close_window . $console_applet . '\') ; return false ; ' ;

        $action_data .= cloud_display_action(
                          'images/icon_ssh', 
                          'Console', 
                           $console_url, 
                           array('query' => 'id=' . urlencode($key), 
                          'html' => TRUE), $arr['onclick']
                        );
      } //end console condition

      if ($form['State'][$key][0]['#value'] == 'Suspended') {
        $action_data .= cloud_display_action(
                          'images/icon_failover_up', 
                          'Resume', 
                           XCP_PATH . '/' . $key . '/resume', 
                           array( 'html' => TRUE)
                        );
      }
      if ($form['State'][$key][0]['#value'] == 'Running') {
        $action_data .= cloud_display_action(
                          'images/icon_failover_up', 
                          'Reboot', 
                           XCP_PATH . '/' . $key . '/reboot', 
                           array('html' => TRUE)
                        );
         $action_data .= cloud_display_action(
                           'images/icon_failover_up', 
                           'Hard Reboot', 
                            XCP_PATH . '/' . $key . '/hard_reboot', 
                            array('html' => TRUE)
                         );
      }

      if ($form['State'][$key][0]['#value'] != 'Suspended') {
        $action_data .= cloud_display_action(
                          'images/action_stop', 
                          'Suspend', 
                           XCP_PATH . '/' . $key . '/suspend', 
                           array('html' => TRUE)
                        );
      }

      $action_data .= cloud_display_action(
                          'images/action_stop', 
                          'Shutdown', 
                           XCP_PATH . '/' . $key . '/shutdown', 
                           array( 'html' => TRUE)
                      );

      $action_data .= cloud_display_action(
                          'images/icon_failover_down', 
                          'Hard Shutdown', 
                           XCP_PATH  . '/' . $key . '/hard_shutdown', 
                           array( 'html' => TRUE)
                      );
    }
     
    if ($form['State'][$key][0]['#value'] == 'Halted' ) {

      $action_data .= cloud_display_action(
                          'images/icon_delete', 
                          'Destroy', 
                           XCP_PATH  . '/' . $key . '/destroy', 
                           array( 'html' => TRUE), $prop['onclick']
                      );
    }

    if ($is_locked) { // Instance is Locked do not display any options other than edit and console

      $action_data = cloud_display_action( 'images/icon_clear', t('Edit'), XCP_PATH . '/describe/' . $key . '/vm_details',  array('html' => TRUE));
    
      //console should be available for running state only
      if ($form['State'][$key][0]['#value'] == 'Running'
       && user_access('administer xcp')) {
    
        $console_location  = $form['Console'][$key][0]['#value'] ;
        $xcp_relative_path = drupal_get_path('module', XCP_CONTEXT ) ;
        $console_url       = $xcp_relative_path . '/xcp_console.inc' ;
        // TODO: Use stylesheet
        $console_data      = '<H1>Console : ' . $form['Nickname'][$key][0]['#value'] . '</H1>';
        $close_window      = "<input type=button value=\"Close Console\" onClick=\"javascript:window.close();\">" ;
  
        $console_applet    = "<applet archive=\"/" . $xcp_relative_path . "/XenServerConsole.jar\" code=com.citrix.xenserver.console.Initialize.class width=800 height=600><param name=SESSION value=\"$sesid\"><param name=URL value=\"$console_location\"><PARAM NAME=USEURL VALUE=\"true\"></applet>" ;
      //$console_applet    = "<applet archive=\"/sites/all/modules/iass/xcp/XenServerConsole.jar\" code=com.citrix.xenserver.console.Initialize.class width=800 height=600><param name=SESSION value=\"$sesid\"><param name=URL value=\"$console_location\"><PARAM NAME=USEURL VALUE=\"true\"></applet>" ;
  
  
        $arr = array() ;
        $arr['onclick'] = ' popWin = open(\'' . $console_url . '\', \'Console\', \'width=900, height=800\');  popWin.focus();
        popWin.document.write(\'' . $console_data . $close_window . $console_applet . '\') ; return false ; ' ;
  
        $action_data .= cloud_display_action(
                          'images/icon_ssh',
                          'Console',
                           $console_url,
                           array('query' => 'id=' . urlencode($key),
                           'html' => TRUE), $arr['onclick']
                        );
      } //end console condition
    }

    if (isset($task_list[$key] ) === FALSE ) {
      $row[] =  array('data' => $action_data, 'class' => 'action-column' );     
    }
    else {

    //$row[] = 'Operation in Progress' ;
      $row[] = '' ;
    }

    $rows[] = $row ;
  }

  $table_attr = array(
    'id'             => 'xcp_list_table'                           ,
    'autoupdate_url' => url( XCP_PATH . '/callback_get_xcp_list' ) ,
  ) ;

  $output .= theme('table', $form['header']['#value'], $rows, $table_attr);

  if ($form['pager']['#value']) {

    $output  .= drupal_render($form['pager']);
  }
   
  $reload_link = l(t('- Refresh Page -') , XCP_PATH . '/xcp_fetch_data', array('query' => array('query' => 'src=' . XCP_PATH ) ) );
  $ref_link = array(
    '#type'   => 'item', 
    '#prefix' => '<div id="link_reload" align="right">', 
    '#suffix' => '</div>', 
    '#value'  => $reload_link
  );

  $output .= drupal_render($ref_link);
  $output .= drupal_render($form    );

  return $output;
}


function xcp_display_instances_list_submit($form_id, $form_values) {

  $form_values = $form_values['values'] ;

  if ( $form_values['op'] == t('Create VM')) {

    return drupal_goto( XCP_PATH . '/create_vm') ;
  }

  if ( $form_values['op'] == t('Apply')) {

  }

  return;
}



function _xcp_callback_get_instances_list($form_submit='' , $cloud='') {

  $filter     = isset($_REQUEST['filter'   ]) ? $_REQUEST['filter'   ] : '' ;
  $filter_col = isset($_REQUEST['operation']) ? $_REQUEST['operation'] : 0  ; // default: Nickname
  $filter     = trim($filter);

  if ( $filter_col == 0 )     {
    $column  = 'Nickname'     ;
    $sql_col = 'vm_name'      ;
  }
  elseif ($filter_col == 1 )  {
    $column  = 'User'         ;
    $sql_col = 'assigned_to'  ;
  }
  elseif ( $filter_col == 2 ) {
    $column  = 'Host'         ;
    $sql_col = 'host_ip'      ;
  }
  elseif ($filter_col == 3 )  {
    $column  = 'RDC IP'       ;
    $sql_col = 'vm_ip'        ;
  }

  $query_args = array()       ;
  if ( isset($filter) ) {

    $query_args[] = $sql_col  ;
    $query_args[] = $filter   ;
  }
  else {
    $filter       = ' 1 '     ;
    $query_args[] = 'vm_name' ;
    $query_args[] = ''        ;
  }

  $table_data = array() ;

  $xcp_host_arr = _xcp_get_host_cpu_info_query() ;

  $table_data['header'] = array(
    '#type' => 'value',
    '#value' => array(
      array('data' => t('Nickname') , 'field' => 'vm_name'        ,
                                      'class' => 'nickname-column',
                                      'width' => '250'            ,
                                      'sort'  => 'asc'            , ) ,
      array('data' => t('ID'      ) , 'field' => 'vmid'           , ) ,
      array('data' => t('RDC IP'  ) , 'field' => 'vm_ip'          , ) ,
      array('data' => t('State'   ) , 'field' => 'statename'      ,
                                      'sort'  => 'desc'           , ) ,
      array('data' => t('Host'    ) , 'field' => 'host_ip'        , ) ,
      array('data' => t('User'    ) , 'field' => 'assigned_to'    , ) ,
      array('data' => t('Runtime' ) , 'field' => 'launchtime'     , ) ,
      array('data' => t('Actions' ) , 'class' => 'action-column'  , ) ,
    )
  );

  if (user_access('administer xcp') == FALSE ) {
    $query  = _xcp_get_describe_instances_query() ;
    $query .= tablesort_sql( $table_data['header']['#value'] ) ;
    $result = pager_query( $query, XCP_PAGER_LIMIT, 0 , NULL, $query_args );
  }
  else {

    if (empty($_REQUEST['sort']) && !$filter) {
      $query  = _xcp_get_describe_all_instances_query_manual_sort() ;
      $result = db_query( $query);
    }
    elseif (empty($_REQUEST['sort']) === FALSE && $_REQUEST['sort'] === 'desc' && $_REQUEST['order'] === 'State' ) {

        // Default sort
        $query  = _xcp_get_describe_all_instances_query_manual_sort() ;
        $result = pager_query( $query, XCP_PAGER_LIMIT, 0 , NULL, $query_args );
    }
    else {
      $query  = _xcp_get_describe_all_instances_query() ;
      $query .= tablesort_sql( $table_data['header']['#value'] ) ;
      $result = pager_query( $query, XCP_PAGER_LIMIT, 0 , NULL, $query_args );
    }
  }

  // Fetch Console information
  $console_arr = _xcp_get_console_info_query() ;
  $task_list   = _xcp_get_all_queued_task_list() ;

  $lock_status = _xcp_get_lock_status_all() ;
    
  while ($node = db_fetch_object($result)) {

    $table_data['Nickname'][$node->vmid]  = array( array( '#value' => l( $node->vm_name , XCP_PATH . '/describe/' . $node->vmid . '/vm_details'  ) . (
                                                ( !empty($lock_status[$node->vmid]) && $lock_status[$node->vmid] == 'Lock' )
                                            ? '<a class=lockIcon title=Lock>&nbsp;&nbsp;&nbsp;&nbsp;</a>'
                                            : '' ) ) );

    $instance_idFormatted = (strlen($node->vmid)>10)
    ? substr($node->vmid, 0, 8) . '...'
    : $node->vmid;
    $table_data['hdnName'   ][$node->vmid] = array('#type' => 'hidden', '#value' => addslashes($node->vm_name) );
    $table_data['ID'        ][$node->vmid] = array( array( '#value' => t( $instance_idFormatted) ) );
    $table_data['Public_DNS'][$node->vmid] = array( array( '#value' => l( $node->vm_ip, 'http://' . $node->vm_ip,  array('attributes' => array('target' => '_blank')) ) ) );

    if (isset($task_list[$node->vmid] ) === FALSE ) {
    
      $table_data['State'  ][$node->vmid] = array( array( '#value' => t( $node->vm_state ) ) );
    }
    else {
    
      $table_data['State'  ][$node->vmid] = array( array( '#value' => t( 'Operation in Progress' ) ) );
    }

    $xcp_host_str = isset( $xcp_host_arr[$node->host_ip]['hostname'] )
                  ?        $xcp_host_arr[$node->host_ip]['hostname']
                  : '' ;
    $table_data['Host'      ][$node->vmid] = array( array( '#value' => $xcp_host_str                             ) );
    $table_data['User'      ][$node->vmid] = array( array( '#value' => t( $node->assigned_to )                   ) );
    $table_data['Runtime'   ][$node->vmid] = array( array( '#value' => t( cloud_get_runtime($node->launchtime) ) ) );
    $console_str = isset($console_arr[$node->opaquereference]['location'] )
                 ?       $console_arr[$node->opaquereference]['location']
                 : '' ;
    $table_data['Console'   ][$node->vmid] = array( array( '#type'  => 'hidden', '#value' => t( $console_str )   ) );
    $table_data['vm_ip'     ][$node->vmid] = array( array( '#type'  => 'hidden', '#value' => $node->vm_ip        ) );
  }


  // The theme for displaying the table
//$sesid     = _xcp_login() ;
  $sesid     = _xcp_session_get() ;
  $task_list = _xcp_get_all_queued_task_list() ;
  $vm_monitor_info = _xcp_get_vm_monitor_info() ;
  
  $rows = array();
  foreach (element_children($table_data['Nickname']) as $key) {

    $row = array(array('data' =>
      drupal_render($table_data['Nickname'  ][$key]) , 'class' => 'nickname-column'),
      drupal_render($table_data['ID'        ][$key]) ,
      drupal_render($table_data['Public_DNS'][$key]) ,
      drupal_render($table_data['State'     ][$key]) ,
      drupal_render($table_data['Host'      ][$key]) ,
      drupal_render($table_data['User'      ][$key]) ,
      drupal_render($table_data['Runtime'   ][$key]) ,
    );

    $is_locked = FALSE ;
    if (isset($lock_status[$key]) && $lock_status[$key] ===  'Lock' )
        $is_locked = TRUE ;

    $table_data['hdnName'][$key]['#value'] = !empty($table_data['hdnName'][$key]['#value'])
                                           ? $table_data['hdnName'][$key]['#value']
                                           : '';
    $inst_name   =  trim($table_data['hdnName'][$key]['#value']);
    $action_data = '' ;
    $prop['onclick'] = cloud_get_messagebox('Are you sure you want to destroy the VM?') ;
    //if (user_access('administer xcp')) {
    $action_data  .= cloud_display_action( 'images/icon_clear', t('Edit'), XCP_PATH . '/describe/' . $key . '/vm_details',  array('html' => TRUE));
    //}

    if ($table_data['State'][$key][0]['#value'] == 'Halted' ) {

      if (user_access('administer xcp') ) {

        $action_data .= cloud_display_action( 'images/icon_play', 'Launch', XCP_PATH . '/' . $key . '/launch'  , array('html' => TRUE));
        $action_data .= cloud_display_action( 'images/icon_copy', 'Clone' , XCP_PATH . '/' . $key . '/clone_vm', array('html' => TRUE));
      }
      else {

        $action_data .= cloud_display_action( 'images/icon_play', 'Launch' , XCP_PATH . '/' . $key . '/launch_default' ,  array('query' => 'name=' . $inst_name , 'html' => TRUE));
      }
    }
    elseif ($table_data['State'][$key][0]['#value'] == 'Running'
         || $table_data['State'][$key][0]['#value'] == 'Suspended') {

      $monitor_enabled = 'gray monitor disabled' ;
      //monitor actions
      $vm_ip = $table_data['vm_ip'][$key][0]['#value'] ;
      if ( empty($vm_monitor_info) === FALSE && isset($vm_monitor_info[$vm_ip] ) &&  $vm_monitor_info[$vm_ip] ) {
        $monitor_enabled = 'Monitor Enabled' ;
      }

      $action_data  .= cloud_display_action( 'images/icon_monitor' , $monitor_enabled , XCP_PATH . '/describe/' . $key . '/vm_monitor' ,  array('query' => 'name=' . $inst_name . "&action=Monitor", 'html' => TRUE));

      //console should be available for running state only
      if ($table_data['State'][$key][0]['#value'] == 'Running'
      && user_access('administer xcp')) {

        $console_location  = $table_data['Console'][$key][0]['#value'] ;
        $xcp_relative_path = drupal_get_path('module', XCP_CONTEXT ) ;
        $console_url       = $xcp_relative_path .  '/xcp_console.inc' ;
        // TODO: Use stylesheet
        $console_data      = '<H1>Console : ' . $table_data['Nickname'][$key][0]['#value'] . '</H1>';
        $close_window      = "<input type=button value=\"Close Console\" onClick=\"javascript:window.close();\">" ;

        $console_applet = "<applet archive=\"/" . $xcp_relative_path . "/XenServerConsole.jar\" code=com.citrix.xenserver.console.Initialize.class width=800 height=600><param name=SESSION value=\"$sesid\"><param name=URL value=\"$console_location\"><PARAM NAME=USEURL VALUE=\"true\"></applet>" ;
//      $console_applet = "<applet archive=\"/sites/all/modules/iass/xcp/XenServerConsole.jar\" code=com.citrix.xenserver.console.Initialize.class width=800 height=600><param name=SESSION value=\"$sesid\"><param name=URL value=\"$console_location\"><PARAM NAME=USEURL VALUE=\"true\"></applet>" ;


        $arr = array() ;
        $arr['onclick'] = ' popWin = open(\'' . $console_url . '\', \'Console\', \'width=900, height=800\');  popWin.focus();
        popWin.document.write(\'' . $console_data . $close_window . $console_applet . '\') ; return false ; ' ;

        $action_data  .= cloud_display_action(
                          'images/icon_ssh',
                          'Console',
                           $console_url,
                           array('query' => 'id=' . urlencode($key),
                           'html' => TRUE), $arr['onclick']
                        );
      } //end console condition

      if ($table_data['State'][$key][0]['#value'] == 'Suspended') {
        $action_data  .= cloud_display_action(
                          'images/icon_failover_up',
                          'Resume',
                           XCP_PATH . '/' . $key . '/resume',
                           array( 'html' => TRUE)
                        );
      }
      if ($table_data['State'][$key][0]['#value'] == 'Running') {
        $action_data  .= cloud_display_action(
                          'images/icon_failover_up',
                          'Reboot',
                           XCP_PATH . '/' . $key . '/reboot',
                           array('html' => TRUE)
                        );
        $action_data  .= cloud_display_action(
                          'images/icon_failover_up',
                          'Hard Reboot',
                           XCP_PATH . '/' . $key . '/hard_reboot',
                           array('html' => TRUE)
                        );
      }

      if ($table_data['State'][$key][0]['#value'] != 'Suspended') {
        $action_data  .= cloud_display_action(
                          'images/action_stop',
                          'Suspend',
                           XCP_PATH . '/' . $key . '/suspend',
                           array('html' => TRUE)
                        );
      }

      $action_data  .= cloud_display_action(
                        'images/action_stop',
                        'Shutdown',
                         XCP_PATH . '/' . $key . '/shutdown',
                         array( 'html' => TRUE)
                       );

      $action_data  .= cloud_display_action(
                        'images/icon_failover_down',
                        'Hard Shutdown',
                         XCP_PATH  . '/' . $key . '/hard_shutdown',
                         array( 'html' => TRUE)
                       );
    }

    if ($table_data['State'][$key][0]['#value'] == 'Halted' ) {

      $action_data  .= cloud_display_action(
                        'images/icon_delete',
                        'Destroy',
                         XCP_PATH  . '/' . $key . '/destroy',
                         array( 'html' => TRUE), $prop['onclick']
                      );
    }

    if ($is_locked) { // Instance is Locked do not display any options other than edit and console

        $action_data = cloud_display_action( 'images/icon_clear', t('Edit'), XCP_PATH . '/describe/' . $key . '/vm_details',  array('html' => TRUE));

        //console should be available for running state only
        if ($table_data['State'][$key][0]['#value'] == 'Running'
            && user_access('administer xcp')) {

            $console_location  = $table_data['Console'][$key][0]['#value'] ;
            $xcp_relative_path = drupal_get_path('module', XCP_CONTEXT ) ;
            $console_url       = $xcp_relative_path .  '/xcp_console.inc' ;
            // TODO: Use stylesheet
            $console_data      = '<H1>Console : ' . $table_data['Nickname'][$key][0]['#value'] . '</H1>';
            $close_window      = "<input type=button value=\"Close Console\" onClick=\"javascript:window.close();\">" ;

            $console_applet = "<applet archive=\"/" . $xcp_relative_path . "/XenServerConsole.jar\" code=com.citrix.xenserver.console.Initialize.class width=800 height=600><param name=SESSION value=\"$sesid\"><param name=URL value=\"$console_location\"><PARAM NAME=USEURL VALUE=\"true\"></applet>" ;
            //$console_applet = "<applet archive=\"/sites/all/modules/iass/xcp/XenServerConsole.jar\" code=com.citrix.xenserver.console.Initialize.class width=800 height=600><param name=SESSION value=\"$sesid\"><param name=URL value=\"$console_location\"><PARAM NAME=USEURL VALUE=\"true\"></applet>" ;


            $arr = array() ;
            $arr['onclick'] = ' popWin = open(\'' . $console_url . '\', \'Console\', \'width=900, height=800\');  popWin.focus();
            popWin.document.write(\'' . $console_data . $close_window . $console_applet . '\') ; return false ; ' ;

            $action_data  .= cloud_display_action(
                              'images/icon_ssh',
                              'Console',
                               $console_url,
                               array('query' => 'id=' . urlencode($key),
                               'html' => TRUE), $arr['onclick']
                            );
        } //end console condition
    }
    
    if (isset($task_list[$key] ) === FALSE ) {

      $row[] =  array('data' => $action_data, 'class' => 'action-column' );
    }
    else {

      //$row[] = 'Operation in Progress' ;
      $row[] = '' ;
    }

    $rows[] = $row ;
  }

  $table_attr = array(
    'id'             => 'xcp_list_table' ,
    'autoupdate_url' => url( XCP_PATH . '/callback_get_xcp_list' ),
  ) ;

  $output  = '' ;
  $output .= theme('table', $table_data['header']['#value'], $rows, $table_attr);

  // Send only the body do not send the headers
  $index_start = strrpos( $output , '<tbody>' ) ;
  $index_end   = strrpos( $output , '</tbody>' ) ;
  if ( isset($table_data['Nickname']) === FALSE || sizeof($table_data['Nickname']) == 0 ) { // No element present

    $output = 'NULL' ;
  }
  else {

    $output = substr( $output , $index_start , $index_end - $index_start ) ;
    $output .= '</tbody>' ;
 }

  $html = $output ;

  print drupal_to_js(array('html' => $html));

  // The exit() call is critical!
  exit();
}


function xcp_launch_vm_server_template($launch_params) {

  if ( empty($launch_params) || isset($launch_params['template_id']) === FALSE ) {

    // Cannot launch instance without Template Id
    return FALSE;
  }

  $template_id = $launch_params['template_id'] ;
  $id          = '' ;
  $query_args  = array();
  
  
  $query        = _cloud_server_templates_get_server_template_details() ;
  $query_args[] = $template_id ;

  $result = db_query( $query, $query_args );
  
  while ($key = db_fetch_object($result)) {

    $id = $key->image_id ;
  }
  
  $name     = $launch_params['nickname'] ;

  $host_ref = xcp_launch_vm_choose_host() ;
  
  _xcp_add_launch_vm_on_host_task( $id ,   $host_ref, $name ) ;
  _xcp_add_download_vm_info_task() ;

  drupal_set_message(  check_plain( t('Task added to queue: Launch @name. This may require some time.', array('@name' => $name) ) ) ) ;

  $instances_id_arr = array() ;
  $instances_id_arr[] = $id ;

  $_REQUEST['new_instance_ids'] = $instances_id_arr ;
  
  return TRUE ;
}


function xcp_launch_vm_default($vmid) {

  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ; 
  }  

   $name = _xcp_get_vm_by_id($vmid) ;
   
  _xcp_add_launch_vm_task($vmid, $name) ;
  _xcp_add_download_vm_info_task() ;

  drupal_set_message(  check_plain( t('Task added to queue: Launch @name. This may require some time.', array('@name' => $name) ) ) ) ;

//drupal_goto( XCP_PATH ) ;
  drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;

  return;
}


function xcp_shutdown_vm($cloud_context, $vmid) {
  
  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ; 
  }  
  
  $name = _xcp_get_vm_by_id($vmid) ;
  
  _xcp_add_shutdown_vm_task($vmid, $name) ;
  _xcp_add_download_vm_info_task() ;

  drupal_set_message( check_plain( t('Task added to queue: Terminate @name. This may require some time.', array('@name' => $name) ) ) );

//drupal_goto( XCP_PATH ) ;
  drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;

  return;
}


function xcp_destroy_vm_action($cloud_context , $vmid) {
  
  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ; 
  }  
  
  $name = _xcp_get_vm_by_id($vmid) ;
  
  _xcp_add_destroy_vm_task($vmid, $name) ;
  _xcp_add_download_vm_info_task() ;

  drupal_set_message( check_plain( t('Task added to queue: Destroy @name. This may require some time.', array('@name' => $name) ) ) );
  drupal_goto( XCP_PATH ) ;

  return;
}


function xcp_suspend_vm($cloud_context, $vmid) {
  
  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ; 
  }  
  
  $name = _xcp_get_vm_by_id($vmid) ;
  
  // jshaikh : Commented for Queue implementation

  /*$result = _xcp_suspend_vm($vmid) ;
   if ($result)
   drupal_set_message("Successfully suspended the instance " . $name . ". It may take some time.") ;
   else
   drupal_set_message("Failed suspend of instance " . $name ) ;
   */

  _xcp_add_suspend_vm_task($vmid , $name ) ;
  _xcp_add_download_vm_info_task() ;

  drupal_set_message( check_plain( t('Task added to queue: Suspend @name. This may require some time.', array('@name' => $name) ) ) );

   if ( isset($_REQUEST['op']) === FALSE || empty($_REQUEST['op']) ) {

    drupal_goto( XCP_PATH ) ;
  }
  else {

    // Came from details page
    drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;
  }
}


function xcp_resume_vm($cloud_context, $vmid) {
  
  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ; 
  }  
  
  $name = _xcp_get_vm_by_id($vmid) ;

  // jshaikh : Commented for Queue implementation

  /*
   $result = _xcp_resume_vm($vmid) ;
   if ($result)
   drupal_set_message("Successfully resumed the instance " . $name . ". It may take some time.") ;
   else
   drupal_set_message("Failed resume of instance " . $name ) ;
   */

  _xcp_add_resume_vm_task($vmid , $name ) ;
  _xcp_add_download_vm_info_task() ;

  drupal_set_message( check_plain( t('Task added to queue: Resume @name. This may require some time.', array('@name' => $name) ) ) );

   if ( isset($_REQUEST['op']) === FALSE || empty($_REQUEST['op']) ) {

    drupal_goto( XCP_PATH ) ;
  }
  else {

    // Came from details page
    drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;
  }
}


function xcp_hard_shutdown_vm($cloud_context, $vmid) {
  
  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ; 
  }  
  
  $name = _xcp_get_vm_by_id($vmid) ;

  // jshaikh : Commented for Queue implementation

  /*$result = _xcp_hard_shutdown_vm($vmid) ;
   if ($result)
   drupal_set_message("Successfully terminated (hard shutdown) the instance " . $name . ". It may take some time.") ;
   else
   drupal_set_message("Failed terminate  (hard shutdown) of instance " . $name ) ;
   */

  _xcp_add_hard_shutdown_vm_task($vmid, $name) ;
  _xcp_add_download_vm_info_task() ;

  drupal_set_message( check_plain( t('Task added: Hard Shutdown @name. This may require some time.', array('@name' => $name) ) ) );

  if ( isset($_REQUEST['op']) === FALSE || empty($_REQUEST['op']) ) {

    drupal_goto( XCP_PATH ) ;
  }
  else {

    // Came from details page
    drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;
  }
}


function xcp_reboot_vm($cloud_context, $vmid) {

  if ( empty($vmid) ) {

    drupal_goto( XCP_PATH ) ;

    return ;
  }

  $name = _xcp_get_vm_by_id($vmid) ;

  // jshaikh : Commented for Queue implementation

  /*$result = _xcp_reboot_vm($vmid) ;
   if ($result)
   drupal_set_message("Successfully rebooting the instance " . $name . ". It may take some time.") ;
   else
   drupal_set_message("Failed reboot of instance " . $name ) ;
   */

  _xcp_add_reboot_vm_task($vmid, $name) ;
  _xcp_add_download_vm_info_task() ;
  drupal_set_message( check_plain( t('Task added: Reboot @name. This may require some time.', array('@name' => $name) ) ) );

  if ( isset($_REQUEST['op']) === FALSE || empty($_REQUEST['op']) ) {

    drupal_goto( XCP_PATH ) ;
  }
  else {

    // Came from details page
    drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;
  }
}


function xcp_callback_autoupdate_button($cloud_context, $vmid) {

  $lock_status = _xcp_get_lock_status($vmid) ;
  $html = 'NULL' ; 
  if ( empty($vmid) ) {

    $html = 'NULL' ;
    print drupal_to_js(array('html' => $html , 'lock' => $lock_status ));
    
    exit();
  }

  $task_list = _xcp_get_all_queued_task_list() ;
  if (isset($task_list[$vmid] ) === TRUE && $task_list[$vmid] ) {

    $html = 'IN_PROGRESS' ;
  }
  
  print drupal_to_js(array('html' => $html , 'lock' => $lock_status ));

  exit();
}


function xcp_cancel_task($cloud_context, $vmid) {
  
  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ; 
  }  
  
  $name = _xcp_get_vm_by_id($vmid) ;

  $task_id = '' ;
  if ($_REQUEST['op'] === t('Cancel Launch') ) {

    $task_id = XCP_VM_LAUNCH ; 
  }
  elseif ($_REQUEST['op'] === t('Cancel Clone') ) {

    $task_id = XCP_VM_CLONE ;
  }
  elseif ($_REQUEST['op'] === t('Cancel Shutdown') ) {

    $task_id = XCP_VM_TERMINATE ;
  }
  elseif ($_REQUEST['op'] === t('Cancel Hard Shutdown') ) {

    $task_id = XCP_VM_HARD_SHUTDOWN ;
  }
  elseif ($_REQUEST['op'] === t('Cancel Hard Reboot') ) {

    $task_id = XCP_VM_HARD_REBOOT ;
  }
  elseif ($_REQUEST['op'] === t('Cancel Suspend') ) {

      $task_id = XCP_VM_SUSPEND ;
  }
  elseif ($_REQUEST['op'] === t('Cancel Resume') ) {

    $task_id = XCP_VM_RESUME ;
  }
  elseif ($_REQUEST['op'] === t('Cancel Reboot') ) {

    $task_id = XCP_VM_REBOOT ;
  }
  elseif ($_REQUEST['op'] === t('Cancel Destroy') ) {

    $task_id = XCP_VM_DESTROY ;
  }
  
  $xcp_task_message = _xcp_get_task_message() ; 
  $task_details     = _xcp_get_next_task_by_vm($vmid, $task_id) ;

  if ( empty($task_details) )  {

    drupal_set_message( check_plain( t('Unable to cancel the task.') )  , 'error' );
  }
  elseif ($task_details['status'] === XCP_TASK_STATUS_INITIATED ) {

    _xcp_update_task_status($task_details['qid'] , t("Successfully canceled task @task" , array( '@task' => $xcp_task_message[$task_details['task']] ) ), XCP_TASK_STATUS_CANCELED ) ;
    drupal_set_message( check_plain( t('@name task @task canceled.', array( '@task' =>  $xcp_task_message[$task_details['task']] , '@name' => $name) ) ) );
  }
  elseif ($task_details['status'] === XCP_TASK_STATUS_IN_PROGRESS ) {

    drupal_set_message( check_plain( t('Unable to cancel the task @task. The task was already executed.', array('@task' => $xcp_task_message[$task_details['task']] ) ) ) );
  }
  else {

    drupal_set_message( check_plain( t('Unable to cancel the task @task. The task was already executed.', array('@task' => $xcp_task_message[$task_details['task']] ) ) ) );
  }

  if ( isset($_REQUEST['op']) === FALSE || empty($_REQUEST['op']) ) {

    drupal_goto( XCP_PATH ) ;
  }
  else {

   // Came from details page
    drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;
  }
}

function xcp_hard_reboot_vm($cloud_context, $vmid) {
  
  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ; 
  }  
  
  $name = _xcp_get_vm_by_id($vmid) ;

  // jshaikh : Commented for Queue implementation

/*$result = _xcp_hard_reboot_vm($vmid) ;
  if ($result)
		drupal_set_message("Successfully rebooting (hard reboot) the instance " . $name . ". It may take some time.") ;
  else
  	drupal_set_message("Failed reboot (hard reboot) of instance " . $name ) ;
*/

  _xcp_add_hard_reboot_vm_task($vmid, $name) ;
  _xcp_add_download_vm_info_task() ;
  drupal_set_message( check_plain( t('Task added: Hard Reboot @name. This may require some time.', array('@name' => $name) ) ) );

  if ( isset($_REQUEST['op']) === FALSE || empty($_REQUEST['op']) ) {

    drupal_goto( XCP_PATH ) ;
  }
  else {

    // Came from details page
    drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;
  }
}


function xcp_create_new_vm($form_submit='') {

  $form['fieldset_vm_info'  ] = array('#type' => 'fieldset', '#title' => t('VM Info'));
  
  $form['name']['name_label'] = array( '#type' => 'item', '#title' => t('Name of VM') , '#required' => TRUE);
  $form['name']['name_text' ] = array( '#type' => 'textfield' );

  $query      = _xcp_get_all_halted_instances_query() ;
  $query_args = array() ;
  $results    = db_query( $query, $query_args );

  $vm_options = array() ;
  while ($vm = db_fetch_object($results)) {

    $vm_options[$vm->vmid] = $vm->vm_name ;
  }

  $form['VM_Master']['vm_master_label' ] = array( '#type' => 'item', '#title' => t('Master VM') );
  $form['VM_Master']['vm_master_select'] = array( '#type' => 'select', '#options' => $vm_options );

  $form['submit_buttons'] = array(
    '#prefix' => '<span class="clear"></span><div class="container-inline"><div class="buttons">',
    '#type'   => 'fieldset',  
    '#suffix' => '</div></div>'
  );
             
  $form['submit_buttons']['Create'] = array( '#type' => 'submit', '#value' => t('Create') );
  $form['submit_buttons']['Cancel'] = array( '#type' => 'submit', '#value' => t('Cancel') );
  
  return $form ;
}


function theme_xcp_create_new_vm($form) {

  $rows = array(
    array(
      drupal_render($form['name']['name_label'] ),
      drupal_render($form['name']['name_text' ] ),
    ),
    array(  
      drupal_render($form['VM_Master']['vm_master_label' ] ),
      drupal_render($form['VM_Master']['vm_master_select'] ),
    ),
  );
  
  $table = theme('table', NULL, $rows );
  $form['fieldset_vm_info']['#children'] = $table;

//cf. Waning by Coder module: Potential problem: when FAPI element '#type' is set to 'markup' (default), '#value' only accepts filtered text, be sure to use check_plain(), filter_xss() or similar to ensure your $variable is fully sanitized.
//$form['fieldset_vm_info']['list'] = array('#type' => 'markup', '#value' => $table);

  $output  = drupal_render($form['fieldset_vm_info']);
  $output .= drupal_render($form['submit_buttons']  );
  $output .= drupal_render($form                    );

  return $output;
}


function xcp_create_new_vm_validate($form_id, $form_values) {

  $form_values = $form_values['values'];

  if ( $form_values['op'] == t('Create') ) {

    if ( empty($form_values['name_text']) ) {
        
      form_set_error('',  t('You must enter valid Name'));
    }
  }
}


function xcp_create_new_vm_submit($form_id, $form_values) {

  $form_values = $form_values['values'];

  if ( $form_values['op'] == t('Cancel') ) {
    drupal_goto( XCP_PATH ) ;

    return ;
  }
  elseif ( $form_values['op'] == t('Create VM') ) {

    $form_values = $form_values['values'];

    // jshaikh : Commented for Queue implementation
    $result = _xcp_clone_vm( $form_values['vm_master_select'] , $form_values['name_text'] ) ;

    /*
    if ($result) {
    	_xcp_download_instances_info_xcp() ;
      drupal_set_message("Successfullt created the VM   " . $form_values['name_text'] ) ;
    }
    */
    _xcp_add_download_vm_info_task() ;

    drupal_goto( XCP_PATH ) ;

    return ;
  }
}


function xcp_clone_vm($form_submit='', $vmid) {
  
  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ; 
  }  
  
  $name = _xcp_get_vm_by_id($vmid) ;

  $form['fieldset_vm_info'  ] = array('#type' => 'fieldset', '#title' => t('VM Info'));
  
  $form['name']['name_label'] = array( '#type' => 'item', '#title' => t('Name of VM')  );
  $form['name']['name_text' ] = array( '#type' => 'textfield' );

  $master_vm = $name ;
  $master_id = $vmid ;

  $form['VM_Master'   ]['vm_master_label' ] = array( '#type' => 'item', '#title' => t('Master VM') );
  $form['VM_Master'   ]['vm_master_select'] = array(  array('#value' => $master_vm  )              );
  $form['VM_Master_id']['vm_master_id'    ] = array( '#type' => 'hidden', '#value' => $master_id   );

  $form['submit_buttons'] = array(
    '#type' => 'fieldset',  
    '#prefix' => '<span class="clear"></span><div class="container-inline"><div class="buttons">', '#suffix' => '</div></div>'
  );
       
  $form['submit_buttons']['Create'] = array( '#type' => 'submit', '#value' => t('Create') );
  $form['submit_buttons']['Cancel'] = array( '#type' => 'submit', '#value' => t('Cancel') );

  return $form ;
}


function theme_xcp_clone_vm($form) {

  $rows = array(

    array(
      drupal_render($form['name']['name_label'] ),
      drupal_render($form['name']['name_text' ] ),
    ),
    array(
      drupal_render($form['VM_Master']['vm_master_label' ] ),
      drupal_render($form['VM_Master']['vm_master_select'] ),
    ),
  );

  $table = theme('table', NULL, $rows );
  $form['fieldset_vm_info']['#children'] = $table;
  
//cf. Waning by Coder module: Potential problem: when FAPI element '#type' is set to 'markup' (default), '#value' only accepts filtered text, be sure to use check_plain(), filter_xss() or similar to ensure your $variable is fully sanitized.
//$form['fieldset_vm_info']['list'] = array('#type' => 'markup', '#value' => $table);

  $output  = drupal_render($form['fieldset_vm_info'            ]) ;
  $output .= drupal_render($form['submit_buttons'              ]) ;
  $output .= drupal_render($form['VM_Master_id']['vm_master_id']) ;
  $output .= drupal_render($form                                ) ;

  return $output;
}


function xcp_clone_vm_validate($form_id, $form_values) {

  $form_values = $form_values['values'];

  if ( $form_values['op'] == t('Create') ) {

    if ( empty($form_values['name_text']) ) {
        
      form_set_error('',  t('You must enter valid Name'));
    }
  }
}


function xcp_clone_vm_submit($form_id, $form_values) {
  
  $form_values = $form_values['values'];  
  if ( $form_values['op'] == t('Cancel') ) {

    drupal_goto( XCP_PATH ) ;

    return ;
  }
  elseif ( $form_values['op'] == t('Create') ) {

    // jshaikh : Commented for Queue implementation

  //$result = _xcp_clone_vm( $form_values['vm_master_id'] , $form_values['name_text'] ) ;
/*
  	if ($result) {
      _xcp_download_instances_info_xcp() ;
      drupal_set_message("Successfullt created the VM   " . $form_values['name_text'] ) ;
    }
*/
    _xcp_add_clone_vm_task($form_values['vm_master_id'] , $form_values['name_text']) ;
    _xcp_add_download_vm_info_task() ;

    drupal_set_message( check_plain( t('Task added to queue: Clone @name. This may require some time.', array('@name' => $form_values['vm_master_id'] ) ) ) );

 // drupal_goto( XCP_PATH ) ;
    drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;

    return ;
  }
}



function xcp_launch_vm_choose_host_default_algo() {

    $host_vm_cnt   = _xcp_get_vm_count_by_host() ;
    $host_cpu      = _xcp_get_host_cpu_info_query() ;

    $selected_host = FALSE ;
    $lowest_load   = 0;


    // Following formula is used to choose the Host.
    // load_factor = No_Of_VM/No_Of_CPU
    // Lowest the load_factor , lowest is the current load. So the Host with lowest load_factor should be used for launching VM
    foreach ($host_cpu as $host ) {

      if (isset($host_vm_cnt[$host['ip']]) == FALSE && $host['no_of_cpu'] > 0 ) { // No VM Launched on this host

        return $host['reference'] ;
      } 
      elseif ($host['no_of_cpu'] == 0 ) {

        continue ;
      } 
      elseif ($selected_host == FALSE ) { // This is the first host

        $selected_host = $host['reference'] ;
        $lowest_load = $host_vm_cnt[$host['ip']]/$host['no_of_cpu'] ;
      } 
      elseif ($host_vm_cnt[$host['ip']]/$host['no_of_cpu'] < $lowest_load ) {

        $selected_host = $host['reference'] ;
        $lowest_load = $host_vm_cnt[$host['ip']]/$host['no_of_cpu'] ;
      }
    }

    return $selected_host ;
}


function xcp_launch_vm_choose_host($launch_count = 1) {

  $hosts         = _xcp_get_host_info_db() ; // How many cores Host has

  $selected_host = cloud_get_deploy_info(array(
                                        'launch_count' => $launch_count,
                                        'hosts'        => $hosts,
                                      )
                                );

  // No Host selected : check for default algo
  if ( $selected_host === FALSE ) {

    $selected_host = xcp_launch_vm_choose_host_default_algo() ;
  }

  return $selected_host ? $selected_host : FALSE;
}


function xcp_launch_vm($form_submit='' , $vmid='') {

  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ; 
  }  
  
  $name = _xcp_get_vm_by_id($vmid) ;

  $form['fieldset_vm_info'  ] = array('#type' => 'fieldset', '#title' => t('VM Info')    );
  
  $form['name']['name_label'] = array('#type' => 'item'    , '#title' => t('Name of VM') );
  $form['name']['name_text' ] = array(array('#value' => $name  ) );

  $query      = _xcp_get_all_host_query() ;
  $query_args = array() ;
  $results    = db_query( $query, $query_args );

  $host_options = array() ;
  $host_options[-1] = '- Auto Select -' ;
  while ($host = db_fetch_object($results)) {

    $host_options[$host->opaquereference] = $host->hostname . " (" . $host->host_ip . ")" ;
  }

  $form['Host_Master']['host_label' ] = array('#type' => 'item'  , '#title'   => t('Host')     );
  $form['Host_Master']['host_select'] = array('#type' => 'select', '#options' => $host_options );

  $form['submit_buttons'] = array(
     '#type'   => 'fieldset',  
     '#prefix' => '<span class="clear"></span><div class="container-inline"><div class="buttons">', '#suffix' => '</div></div>'
  );
       
  $form['submit_buttons']['Create'] = array( '#type' => 'submit', '#value' => t('Launch') );
  $form['submit_buttons']['Cancel'] = array( '#type' => 'submit', '#value' => t('Cancel') );
  
  $form['VM_id']['vm_id'] = array('#type' => 'hidden', '#value' => $vmid  );
  
  return $form ;
}


/**
 * Revert a VM to a previously taken snapshot
 * @param $form_submit
 * @param $ss_id
 * @return
 */
function _xcp_revert_snapshot($form_submit='' , $ss_id) {
  
  $name = $ss_id ;
  
  _xcp_add_snapshot_revert_task($ss_id, $name) ;
  _xcp_add_download_vm_info_task() ;

  drupal_set_message( check_plain( t('Task added to queue: Revert @name. This may require some time.', array('@name' => $name) ) ) );

//drupal_goto( XCP_PATH ) ;
  drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;

  return $form ;
}


function theme_xcp_launch_vm($form) {

  $rows = array(
    array(
      drupal_render($form['name']['name_label'] ),
      drupal_render($form['name']['name_text' ] ),
    ),
    array(
      drupal_render($form['Host_Master']['host_label' ] ),
      drupal_render($form['Host_Master']['host_select'] ),
    ),
  );

  $table = theme('table', NULL, $rows );
  $form['fieldset_vm_info']['#children'] = $table;
  
//cf. Waning by Coder module: Potential problem: when FAPI element '#type' is set to 'markup' (default), '#value' only accepts filtered text, be sure to use check_plain(), filter_xss() or similar to ensure your $variable is fully sanitized.
//$form['fieldset_vm_info']['list'] = array('#type' => 'markup', '#value' => $table);
  
  $output  = drupal_render($form['fieldset_vm_info']);
  $output .= drupal_render($form['VM_id'           ]);
  $output .= drupal_render($form['submit_buttons'  ]);
  $output .= drupal_render($form                    );

  return $output;
}


function xcp_launch_vm_submit($form_id, $form_values) {
  
  $form_values = $form_values['values'];
  if ( $form_values['op'] == t('Cancel') ) {

    drupal_goto( XCP_PATH ) ;

    return ;
  }
  elseif ( $form_values['op'] == t('Launch') ) {

    $host_ref = $form_values['host_select'] ;
    if ( $host_ref == -1 ) { // Auto Select

      $host_ref = xcp_launch_vm_choose_host() ;
    }

    $name = _xcp_get_vm_by_id($form_values['vm_id']) ;
    // jshaikh : Commented for Queue implementation

    /*$result = _xcp_start_vm($form_values['vm_id'] ,   $host_ref ) ;
     if ($result)
     drupal_set_message("Successfully launched the instance " . $name . ". It may take some time.") ;
     else
     drupal_set_message("Failed launching of instance " . $name ,  'error' ) ;

     _xcp_download_instances_info_xcp() ;
     */

    _xcp_add_launch_vm_on_host_task($form_values['vm_id'] ,   $host_ref, $name ) ;
    _xcp_add_download_vm_info_task() ;

    drupal_set_message( check_plain( t('Task added: Launch @name. This may require some time.', array('@name' => $name) ) ) );

 // drupal_goto( XCP_PATH ) ;
    drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;

    return ;
  }
}


/**
 * Implementation of hook_cloud_get_instance() 
 */
function xcp_cloud_get_instance($cloud_context, $filter = array()) {
  $query = _xcp_get_instance_by_id_query();
  $instances = array();
  //instance_id has to be mapped to vmid
  if (isset($filter['filter_value']) && !empty($filter['filter_value'])) {
    $result = db_query($query, $filter['filter_value']);
    while ($obj = db_fetch_object($result)) {
      $instances[$obj->vmid] = array();
      $instances[$obj->vmid]['instance_id'] = $obj->vmid;
      $instances[$obj->vmid]['name'] = $obj->vm_name;
      $instances[$obj->vmid]['hostname'] = $obj->vm_ip;
      //TODO: add more if needed
    }
  }
  return $instances;
}

function xcp_display_instance_info() {

  $vmid = isset( $_REQUEST['instance_id'] ) ? $_REQUEST['instance_id'] : '' ;
  return drupal_get_form( 'xcp_display_vm_info' , $vmid )  ;
}


function xcp_display_vm_info($form_submit='' , $vmid='') {

  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ;
  }
  
  drupal_add_js(drupal_get_path('module', XCP_CONTEXT)
              . CLOUD_PATH_SEPARATOR
              . 'js/xcp_auto_refresh_vm_info.js'
              , 'module') ;
  
  // Get VM ID
  $query      = _xcp_get_instance_by_id_query() ;
  $query_args = array(
    $vmid ,
  ) ;
  
  $results      = db_query( $query, $query_args );
  $vm           = db_fetch_object($results)  ;
  $lock_status  = _xcp_get_lock_status($vm->vmid) ;
  
  $is_locked = '' ;
  if ($lock_status ===  'Lock' )
    $is_locked = TRUE ;

    
  // Get TaskList
  $task_list = _xcp_get_all_queued_task_list() ;
  $disabled  = ''    ;
  $curr_task = FALSE ;
  $task_id   = FALSE ;
  
  // The launch time and the runtime
  $launch_time = '';
  $runtime     = '';
  
  if (!empty($vm->launchtime)) {
    $launch_time = $vm->launchtime;
    $runtime     = cloud_get_runtime($launch_time);
    $launch_time = date_parse($launch_time);
    $launch_time = gmmktime( $launch_time['hour' ], $launch_time['minute'], $launch_time['second'],
                                  $launch_time['month'], $launch_time['day'   ], $launch_time['year'  ] );
    $launch_time = gmdate('Y-m-d H:i', $launch_time);
  }
  
  // Initialize $form
  $form     = array();
  
  if (isset($task_list[$vm->vmid] ) === TRUE
    &&  $task_list[$vm->vmid] ) {

    $disabled  = TRUE ;
    $curr_task = $task_list[$vm->vmid]['task'] ;
    $task_id   = $task_list[$vm->vmid]['qid' ] ;
    $form['Instance_state']['state_text'] = array( array('#value' => t( 'Operation in Progress') ));
    $form['vm_current_state']             = array('#type' => 'hidden', '#value' => 'IN_PROGRESS' ); // Save the current state. Its a hidden parameter
  }
  else {

    $form['Instance_state']['state_text'] = array( array('#value' => t( $vm->vm_state )          ));
    $form['vm_current_state']             = array('#type' => 'hidden', '#value' => $vm->vm_state ); // Save the current state. Its a hidden parameter
  }

  if ($is_locked) {

      $disabled  = TRUE ;
  }
  
  $form['fieldset_vm_info'      ] = array('#type' => 'fieldset', '#title' => t('Details'));

  $vm_name = cloud_get_filter_value( $form_submit , 'Name_text' ) ;
  $vm_name = empty($vm_name) ? $vm->vm_name : $vm_name ; 

  $form['Instance_Name_details' ]                  = array( '#prefix' => '<div class="container-inline">',
                                                            '#suffix' => '</div>'                                       );
  $form['Instance_Name'         ]['Name_label'   ] = array( '#type' => 'item', '#title' => t('Nickname')                );
  
  $form['Instance_id'           ]['id_label'     ] = array( '#type' => 'item', '#title' => t('ID')                      );
  $form['Instance_id'           ]['id_text'      ] = array( array('#value' => t( $vm->vmid ) )                          );

  $form['Instance_ip'           ]['ip_label'     ] = array( '#type' => 'item', '#title' => t('RDC IP')                  );
  $form['Instance_ip'           ]['ip_text'      ] = array( array('#value' => !empty($vm->vm_ip)
                                                                            ? l($vm->vm_ip, 'http://' . $vm->vm_ip,
                                                                              array('attributes' => array('target' => '_blank') ) )
                                                                            : XCP_CLOUD_NONE,                         ) );


  $form['Instance_lock']['lock_label'] = array('#type' => 'item', '#title' => t('Safety Status') );
  $form['Instance_lock_details'      ] = array('#prefix' => '<div class="container-inline">', '#suffix' => '</div>');

  $lock_options =  array(
    'Lock'   => t('Lock')   ,
    'Unlock' => t('Unlock') ,
  ) ;

  $form['Instance_lock_details']['lock_text'     ]     = array('#type' => 'select', '#options' => $lock_options , '#default_value' => $lock_status );
  

  $form['Instance_state'        ]['state_label'  ]     = array( '#type' => 'item', '#title' => t('State')                   );

  $form['Instance_pool'         ]['pool_label'   ]     = array( '#type' => 'item', '#title' => t('Pool')                    );
  $form['Instance_pool'         ]['pool_text'    ]     = array( array('#value' => t( _xcp_get_pool_name() ) )               );
  
  $form['Instance_launch_time'  ]['launch_time_label'] = array( '#type' => 'item', '#title' => t('Launch Time')                 );
  $form['Instance_launch_time'  ]['launch_time_text' ] = array( array('#value' => !empty($launch_time)
                                                                            ? t( $launch_time )
                                                                            : XCP_CLOUD_NONE                          ) );

  $form['Instance_runtime'      ]['runtime_label']     = array( '#type' => 'item', '#title' => t('Runtime')                 );
  $form['Instance_runtime'      ]['runtime_text' ]     = array( array('#value' => !empty($runtime)
                                                                            ? t( $runtime )
                                                                            : XCP_CLOUD_NONE                          ) );

  $form['Instance_network'      ]                      = array( '#prefix' => '<div class="container-inline">',
                                                            '#suffix' => '</div>',                                      );
  $form['Instance_User'         ]                      = array( '#prefix' => '<div class="container-inline">',
                                                            '#suffix' => '</div>',                                      );
  $form['Instance_User'         ]['User_label'   ]     = array( '#type' => 'item', '#title' => t('User')                    );
//$form['Instance_user'         ]['user_text'    ] = array( array('#value' => t( $vm->assigned_to ) )                   );

  $form['vif_header'] = array(
      '#type' => 'value',
        '#value' => array(
          array('data' => t('UUID'          ) , 'field' => 'uuid'                       ) ,
          array('data' => t('Device'        ) , 'field' => 'device'  , 'sort'  => 'asc' ) ,
          array('data' => t('MAC'           ) , 'field' => 'mac'                        ) ,
          array('data' => t('IP'            )                                           ) ,
          array('data' => t('Network'       ) , 'field' => 'bridge'                     ) ,
          array('data' => t('Attached'      ) , 'field' => 'currently_attached'         ) ,
          array('data' => user_access('administer xcp') ? t('Action') : ''              ) ,
        )
      );
  
  $vif_list = _xcp_get_vif_list($vm->opaquereference , $form['vif_header']['#value'] )  ;

  $form['release_uuid']   = array('#type' => 'hidden', '#value' => '' );
  if (count($vif_list) > 0 ) {
  
    $form['fieldset_vif'] = array('#type' => 'fieldset', '#title' => t('Network') , '#collapsible' => TRUE, '#collapsed' => FALSE );
  }
  else {

    $form['fieldset_vif'] = array('#type' => 'fieldset', '#title' => t('Network') , '#collapsible' => TRUE, '#collapsed' => TRUE );
  }

  $network_list = _xcp_get_vm_network_list() ;
  $cnt = 0 ;
  foreach ($vif_list as $vif_details) {

    $tmp_table_rows = array() ;
    $form['vif_details_data']['vif_details_' . $cnt]            = array() ;
    $form['vif_details_data']['vif_details_' . $cnt]['uuid'   ] = array('#type' => 'item', '#value' => $vif_details['uuid'   ]  );
    $form['vif_details_data']['vif_details_' . $cnt]['device' ] = array('#type' => 'item', '#value' => $vif_details['device' ]  );
    $form['vif_details_data']['vif_details_' . $cnt]['mac'    ] = array('#type' => 'item', '#value' => $vif_details['mac'    ]  );
    $form['vif_details_data']['vif_details_' . $cnt]['network'] = array('#type' => 'item', '#value' => $vif_details['network']  );

    if (isset($network_list[$vmid]) && isset($network_list[$vmid][$vif_details['device']]) )  {

      $form['vif_details_data']['vif_details_' . $cnt]['ip']     = array('#type' => 'item', '#value' => $network_list[$vmid][$vif_details['device']]  );
    }
    else {

      $form['vif_details_data']['vif_details_' . $cnt]['ip']     = array('#type' => 'item', '#value' => ''  );
    }
  
    $action      = "document.getElementsByName('release_uuid')[0].value='" . $vif_details['vif_ref'] . "' ; document.forms[0].action=document.forms[0].action; ";
    $release_msg = cloud_get_messagebox(t('Are you sure you want to release the device @device  ?', array('@device' => $vif_details['device'])) , $action );
 // $form['vif_details_data']['vif_details_' . $cnt]['button' ] = array('#type' => 'submit', '#value' => t('Delete') , '#attributes' => array('onclick' => $release_msg)  );
    $form['vif_details_data']['vif_details_' . $cnt]['button' ] = user_access('administer xcp')
                                                                ? array('#type' => 'submit', '#value' => t('Delete') , '#attributes' => array('onclick' => $release_msg) , '#disabled' => $disabled )
                                                                : '';

    if (empty($vif_details['currently_attached'])
    ||        $vif_details['currently_attached'] === '0' ) {
    
      $form['vif_details_data']['vif_details_' . $cnt]['active']  = array('#type' => 'item', '#value' => 'No'  );
    //$form['vif_details_data']['vif_details_' . $cnt]['button' ]['#disabled'] = TRUE ;
    }
    else {
  
      $form['vif_details_data']['vif_details_' . $cnt]['active']  = array('#type' => 'item', '#value' => 'Yes' );
    }
  
    $cnt++ ;
  } // end of foreach
  
  if (user_access('administer xcp')) {

    $form['Instance_Name_details' ]['Name_text'     ] = array( '#type' => 'textfield', '#value'   => t( $vm_name )    , '#disabled' => $disabled );

    $form['Instance_User'         ]['User_select'   ] = array( '#type' => 'select'   , '#options' => cloud_get_users(), '#disabled' => $disabled );
    $form['Instance_User'         ]['User_select'   ]['#default_value'] = isset_variable($vm->assigned_to);

    /*$form['Instance_network'      ]['Network_label' ] = array( '#type' => 'item'     , '#title'   => t('Network')     ,
                                                               '#description' => t('This feature is Temporarily unavailable.')); */
    $form['Instance_network'      ]['Network_label' ] = array( '#type' => 'item'     , '#title'   => t('Network')     ,
                                                               '#description' => t(''));
    $form['Instance_network'      ]['Network_select'] = array( '#type' => 'select'   , '#options' => _xcp_get_network_options()
                                                                                                                     , '#disabled' => $disabled
                                                                                                                    /* '#disabled' => $disabled */);
    $form['Instance_network'      ]['Add'           ] = array( '#type' => 'submit'   , '#value'   => t('Add')         , '#disabled' => $disabled
                                                                                                                    /* '#disabled' => $disabled */);
  }
  else {

    $form['Instance_Name_details' ]['Name_text'     ] = array(array('#value' => t( $vm_name )));

    $form['Instance_User'         ]['User_select'   ] = array( array('#value' => check_plain( isset_variable($vm->assigned_to) ) ) );

//  $form['Instance_network'      ]['Network_select'] = array( '#type' => 'select', '#options' => _xcp_get_network_options() , '#disabled' => TRUE  );
//  $form['Instance_network'      ]['Add'           ] = array( '#type' => 'submit', '#value' => t('Add')  , '#disabled' => TRUE  );
  }

  $form['Instance_host_ip'        ]['host_ip_label' ] = array( '#type' => 'item', '#title' => t('Host IP'));
  $form['Instance_host_ip'        ]['host_ip_text'  ] = array( array('#value' =>  !empty($vm->hostname)  // if both hostname and host IP exist
                                                                              &&  !empty($vm->host_ip )  // show the hostname and IP w/ alink
                                                                               ?   l( $vm->hostname . ' ( ' . $vm->host_ip . ' ) ',
                                                                                   'http://' . $vm->host_ip,
                                                                                   array('attributes' => array('target' => '_blank') ) )  
                                                                               : (!empty($vm->hostname)  // if only hostname exists w/o host IP
                                                                               ?   $vm->hostname         // show the hostname
                                                                               :   XCP_CLOUD_NONE)       // else nothing to show ('None')
                                                               )
                                                        );
  
  $form['save_button'                               ] = array('#type' => 'submit', '#value' => t('Update Details'));
  
  $form['VM_id']['vm_id'         ] = array('#type' => 'hidden', '#value' => $vmid  );
  $form['VM_id']['autoupdate_url'] = array('#type' => 'hidden', '#value' => url( XCP_PATH . '/' . $vmid . '/callback_autoupdate_button' )  );
  
  
  $form['submit_buttons'] = array(
    '#prefix' => '<span class="clear"></span><div class="container-inline"><div class="buttons">',
    '#type'   => 'fieldset'    ,
    '#suffix' => '</div></div>',
  );
  
  $form['submit_buttons']['save_button'] = array( '#type' => 'submit', '#value' => t('Update Details'),  '#attributes' => array('class' => 'vm-update-details-1') );

  // Check the available actions
  if ( strtolower($vm->vm_state) === strtolower('halted') ) {

    if (user_access('administer xcp') ) {
  
      if ( $curr_task === XCP_VM_LAUNCH ) {
  
        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/cancel_task')) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Launch'] = array( '#type' => 'submit', '#value' => t('Cancel Launch'), '#attributes' => array('onclick' => $action ) );
      }
      else {
        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/launch')) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Launch'] = array( '#type' => 'submit', '#value' => t('Launch'), '#disabled' => $disabled , '#attributes' => array('onclick' => $action ) );
      }
  
      if ( $curr_task === XCP_VM_CLONE ) {
  
        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/cancel_task')) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Clone'] = array( '#type' => 'submit', '#value' => t('Cancel Clone') ,  '#attributes' => array('onclick' => $action ) );
      }
      else {
  
        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/clone_vm')) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Clone'] = array( '#type' => 'submit', '#value' => t('Clone'), '#disabled' => $disabled ,  '#attributes' => array('onclick' => $action ) );
      }
    }
    else {

      if ( $curr_task === XCP_VM_LAUNCH ) {

        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/cancel_task' , array( 'query' => 'name=' . $vm_name ) )) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Launch_default'] = array( '#type' => 'submit', '#value' => t('Cancel Launch'),  '#attributes' => array('onclick' => $action ) );
      }
      else {

        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/launch_default' , array( 'query' => 'name=' . $vm_name ) )) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Launch_default'] = array( '#type' => 'submit', '#value' => t('Launch'), '#disabled' => $disabled ,  '#attributes' => array('onclick' => $action ) );
      }
    }
  }
  elseif (strtolower($vm->vm_state) == strtolower('running'  ) 
      ||  strtolower($vm->vm_state) == strtolower('suspended') ) {

    //console should be available for running state only
    if ( strtolower($vm->vm_state) == strtolower('running')
    && user_access('administer xcp')) {

      $console_arr = _xcp_get_console_info_query() ;
      $console_str = isset($console_arr[$vm->opaquereference]['location'] ) ? $console_arr[$vm->opaquereference]['location'] : '' ;
      
      $console_location  = $console_str ;
      $xcp_relative_path = drupal_get_path('module', XCP_CONTEXT ) ;
      $console_url       = $xcp_relative_path . '/xcp_console.inc' ;
      $console_data      = '<H1>Console : ' . $vm_name . '</H1>';
      $close_window      = "<input type=button value=\"Close Console\" onClick=\"javascript:window.close();\">" ;

   // $sesid             = _xcp_login() ;
      $sesid             = _xcp_session_get() ;
      
      $console_applet    = "<applet archive=\"/" . $xcp_relative_path . "/XenServerConsole.jar\" code=com.citrix.xenserver.console.Initialize.class width=800 height=600><param name=SESSION value=\"$sesid\"><param name=URL value=\"$console_location\"><PARAM NAME=USEURL VALUE=\"true\"></applet>" ;

      $arr = array() ;
      $arr['onclick']    = ' popWin = open(\'' . $console_url . '\', \'Console\', \'width=900, height=800\');  popWin.focus();
      popWin.document.write(\'' . $console_data . $close_window . $console_applet . '\') ; return false ; ' ;

      $form['submit_buttons']['Console'] = array( '#type' => 'submit', '#value' => t('Console'),  '#attributes' => array('onclick' => $arr['onclick'] ) );
      
    } //end console condition

    if (strtolower($vm->vm_state) == strtolower('suspended') ) {
    
      if ( $curr_task === XCP_VM_RESUME ) {
  
        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/cancel_task' , array( 'query' => 'name=' . $vm_name ) )) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Resume'] = array( '#type' => 'submit', '#value' => t('Cancel Resume'),  '#attributes' => array('onclick' => $action ) );
      }
      else {
  
        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/resume' , array( 'query' => 'name=' . $vm_name ) )) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Resume'] = array( '#type' => 'submit', '#value' => t('Resume'), '#disabled' => $disabled ,  '#attributes' => array('onclick' => $action ) );
      }
    }
    if (strtolower($vm->vm_state) == strtolower('running') ) {

      if ( $curr_task === XCP_VM_REBOOT ) {

        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/cancel_task' , array( 'query' => 'name=' . $vm_name ) )) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Reboot'] = array( '#type' => 'submit', '#value' => t('Cancel Reboot'),  '#attributes' => array('onclick' => $action ) );
      }
      else {

        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/reboot' , array( 'query' => 'name=' . $vm_name ) )) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Reboot'] = array( '#type' => 'submit', '#value' => t('Reboot'), '#disabled' => $disabled ,  '#attributes' => array('onclick' => $action ) );
      }

      if ( $curr_task === XCP_VM_HARD_REBOOT ) {

        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/cancel_task' , array( 'query' => 'name=' . $vm_name ) )) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Hard_Reboot'] = array( '#type' => 'submit', '#value' => t('Cancel Hard Reboot'),  '#attributes' => array('onclick' => $action ) );
      }
      else {

        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/hard_reboot' , array( 'query' => 'name=' . $vm_name ) )) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Hard_Reboot'] = array( '#type' => 'submit', '#value' => t('Hard Reboot'), '#disabled' => $disabled ,  '#attributes' => array('onclick' => $action ) );
      }
    }
    if ( strtolower($vm->vm_state) != strtolower('suspended') ) {

      if ( $curr_task === XCP_VM_SUSPEND ) {

        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/cancel_task' , array( 'query' => 'name=' . $vm_name ) )) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Suspend'] = array( '#type' => 'submit', '#value' => t('Cancel Suspend'),  '#attributes' => array('onclick' => $action ) );
      }
      else {

        $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/suspend' , array( 'query' => 'name=' . $vm_name ) )) ;
        $action   = "document.forms[0].action='" . $location . "';";
        $form['submit_buttons']['Suspend'] = array( '#type' => 'submit', '#value' => t('Suspend'), '#disabled' => $disabled ,  '#attributes' => array('onclick' => $action ) );
      }
    }

    if ( $curr_task === XCP_VM_TERMINATE ) {
  
      $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/cancel_task' , array( 'query' => 'name=' . $vm_name ) )) ;
      $action   = "document.forms[0].action='" . $location . "';";
      $form['submit_buttons']['Shutdown'] = array( '#type' => 'submit', '#value' => t('Cancel Shutdown'),  '#attributes' => array('onclick' => $action ) );
    }
    else {
  
      $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/shutdown' , array( 'query' => 'name=' . $vm_name ) )) ;
      $action   = "document.forms[0].action='" . $location . "';";
      $form['submit_buttons']['Shutdown'] = array( '#type' => 'submit', '#value' => t('Shutdown'), '#disabled' => $disabled ,  '#attributes' => array('onclick' => $action ) );
    }

    if ( $curr_task === XCP_VM_HARD_SHUTDOWN ) {

      $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/cancel_task' , array( 'query' => 'name=' . $vm_name ) )) ;
      $action   = "document.forms[0].action='" . $location . "';";
      $form['submit_buttons']['Hard_shutdown'] = array( '#type' => 'submit', '#value' => t('Cancel Hard Shutdown'),  '#attributes' => array('onclick' => $action ) );
    }
    else {

      $location = check_url(url(XCP_PATH . '/' . $vm->vmid . '/hard_shutdown' , array( 'query' => 'name=' . $vm_name ) )) ;
      $action   = "document.forms[0].action='" . $location . "';";
      $form['submit_buttons']['Hard_shutdown'] = array( '#type' => 'submit', '#value' => t('Hard Shutdown'), '#disabled' => $disabled ,  '#attributes' => array('onclick' => $action ) );
    }
  }

  if (strtolower($vm->vm_state) == strtolower('halted') ) {

    if ( $curr_task === XCP_VM_DESTROY ) {

      $location    = check_url(url(XCP_PATH . '/' . $vm->vmid . '/cancel_task' , array( 'query' => 'name=' . $vm_name ) )) ;
      $action      = "document.forms[0].action='" . $location . "';";
      $confirm_msg = cloud_get_messagebox( t('Are you sure you want to cancel the destroy request for VM  @vm_name ?' , array('@vm_name' => $vm_name ) ) , $action ) ;
      $form['submit_buttons']['Destroy'] = array( '#type' => 'submit', '#value' => t('Cancel Destroy'),  '#attributes' => array('onclick' => $confirm_msg ) );
    }
    elseif (user_access('administer xcp')) {

      $location    = check_url(url(XCP_PATH . '/' . $vm->vmid . '/destroy' , array( 'query' => 'name=' . $vm_name ) )) ;
      $action      = "document.forms[0].action='" . $location . "';";
      $confirm_msg = cloud_get_messagebox( t('Are you sure you want to destroy the VM  @vm_name ?' , array('@vm_name' => $vm_name ) ) , $action ) ;
      $form['submit_buttons']['Destroy'] = array( '#type' => 'submit', '#value' => t('Destroy'), '#disabled' => $disabled ,  '#attributes' => array('onclick' => $confirm_msg ) );
    }
  }

  $form['submit_buttons']['List VMs'] = array('#type' => 'submit', '#value' => t('List VMs'));
    
  $form['header'] = array(

    '#type'  => 'value',  
    '#value' => array(
     array('data' => t('Name')  ), 
     array('data' => t('ID')    ), 
     array('data' => t('Time')  ), 
     array('data' => t('Action')),
    )
  );

  $query_args = array(
    $vm->opaquereference,
  ) ;
  $query = _xcp_get_describe_snapshot_query() ;
  $result = db_query( $query , $query_args );

  $form['SS_Header_Fieldset'] = array(
    '#type'        => 'fieldset',  
    '#title'       => t('Snapshot History'),  
    '#collapsible' => TRUE,  
    '#collapsed'   => FALSE,  
  );

  while ($node = db_fetch_object($result)) {

    $form['SS_Header_Fieldset']['ss_name'][$node->uuid] = array('#value' => t( $node->name ) ) ;
    $form['SS_Header_Fieldset']['ss_id'  ][$node->uuid] = array('#value' => t( $node->uuid ) ) ;
    $form['SS_Header_Fieldset']['ss_time'][$node->uuid] = array('#value' => t( $mysqldate = date( 'Y-m-d H:i:s', $node->snapshot_time  ) ) ) ;
  }

  if (empty($form['SS_Header_Fieldset']['ss_name'])) {

    $form['SS_Header_Fieldset']['#collapsed'] = TRUE ;
  }

  return $form ;
}


function theme_xcp_display_vm_info($form) {

  $output  = '' ;
  $output .= drupal_render($form['submit_buttons']);
  
  $rows = array(
    array(
      drupal_render($form['Instance_Name'        ]['Name_label']),
      drupal_render($form['Instance_Name_details']              )
    . drupal_render($form['Instance_Name_details']['Name_text'] )
    . drupal_render($form['Instance_Name_details']['Update'   ] )
    ),
    array(
      drupal_render($form['Instance_state']['state_label'] ),
      drupal_render($form['Instance_state']['state_text' ] ),
    ),
    array(
      drupal_render($form['Instance_User']['User_label' ] ),
      drupal_render($form['Instance_User']                )
    . drupal_render($form['Instance_User']['User_select'] )
    . drupal_render($form['Instance_User']['Assign'     ] ),
    ),
    array(
      drupal_render($form['Instance_ip']['ip_label'] ),
      drupal_render($form['Instance_ip']['ip_text' ] ),
    ),  
    array(
      drupal_render($form['Instance_host_ip']['host_ip_label'] ),
      drupal_render($form['Instance_host_ip']['host_ip_text' ] ),
    ),
    array(
      drupal_render($form['Instance_lock']['lock_label']),
      drupal_render($form['Instance_lock_details'])
    . drupal_render($form['Instance_lock_details']['lock_text'])
    . drupal_render($form['Instance_lock_details']['submit'   ])
    ),
    array(
      drupal_render($form['Instance_pool']['pool_label'] ),
      drupal_render($form['Instance_pool']['pool_text' ] ),
    ),
    array(
      drupal_render($form['Instance_id']['id_label'] ),
      drupal_render($form['Instance_id']['id_text' ] ),
    ),
    array(
      drupal_render($form['Instance_launch_time']['launch_time_label'] ),
      drupal_render($form['Instance_launch_time']['launch_time_text' ] ),
    ),
    array(
      drupal_render($form['Instance_runtime']['runtime_label'] ),
      drupal_render($form['Instance_runtime']['runtime_text' ] ),
    ),
    array(
      drupal_render($form['Instance_network']['Network_label' ] ),
      drupal_render($form['Instance_network'])
    . drupal_render($form['Instance_network']['Network_select'] )
    . drupal_render($form['Instance_network']['Add'           ] )
    ),
    array(
      drupal_render($form['save_button']                       ),
      ''                                                        ,
    ),
  ) ;

  $table = theme('table', NULL, $rows );
  $form['fieldset_vm_info']['#children'] = $table;

//cf. Waning by Coder module: Potential problem: when FAPI element '#type' is set to 'markup' (default), '#value' only accepts filtered text, be sure to use check_plain(), filter_xss() or similar to ensure your $variable is fully sanitized.
//$form['fieldset_vm_info']['list'] = array('#type' => 'markup', '#value' => $table);

  $output .= drupal_render($form['fieldset_vm_info']);
  
  if (isset($form['vif_details_data']) ) {

    $cnt  = 0 ;
    $rows = array();

    foreach ($form['vif_details_data'] as $sg_key => $details_data) {

      if (strpos($sg_key , 'vif_details' ) === FALSE ) {

        continue ;
      }

      $rows[] = array(
        drupal_render($form['vif_details_data']['vif_details_' . $cnt]['uuid'   ]),
        drupal_render($form['vif_details_data']['vif_details_' . $cnt]['device' ]),
        drupal_render($form['vif_details_data']['vif_details_' . $cnt]['mac'    ]),
        drupal_render($form['vif_details_data']['vif_details_' . $cnt]['ip'     ]),
        drupal_render($form['vif_details_data']['vif_details_' . $cnt]['network']),
        drupal_render($form['vif_details_data']['vif_details_' . $cnt]['active' ]),
        drupal_render($form['vif_details_data']['vif_details_' . $cnt]['button' ]),
      ) ;

      $cnt++ ;
    }

    // Header
    
    $table = theme('table', $form['vif_header']['#value'] , $rows );
    $form['fieldset_vif']['#children'] = $table;

  //cf. Waning by Coder module: Potential problem: when FAPI element '#type' is set to 'markup' (default), '#value' only accepts filtered text, be sure to use check_plain(), filter_xss() or similar to ensure your $variable is fully sanitized.
  //$form['fieldset_vif']['list'] = array('#type' => 'markup' , '#value' => $table);
  }

  $output .= drupal_render($form['fieldset_vif'    ]);
  $output .= drupal_render($form['VM_id'           ]);
  $output .= drupal_render($form['release_uuid'    ]);
  $output .= drupal_render($form['vm_current_state']);

  $prop['onclick'] = cloud_get_messagebox('Are you sure you want to revert the VM?') ;

  $cnt_ss_name = isset($form['SS_Header_Fieldset']['ss_name']) ? count($form['SS_Header_Fieldset']['ss_name']) : 0 ;
  if ( $cnt_ss_name > 0 ) {

    $rows = array() ;
    foreach (element_children($form['SS_Header_Fieldset']['ss_name']) as $key) {

      $ss_tmp_name = isset($form['SS_Header_Fieldset']['ss_name'][$key][0]['#value'])
                   ? $form['SS_Header_Fieldset']['ss_name'][$key][0]['#value']
                   : '' ;
      $rows[] = array(
        drupal_render($form['SS_Header_Fieldset']['ss_name'][$key]),
        drupal_render($form['SS_Header_Fieldset']['ss_id'  ][$key]),
        drupal_render($form['SS_Header_Fieldset']['ss_time'][$key]),
        cloud_display_action(
          'images/icon_play',
          'Launch',
          XCP_PATH . '/' . $key . '/snapshot_revert',
          array('query' => 'ss_name=' . urlencode($ss_tmp_name),
                'html'  => TRUE
          ),
          $prop['onclick']
        ),
      );
    }

    $form['SS_Header_Fieldset']['#children'] = theme('table', $form['header']['#value'], $rows );
    $output .= drupal_render($form['SS_Header_Fieldset']);
  }

  $output .= drupal_render($form);

  return $output;
}


function xcp_display_vm_info_submit($form_id, $form_values) {

  $form_values = $form_values['values'] ;
  $vmid        = $form_values['vm_id' ] ;

  if (empty($vmid)) {

    drupal_set_message( t('VM ID not given.'), 'error' ) ;

    return;
  }

  // Fetch the current VM Info
  $query      = _xcp_get_instance_by_id_query() ;
  $query_args = array(
    $vmid,
  ) ;

  $results = db_query( $query, $query_args );
  $vm      = db_fetch_object($results)  ;
  
  switch ($form_values['op']) {
    
    case t('List VMs'):
      drupal_goto( XCP_PATH ) ;
      break;
    
    case t('Add'):
      _xcp_add_assign_network_vm_task( $form_values['vm_id'] , $form_values['Network_select'] ) ;
      drupal_set_message( check_plain( t('Task added to queue: Assign network. This may require some time.') ) ) ;
      break;
    
    case t('Update Details'):
      
      //-- Updating the Nickname
      
      $vm_name = trim($form_values['Name_text']) ;
      if ( $vm->vm_name !== $vm_name ) { // Name has been changed
  
        // Update the VM Name
        $result = _xcp_rename_vm( $form_values['vm_id'], $vm_name ) ;
        if ( $result ) {
          _xcp_update_name_by_uuid($vmid, $vm_name ) ;
        }
        else {
          drupal_set_message( t('Failed rename of VM') ) ;
        }
      }
      
      //-- Finished updating the Nickname
      
      //-- Assigning user
      
      $user_to_assign = $form_values['User_select'] ;
      $user_to_assign = ($user_to_assign != XCP_CLOUD_NONE)
                      ? $user_to_assign
                      : '' ;
  
      if ( $vm->assigned_to !== $user_to_assign ) { // VM assigned to a User
        $result = _xcp_vm_info_update_db( $vmid , 'assigned_to' , $user_to_assign ) ;
      }
      
      //-- Finished assigning user
      
      //-- Setting the locked status
      
      $status_lock = $form_values['lock_text'] ;
      _xcp_set_lock_status($vmid, $status_lock) ;
      
      //-- Finished setting the locked status
      
      break;
    
    case t('Delete'):
      _xcp_release_network_vm_task( $form_values['vm_id'] , $_REQUEST['release_uuid'] ) ;
      drupal_set_message( check_plain( t('Task added to queue: Release network. This may require some time.') ) ) ;
      break;
    
  }
  
  drupal_set_message(t('VM information updated: @vmid', array('@vmid' => $vmid)));
  
  cloud_audit_user_activity( array(
          'type'    => 'user_activity', 
          'message' => t('VM information updated: @vmid', array('@vmid' => $vmid)),
          'link'    => '',
        )
  );
  
  drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_details' ) ;
  
  return ;

}


/**
 * Launch XCP VM
 *
 * @param $vm_id
 * @param $manually
 * @param $new_vm
 * @param $count
 * @return
 */
function _xcp_launch_vm($vm_id, $manually='', $new_vm='', $count=0) {

  $host_ref = xcp_launch_vm_choose_host() ;
  //$result = _xcp_start_vm('be4d8783-1f93-78ff-efcf-4d65165f7af2' ,   $host_ref ) ;
  if ($manually) {

    $result = _xcp_start_vm($vm_id ,   $host_ref ) ;
    $_REQUEST['new_instance_ids'] = array($vm_id);
    // jshaikh : Commented for Queue implementation
    // _xcp_download_instances_info_xcp($dont_update_collectd='true') ;
  }
  else {

    $launched_instances = array();

    for ($i=0; $i<$count;$i++) {

      $new_vm       = $new_vm?$new_vm:'Array_' . time();
      $result_clone = _xcp_clone_vm($vm_id, $new_vm);
      // jshaikh : Commented for Queue implementation
      // _xcp_download_instances_info_xcp($dont_update_collectd='true') ;
        
      $query = _xcp_get_instance_info();
      $query_args = array(
        'vm_name' ,
        $new_vm   ,
      );
      $result = db_query( $query, $query_args );
      $xcp_obj = db_fetch_object($result);
      $vm_id_new = $xcp_obj->vmid;

      if ($result_clone) {

        $result = _xcp_start_vm($vm_id_new ,   $host_ref ) ;
        $launched_instances[] = $vm_id_new;
      }
    }
    $_REQUEST['new_instance_ids'] = $launched_instances;

    //_xcp_download_instances_info_xcp($dont_update_collectd='true') ;
  }

  _xcp_add_download_vm_info_task() ;

  return $result;
}


function xcp_display_vm_monitor_info($form_submit='' , $vmid='') {
  
  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ;
  }


  $form['VM_id']['vm_id'] = array('#type' => 'hidden', '#value' => $vmid  );

  $query      = _xcp_get_instance_by_id_query() ;
  $query_args = array(
    $vmid,
  ) ;
  $results = db_query( $query, $query_args );

  $vm = db_fetch_object($results)  ;

  if ($vm->vm_state !== "Running" ) {

    $form['Message']  = array('#value' => t( "Graph not available. VM is not running" ) ,
                              '#prefix' => '<div class="container-inline"><br><br><br><b>',
                              '#suffix' => '</div>'
                              ) ;
    return $form ;
  }

  $period_options              = array()      ;
  $period_options['-600'     ] = 'Minutes-10' ;
  $period_options['-1800'    ] = 'Minutes-30' ;
  $period_options['-3600'    ] = 'Hour'       ;
  $period_options['-86400'   ] = 'Day'        ;
  $period_options['-604800'  ] = 'Week'       ;
  $period_options['-2678400' ] = 'Month'      ;
  $period_options['-31622400'] = 'Year'       ;

  
  $def_period = cloud_get_filter_value( $form_submit , 'period_select' ) ;
  if ( $def_period == '' || empty($def_period) )
  $def_period = '-3600' ; // default

  $form['monitor_details'] = array( '#type' => 'fieldset', '#prefix' => '<div class="container-inline">', '#suffix' => '</div>'  );

  $form['monitor_details']['period_label' ] = array( '#type' => 'item'  , '#title'   => t('Period')  );
  $form['monitor_details']['period_select'] = array( '#type' => 'select', '#options' => $period_options ,  '#default_value' => $def_period );
  $form['monitor_details']['period_submit'] = array( '#type' => 'submit', '#value'   => t('Go') );

  $hostname = $vm->vm_ip ;
   
  $pre_domain = substr($hostname ,  0 ,  3 ) ;

  if (strstr(XCP_MONITOR_URL, $pre_domain ) === FALSE ) {

    $all_ip_arr = _xcp_get_all_ip($vmid) ;

    if (empty($all_ip_arr) === FALSE ) {

      foreach ($all_ip_arr as $ip_vm_ele) {

        $pre_domain = substr($ip_vm_ele ,  0 ,  3 ) ;
        if (strstr(XCP_MONITOR_URL, $pre_domain )) {

          $hostname = $ip_vm_ele ;
          break ;
        }
      }
    }
  }

  $sec_period = $def_period ;

  drupal_add_js(drupal_get_path('module', XCP_CONTEXT)
              . CLOUD_PATH_SEPARATOR
              . 'js/xcp_monitor.js'
              , 'module');
              
  $chck_xcp_graph_filename = XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=percent;type_instance=cpu0;begin=$sec_period;TmpParam=" . time()  ;
  
  if ( file_exists($chck_xcp_graph_filename)
  &&   file(       $chck_xcp_graph_filename) ) {

    $graph_xcp_found = TRUE ;
  }
  else {

    $graph_xcp_found = FALSE ;
  }
  
  if ($graph_xcp_found) {
    $str_img = "<div class='padding'><img id='xcp_cpu0' onerror='javascript: this.src=\"/$base/images/graph_error.png\" ;'  src='" . XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=percent;type_instance=cpu0;begin=$sec_period;TmpParam=" . time() . "' alt='Please retry after some time' >";
    $form['xcp_cpu0'] = array( '#prefix' =>  "$str_img" ,  '#type' => 'item' ,    '#suffix' =>  '</img></div>'  );


    $str_img = "<div class='padding'><img id='xcp_memory_internal_free' onerror='javascript: this.src=\"/$base/images/graph_error.png\" ;'  src='" . XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=gauge;type_instance=memory_internal_free;begin=$sec_period;TmpParam=" . time() . "' alt='Please retry after some time' >";
    $form['xcp_memory_internal_free'] = array( '#prefix' =>  "$str_img" ,  '#type' => 'item' ,    '#suffix' =>  '</img></div>'  );


    $str_img = "<div class='padding'><img id='xcp_memory_target' onerror='javascript: this.src=\"/$base/images/graph_error.png\" ;'  src='" . XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=gauge;type_instance=memory_target;begin=$sec_period;TmpParam=" . time() . "' alt='Please retry after some time' >";
    $form['xcp_memory_target'] = array( '#prefix' =>  "$str_img" ,  '#type' => 'item' ,    '#suffix' =>  '</img></div>'  );

    $chck_xcp_graph_filename = XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=gauge;type_instance=vbd_hda_read;begin=$sec_period;TmpParam=" . time()  ;
    if ( file($chck_xcp_graph_filename) ) {

      $str_img = "<div class='padding'><img id='xcp_vbd_hda_read' onerror='javascript: this.src=\"/$base/images/graph_error.png\" ;'  src='" . XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=gauge;type_instance=vbd_hda_read;begin=$sec_period;TmpParam=" . time() . "' alt='Please retry after some time' >";
      $form['xcp_vbd_hda_read'] = array( '#prefix' =>  "$str_img" ,  '#type' => 'item' ,    '#suffix' =>  '</img></div>'  );
    }

    $chck_xcp_graph_filename = XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=gauge;type_instance=vbd_hda_write;begin=$sec_period;TmpParam=" . time()  ;
    if ( file($chck_xcp_graph_filename) ) {

      $str_img = "<div class='padding'><img id='xcp_vbd_hda_write' onerror='javascript: this.src=\"/$base/images/graph_error.png\" ;'  src='" . XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=gauge;type_instance=vbd_hda_write;begin=$sec_period;TmpParam=" . time() . "' alt='Please retry after some time' >";
      $form['xcp_vbd_hda_write'] = array( '#prefix' =>  "$str_img" ,  '#type' => 'item' ,    '#suffix' =>  '</img></div>'  );
    }

    $chck_xcp_graph_filename = XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=gauge;type_instance=vif_1_rx;begin=$sec_period;TmpParam=" . time()  ;
    if ( file($chck_xcp_graph_filename) ) {

      $str_img = "<div class='padding'><img id='xcp_vif_1_rx' onerror='javascript: this.src=\"/$base/images/graph_error.png\" ;'  src='" . XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=gauge;type_instance=vif_1_rx;begin=$sec_period;TmpParam=" . time() . "' alt='Please retry after some time' >";
      $form['xcp_vif_1_rx'] = array( '#prefix' =>  "$str_img" ,  '#type' => 'item' ,    '#suffix' =>  '</img></div>'  );
    }

    $chck_xcp_graph_filename = XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=gauge;type_instance=vif_1_tx;begin=$sec_period;TmpParam=" . time()  ;
    if ( file($chck_xcp_graph_filename) ) {

      $str_img = "<div class='padding'><img id='xcp_vif_1_tx' onerror='javascript: this.src=\"/$base/images/graph_error.png\" ;'  src='" . XCP_MONITOR_URL . "?hostname=$hostname;plugin=xcp_rrd_plugin;type=gauge;type_instance=vif_1_tx;begin=$sec_period;TmpParam=" . time() . "' alt='Please retry after some time' >";
      $form['xcp_vif_1_tx'] = array( '#prefix' =>  "$str_img" ,  '#type' => 'item' ,    '#suffix' =>  '</img></div>'  );
    }

  }
  else {

    $str_img = "<div class='padding'><img id='xcp_cpu0' src=\"/$base/images/graph_error.png\" alt='Please retry after some time' >";
    $form['xcp_cpu0'] = array( '#prefix' =>  "$str_img" ,  '#type' => 'item' ,    '#suffix' =>  '</img></div>'  );
  }

  // $form['TEXT'] = array( '#prefix' =>  "<input type='text' id='jami' value='1' >" ,  '#type' => 'item' );

  // No need to display SNMP Graph
/*
  $chck_file_name = XCP_MONITOR_URL . "?hostname=$hostname;plugin=snmp;type=percent;type_instance=Processor%20Load;begin=$sec_period;TmpParam=" . time()  ;
  if ( file($chck_file_name) ) {
  $graph_found = TRUE ;
  }
  else {
  $graph_found = FALSE ;
  }

  if ($graph_found === TRUE) {

  $str_img = "<div class='padding'><img id='virt_cpu_total' onerror='javascript: this.src=\"/$base/images/graph_error.png\" ;'  src='" . XCP_MONITOR_URL . "?hostname=$hostname;plugin=snmp;type=percent;type_instance=Processor%20Load;begin=$sec_period;TmpParam=" . time() . "' alt='Please retry after some time' >";
  $form['virt_cpu_total'] = array( '#prefix' =>  "$str_img" ,  '#type' => 'item' ,    '#suffix' =>  '</img></div>'  );

  for ($cnt = 7 ; $cnt <=8 ; $cnt ++ ) {
  $str_img = "<div class='padding' id='div_network_traffic_$cnt' ><img id='network_traffic_" . $cnt. "' onerror='javascript: this.src=\"/$base/images/graph_error.png\" ;' src='" . XCP_MONITOR_URL . "?hostname=$hostname;plugin=snmp;type=if_octets;type_instance=ethernet_" . $cnt. ";begin=$sec_period;TmpParam=" . time() . "' alt='Please retry after some time' title='Please retry after some time' >";

  $form['network_traffic_' . $cnt] = array( '#prefix' =>  "$str_img" ,  '#type' => 'item' ,    '#suffix' =>  '</img></div>'  );
  }
  }
  else {
  $str_img = "<div class='padding'><img id='virt_cpu_total' src=\"/$base/images/graph_error.png\" alt='Please retry after some time' >";
  $form['virt_cpu_total'] = array( '#prefix' =>  "$str_img" ,  '#type' => 'item' ,    '#suffix' =>  '</img></div>'  );
  }
*/

  $form['#redirect']  = FALSE;

  return  $form;
}

function theme_xcp_display_vm_monitor_info($form) {

  $output  = '' ;
  $output .= drupal_render($form['VM_id']);
  $output .= drupal_render($form);

  return   $output ;
}


function _xcp_get_HH_list() {

  $hh  = array() ;
  $cnt = 0 ;
  for ($cnt = 0 ; $cnt <= 23 ; $cnt++ ) {

    $hh[$cnt] = str_pad( $cnt, 2, '0', STR_PAD_LEFT );
  }

  return $hh ;
}


function _xcp_get_MM_list() {

  $mm  = array() ;
  $cnt = 0 ;
  for ($cnt = 0 ; $cnt <= 59 ; $cnt++ ) {

    $mm[$cnt] = str_pad( $cnt, 2, '0', STR_PAD_LEFT );
  }

  return $mm ;
}


function _xcp_get_day_tag(&$form, $day, $checked, $default_hh, $default_mm) {

  $form['SS_' . $day][$day . '_check'] = array( '#type' => 'checkbox', '#value'   => $checked           , '#title'         => t($day) ) ;
  $form['SS_' . $day][$day . '_hh'   ] = array( '#type' => 'select'  , '#options' => _xcp_get_HH_list() , '#default_value' => $default_hh );
  $form['SS_' . $day][$day . '_mm'   ] = array( '#type' => 'select'  , '#options' => _xcp_get_MM_list() , '#default_value' => $default_mm );
}


function xcp_display_vm_snapshot_schedule($form_submit='' , $vmid='') {
  
  if ( empty($vmid) ) {
  
    drupal_goto( XCP_PATH ) ;

    return ;
  }
  
  $query      = _xcp_get_instance_by_id_query() ;
  $query_args = array(
    $vmid,
  ) ;
  $results = db_query( $query, $query_args );

  $vm = db_fetch_object($results)  ;

  $form['fieldset_name_details'] = array('#type' => 'fieldset', '#title' => t('Details'));
  
  $form['Instance_Name_details']['Name_label'] = array( '#type' => 'item', '#title' => t('Nickname') );
  $form['Instance_Name_details']['Name_text' ] = array( array('#value' => t( $vm->vm_name ) ) );

  $form['fieldset_schedule_backup'] = array('#type' => 'fieldset', '#title' => t('Schedule Backup'));

  // Display Schedule
  $form['schedule_header'] = array(
    '#type' => 'value',  
    '#value' => array(
      array('data' => t('Day')    ), 
      array('data' => t('Hour')   ), 
      array('data' => t('Minute') ),
    )
  );

  $ss_schedule = _xcp_get_snapshot_schedule_by_id($vmid) ;

  if (empty($ss_schedule) ) {
    _xcp_get_day_tag($form, t('Monday'   ), cloud_get_filter_value( $form_submit , 'Monday_check'    ) , '00' , '00' ) ;
    _xcp_get_day_tag($form, t('Tuesday'  ), cloud_get_filter_value( $form_submit , 'Tuesday_check'   ) , '00' , '00' ) ;
    _xcp_get_day_tag($form, t('Wednesday'), cloud_get_filter_value( $form_submit , 'Wednesday_check' ) , '00' , '00' ) ;
    _xcp_get_day_tag($form, t('Thursday' ), cloud_get_filter_value( $form_submit , 'Thursday_check'  ) , '00' , '00' ) ;
    _xcp_get_day_tag($form, t('Friday'   ), cloud_get_filter_value( $form_submit , 'Friday_check'    ) , '00' , '00' ) ;
    _xcp_get_day_tag($form, t('Saturday' ), cloud_get_filter_value( $form_submit , 'Saturday_check'  ) , '00' , '00' ) ;
    _xcp_get_day_tag($form, t('Sunday'   ), cloud_get_filter_value( $form_submit , 'Sunday_check'    ) , '00' , '00' ) ;
  }
  else {
  
    $is_form_submit = isset( $form_submit['post'] ) ?  sizeof($form_submit['post']) : FALSE ;
    
    $check_var = $is_form_submit ? cloud_get_filter_value( $form_submit , 'Monday_check'    ) : $ss_schedule->monday_check    ;
    _xcp_get_day_tag($form, t('Monday'   ), $check_var , $ss_schedule->monday_time_hh   , $ss_schedule->monday_time_mm    ) ;
    
    $check_var = $is_form_submit ? cloud_get_filter_value( $form_submit , 'Tuesday_check'   ) : $ss_schedule->tuesday_check   ;
    _xcp_get_day_tag($form, t('Tuesday'  ), $check_var , $ss_schedule->tuesday_time_hh  , $ss_schedule->tuesday_time_mm   ) ;
    
    $check_var = $is_form_submit ? cloud_get_filter_value( $form_submit , 'Wednesday_check' ) : $ss_schedule->wednesday_check ;
    _xcp_get_day_tag($form, t('Wednesday'), $check_var , $ss_schedule->wednesday_time_hh, $ss_schedule->wednesday_time_mm ) ;
    
    $check_var = $is_form_submit ? cloud_get_filter_value( $form_submit , 'Thursday_check'  ) : $ss_schedule->thursday_check  ;
    _xcp_get_day_tag($form, t('Thursday' ), $check_var , $ss_schedule->thursday_time_hh , $ss_schedule->thursday_time_mm  ) ;
    
    $check_var = $is_form_submit ? cloud_get_filter_value( $form_submit , 'Friday_check'    ) : $ss_schedule->friday_check    ;
    _xcp_get_day_tag($form, t('Friday'   ), $check_var , $ss_schedule->friday_time_hh   , $ss_schedule->friday_time_mm    ) ;
    
    $check_var = $is_form_submit ? cloud_get_filter_value( $form_submit , 'Saturday_check'  ) : $ss_schedule->saturday_check  ;
    _xcp_get_day_tag($form, t('Saturday' ), $check_var , $ss_schedule->saturday_time_hh , $ss_schedule->saturday_time_mm  ) ;
    
    $check_var = $is_form_submit ? cloud_get_filter_value( $form_submit , 'Sunday_check'    ) : $ss_schedule->sunday_check    ;
    _xcp_get_day_tag($form, t('Sunday'   ), $check_var , $ss_schedule->sunday_time_hh   , $ss_schedule->sunday_time_mm    ) ;
  }

  // End of Display Schedule

  $form['VM_id']['vm_id'] = array('#type' => 'hidden', '#value' => $vmid  );

  $form['submit_buttons'] = array(
    '#prefix' => '<span class="clear"></span><div class="container-inline"><div class="buttons">',
    '#type'   => 'fieldset'    ,  
    '#suffix' => '</div></div>',
  );

  $form['submit_buttons']['Update'  ] = array('#type' => 'submit', '#value' => t('Update'  ));
  $form['submit_buttons']['List VMs'] = array('#type' => 'submit', '#value' => t('List VMs'));

  // Display list of previous snapshots

  return  $form;
}


function _xcp_get_theme_day(&$form, $day) {
  
  $row = array(
    drupal_render($form['SS_' . $day][$day . '_check'] ),
    drupal_render($form['SS_' . $day][$day . '_hh'   ] ),
    drupal_render($form['SS_' . $day][$day . '_mm'   ] ),
  );
    
  return $row ;
}


function theme_xcp_display_vm_snapshot_schedule($form) {

  $rows = array(
    array(
      drupal_render($form['Instance_Name_details']['Name_label'] ),
      drupal_render($form['Instance_Name_details']['Name_text' ] ),
    ),
  );

  $table = theme('table', NULL, $rows );
  $form['fieldset_name_details']['#children'] = $table;

//cf. Waning by Coder module: Potential problem: when FAPI element '#type' is set to 'markup' (default), '#value' only accepts filtered text, be sure to use check_plain(), filter_xss() or similar to ensure your $variable is fully sanitized.
//$form['fieldset_name_details']['list'] = array('#type' => 'markup', '#value' => $table);
  
  
  // Start display of Days
  $rows = array(
    _xcp_get_theme_day($form,  'Monday'    ) ,
    _xcp_get_theme_day($form,  'Tuesday'   ) ,
    _xcp_get_theme_day($form,  'Wednesday' ) ,
    _xcp_get_theme_day($form,  'Thursday'  ) ,
    _xcp_get_theme_day($form,  'Friday'    ) ,
    _xcp_get_theme_day($form,  'Saturday'  ) ,
    _xcp_get_theme_day($form,  'Sunday'    ) ,
  ) ;
  
  $table = theme('table', $form['schedule_header']['#value'], $rows ); // Display of Days
  $form['fieldset_schedule_backup']['#children'] = $table;

//cf. Waning by Coder module: Potential problem: when FAPI element '#type' is set to 'markup' (default), '#value' only accepts filtered text, be sure to use check_plain(), filter_xss() or similar to ensure your $variable is fully sanitized.
//$form['fieldset_schedule_backup']['list'] = array('#type' => 'markup', '#value' => $table);


  $output  = '' ;
  $output .= drupal_render($form['fieldset_name_details'   ]);
  $output .= drupal_render($form['fieldset_schedule_backup']);
  $output .= drupal_render($form['submit_buttons'          ]);
  $output .= drupal_render($form['VM_id'                   ]);
  $output .= drupal_render($form                            );

  return $output;
}

function xcp_display_vm_snapshot_schedule_submit($form_id, $form_values) {

  $form_values = $form_values['values'];
  if ( $form_values['op'] == t('List VMs') ) {

    drupal_goto( XCP_PATH ) ;

    return ;
  }
  elseif ( $form_values['op'] == t('Update') ) {

    $vmid   = $form_values['vm_id'] ;

    $mon_flag   = empty($form_values['Monday_check'   ]) ? FALSE : TRUE ;
    $tue_flag   = empty($form_values['Tuesday_check'  ]) ? FALSE : TRUE ;
    $wed_flag   = empty($form_values['Wednesday_check']) ? FALSE : TRUE ;
    $thurs_flag = empty($form_values['Thursday_check' ]) ? FALSE : TRUE ;
    $fri_flag   = empty($form_values['Friday_check'   ]) ? FALSE : TRUE ;
    $sat_flag   = empty($form_values['Saturday_check' ]) ? FALSE : TRUE ;
    $sun_flag   = empty($form_values['Sunday_check'   ]) ? FALSE : TRUE ;


    $update_val   = array() ;
    $update_val[] = $mon_flag ;
    $update_val[] = $form_values['Monday_hh'   ] ;
    $update_val[] = $form_values['Monday_mm'   ] ;

    $update_val[] = $tue_flag ;
    $update_val[] = $form_values['Tuesday_hh'  ] ;
    $update_val[] = $form_values['Tuesday_mm'  ] ;

    $update_val[] = $wed_flag ;
    $update_val[] = $form_values['Wednesday_hh'] ;
    $update_val[] = $form_values['Wednesday_mm'] ;

    $update_val[] = $thurs_flag ;
    $update_val[] = $form_values['Thursday_hh' ] ;
    $update_val[] = $form_values['Thursday_mm' ] ;

    $update_val[] = $fri_flag ;
    $update_val[] = $form_values['Friday_hh'   ] ;
    $update_val[] = $form_values['Friday_mm'   ] ;

    $update_val[] = $sat_flag ;
    $update_val[] = $form_values['Saturday_hh' ] ;
    $update_val[] = $form_values['Saturday_mm' ] ;

    $update_val[] = $sun_flag ;
    $update_val[] = $form_values['Sunday_hh'   ] ;
    $update_val[] = $form_values['Sunday_mm'   ] ;

    _xcp_update_snapshot_schedule($vmid , $update_val) ;

    drupal_set_message(t('Snapshot schedule updated') );

 // drupal_goto( XCP_PATH ) ;
    drupal_goto( 'clouds/xcp/describe/' . $vmid . '/vm_snapshot' ) ;

    return ;
  }
}

/**
 * Create a new server template of xcp
 *
 * @param $form_submit
 * @param $cloud_context
 * @param $params
 * @return
 */
function xcp_server_templates_new($form_submit='', $cloud_context, $params = array()) {
    
    return _xcp_support_server_templates_new($cloud_context, $params);
}

function xcp_server_templates_new_validate($form_id, $form_values) {
  
  $form_values = $form_values['values'];

  if ( $form_values['op'] == t('Add') || $form_values['op'] == t('Edit') ) {
  
    //print_r($form_values['ssh_keys_select']); die;
    if ( !preg_match(CLOUD_SERVER_TEMPLATES_VALID_NOT_EMPTY, $form_values['name_text']) ) {
      
      form_set_error('', t('You must enter valid Template Name'));
    }
    
    if ( $form_values['image_id_select'] == '' ) {
      
      form_set_error('', t('You must select Image'));
    }
  }
  _cloud_server_templates_new_submit($form_id, $form_values);
}

function _xcp_support_server_templates_new($cloud_context, $params = array()) {
  
  //include js file for Scripts - switching n order from left to right
  drupal_add_js(cloud_get_module_base() . 'js/selectbox.js', 'module');
  drupal_add_js(cloud_get_module_base() . 'js/scripting.js', 'module');
                
  $server_template_id   = !empty($params['templateid']) ? $params['templateid'] : '';
  $action               = t('Add');
  $selected_scripts_ids = array();
  $selected_scripts     = array();
  
  if ($server_template_id) {

    $cloud_type   = cloud_server_templates_get_cloud_type($server_template_id);
    $query        = _cloud_server_templates_get_server_template_details_by_cloud($server_template_id, $cloud_context) ;    
    $result       = db_query( $query );
    $template_obj = db_fetch_object($result);  
    $action       = t('Edit');
    $cloud_type   = $template_obj->cloud_type;
  }  
  
  $cloud_type = isset($cloud_type) ? $cloud_type : $cloud_context ;
  $cloud = $cloud_type;
  $form['name']['name_label'] = array('#type' => 'item'     , '#title'  =>  t('Name')  );
  $form['name']['name_text' ] = array('#type' => 'textfield', '#size' => 100    );
  
  $form['description']['description_label'] = array('#type' => 'item', '#title' => t('Description')  );
  $form['description']['description_text' ] = array('#type' => 'textarea' );
  
  $cloud_type_options = array( $cloud_type ) ; // Only the selected Cloud is to be displayed
  $form['cloud_type']['cloud_type_label'   ] = array('#type'  =>  'item', '#title'  =>  t('Cloud Type')  );
//$form['cloud_type']['cloud_type_select'  ] = array('#type'  =>  'select', '#options'  =>  $cloud_type_options );
  $form['cloud_type']['cloud_type_display' ] = array( array('#value' => check_plain( $cloud_context ) ) );
  $form['cloud_type']['cloud_type_select'  ] = array('#type' => 'hidden', '#value' => isset_variable($cloud_context));
  //$form['cloud_type']['cloud_type_select']['#default_value'] = isset_variable($cloud_type);
  if ($action != t('Edit') ) {
    //$form['cloud_type']['cloud_type_select']['#attributes'] = array('onChange'  =>  'javaScript:document.forms[0].submit()');
  }  

  $ssh_key_options = array( XCP_CONTEXT => XCP_CONTEXT );
  $form['ssh_keys_details']['ssh_keys_label' ] = array('#type' => 'item'  , '#title'   => t('SSH Key') );
  $form['ssh_keys_details']['ssh_keys_select'] = array('#type' => 'select', '#options' => $ssh_key_options );
  
  $xcp_available_zone_options = _xcp_get_pool_options() ;
  $zone_options = $xcp_available_zone_options;
  $form['zone_details']['zone_label' ] = array('#type' => 'item'  , '#title'   => t('Pool') );
  $form['zone_details']['zone_select'] = array('#type' => 'select', '#options' => $zone_options );
  
  
  $server_template_id = isset( $_REQUEST['templateid'] ) ? $_REQUEST['templateid'] : $server_template_id ;
  
  if ($server_template_id) { // edit case

    $cloud_type = cloud_server_templates_get_cloud_type($server_template_id);
    $form['templateid'     ] = array('#type' => 'hidden', '#value' => $server_template_id );
    $form['name'           ]['name_text'         ]['#default_value'] = isset_variable($template_obj->templatenickname);
    $form['description'    ]['description_text'  ]['#default_value'] = isset_variable($template_obj->description     );
    $form['cloud_type'     ]['cloud_type_display']['#default_value'] = isset_variable($template_obj->cloud_type      );
    $form['cloud_type'     ]['cloud_type_display']['#attributes'] = array('disabled' => TRUE );
    $form['cloud_type_val' ] = array('#type' => 'hidden', '#value' => isset_variable($template_obj->cloud_type)      ); 
    $form['ssh_keys_select'] = array('#type' => 'hidden', '#value' => isset_variable($template_obj->key_name)        );
    $_REQUEST['cloud_type' ] = $template_obj->cloud_type;
    $image_options = _xcp_get_image_options($cloud_type) ;
 // $nodes   = _cloud_server_templates_get_cloud_info_byid($template_obj->image_id, $cloud_type) ;
    $vm_name = _xcp_get_vm_by_id($template_obj->image_id) ;
    $image_options[$template_obj->image_id] = $vm_name ;

    $form['image_id']['image_id_label' ] = array('#type' => 'item'  , '#title'   => t('Image ID')  );
    $form['image_id']['image_id_select'] = array('#type' => 'select', '#options' => $image_options );
    $form['image_id']['image_id_select']['#default_value'] = isset_variable($template_obj->image_id );

    $form['ssh_keys_details']['ssh_keys_select']['#default_value'] = isset_variable($template_obj->key_name);
    $form['zone_details']['zone_select']['#default_value'] = isset_variable($template_obj->placement);

    $selected_scripts   = array();
    $selected_alerts    = array();
    $selected_alertsIds = array();
    $result1 = db_query( $query, $query_args );

    while ($template_obj = db_fetch_object($result1)) {
       
      if ($template_obj->script_id) {
        $selected_scripts[$template_obj->type][$template_obj->script_id] = $template_obj->script_name;
        $selected_scripts_ids[] = $template_obj->script_id;
      }   
       
      if ($template_obj->alert_id) {
        $selected_alerts[$template_obj->alert_id] = $template_obj->alert_name;
        $selected_alertsIds[] = $template_obj->alert_id;
      }   
    }

    $scripting_options = cloud_server_templates_get_scripting_options();
    foreach ($scripting_options['CLOUD_SCRIPTING_TYPE_OPTIONS'] as $script => $script_val) {
      $form[$script][$script . '_content'][$script . '_selected']['#options'] = $selected_scripts[$script];
    }  
    
  }
  else {

    $image_options = _xcp_get_image_options($cloud) ;
    $form['image_id']['image_id_label' ] = array('#type' => 'item'  , '#title'   => t('Image ID')  );
    $form['image_id']['image_id_select'] = array('#type' => 'select', '#options' => $image_options );
  }
  
  //on change cloud type case
  if (isset( $_REQUEST['cloud_type']) && $action != t('Edit')) {
  
    $form['name'       ]['name_text'        ]['#default_value'] = isset_variable($_REQUEST['name_text'       ]);
    $form['description']['description_text' ]['#default_value'] = isset_variable($_REQUEST['description_text']);
    $form['cloud_type' ]['cloud_type_select']['#default_value'] = isset_variable($_REQUEST['cloud_type'      ]);
  }  
  
/*
  if (user_access('set scripts and alerts')) { //permission start
    
    // scripting elements
    if (module_exists('cloud_scripting')) {
      $scripting_options = cloud_server_templates_get_scripting_options();
      foreach ($scripting_options['CLOUD_SCRIPTING_TYPE_OPTIONS'] as $script => $script_val) {
        //$selected_scripts_ids = (count($selected_scripts_ids)>0)?$selected_scripts_ids:$_REQUEST[$script . '_selected'];
        $script_options = array();
        $script_options = cloud_get_all_scripts($script);
        //print_r();
        $script_keys = array_keys($script_options);
        foreach ($selected_scripts_ids as $id) {
          if (in_array($id, $script_keys)) {
            //print $id;die;
            unset($script_options[$id]);
          }  
        }
        
        $form[$script][$script . '_label'] = array('#type'  =>  'item', '#title'  =>  t( $script_val . ' Script')  );
        //$form['script_id']['script_id_select'] = array('#type'  =>  'select', '#options'  =>  $script_options,  '#multiple' => TRUE );
        //$form['script_id']['script_id_select'] = array('#type'  =>  'select', '#options'  =>  $script_options,  '#multiple' => TRUE );
        
        $script_elem = array();
        $script_elem = array(
              '#type'  =>  'fieldset', '#prefix'  =>  '<div class="container-inline">', '#suffix'  =>  '</div>'
          );  
        $script_elem[$script . '_select'  ] = array( '#id'   => $script . '_select'  , '#type' => 'select', '#options' => $script_options,  '#multiple' => TRUE, '#attributes' => array('style' => 'width:250px;margin:5px 0 5px 0;')  );
        $script_elem[$script . '_selected'] = array( '#id'   => $script . '_selected', '#type' => 'select', '#options' => array(), '#multiple' => TRUE, '#attributes' => array('style' => 'width:250px;margin:5px 0 5px 0;')  );
        $script_elem[$script . '_add'     ] = array( '#type' => 'button', '#name' => 'addState'   , '#value' => '>>', '#attributes' => array('onclick' => 'javascript:return moveElement(' . $script . '_select, ' . $script . '_selected)') );
        $script_elem[$script . '_remove'  ] = array( '#type' => 'button', '#name' => 'removeState', '#value' => '<<', '#attributes' => array('onclick' => 'javascript:return moveElement(' . $script . '_selected, ' . $script . '_select)') );
        $script_elem[$script . '_up'      ] = array( '#type' => 'button', '#name' => 'upState'    , '#value' => '^', '#attributes' => array('onclick' => 'javascript:return moveElementUp(' . $script . '_selected)') );
        $script_elem[$script . '_down'    ] = array( '#type' => 'button', '#name' => 'downState'  , '#value' => 'v', '#attributes' => array('onclick' => 'javascript:return moveElementDown(' . $script . '_selected)') );
        $form[$script][$script . '_content'] = $script_elem;
        //print_r($_REQUEST[$script . '_selected']);
        $form[$script][$script . '_content'][$script . '_selected']['#options'] = is_array($selected_scripts[$script])?$selected_scripts[$script]:array();
      }
    }  
    /// scripting end
    
    //alert element
    if (module_exists('cloud_alerts')) {
      $alert_options = _cloud_alerts_get_all();
      $alert_keys = array_keys($alert_options);
      if (is_array($selected_alertsIds) && count($selected_alertsIds)>0) {
        foreach ($selected_alertsIds as $id) {
          if (in_array($id, $alert_keys)) {
            unset($alert_options[$id]);
          }  
        }
      }  
    
      $form['alert_id']['alert_id_label'] = array('#type'  =>  'item', '#title'  =>  t('Alerts')  );
      $alert_elem = array();
      $alert_elem = array(
              '#type'  =>  'fieldset', '#prefix'  =>  '<div class="container-inline">', '#suffix'  =>  '</div>'
          );  
      $alert_elem['alert_id_select'  ] = array( '#id'   => 'alert_id_select', '#type'   => 'select', '#options'  =>  $alert_options,  '#multiple' => TRUE, '#attributes' => array('style' => 'width:250px;margin:5px 0 5px 0;')  );
      $alert_elem['alert_id_add'     ] = array( '#type' => 'button', '#name' => 'addAlert', '#value' => '>>', '#attributes' => array('onclick' => 'javascript:return moveElement(alert_id_select, alert_id_selected)') );
      $alert_elem['alert_id_remove'  ] = array( '#type' => 'button', '#name' => 'removeAlert', '#value' => '<<', '#attributes' => array('onclick' => 'javascript:return moveElement(alert_id_selected, alert_id_select)') );    
      $alert_elem['alert_id_selected'] = array( '#id'   => 'alert_id_selected', '#type' => 'select', '#options'  =>  array(), '#multiple' => TRUE, '#attributes' => array('style' => 'width:250px;margin:5px 0 5px 0;')  );
      $form['alert_id']['alert_id_content'] = $alert_elem;
      $form['alert_id']['alert_id_content']['alert_id_selected']['#options'] = is_array($selected_alerts)?$selected_alerts:array();
    }
    /// alert end
  }//permission end
*/

  $form['submit_buttons'] = array(
    '#type'   => 'fieldset',  
    '#prefix' => '<span class="clear"></span><div class="container-inline"><div class="buttons">', '#suffix'  =>  '</div></div>'
  );
          
  $form['submit_buttons'][$action ] = array( '#type' => 'submit', '#value' => t($action), '#attributes' => array('onclick' => 'javascript:selectAllOptions(boot_selected);selectAllOptions(operational_selected);selectAllOptions(termination_selected);selectAllOptions(alert_id_selected)') );
  $form['submit_buttons']['Cancel'] = array( '#type' => 'submit', '#value' => t('Cancel') );
    
  return $form ;
}


function xcp_server_templates_view($form_submit='', $cloud_context, $params = array()) {

  $server_template_id   = !empty($params['templateid']) ? $params['templateid'] : '';
  $selected_scripts_ids = array();
  $selected_scripts     = array();
  $cloud_type           = '';
  $action               = t('Add');

  if ($server_template_id) {

    $cloud_type   = cloud_server_templates_get_cloud_type($server_template_id);
    $query        = _cloud_server_templates_get_server_template_details_by_cloud($server_template_id, $cloud_context) ;    
    $result       = db_query( $query );
    $template_obj = db_fetch_object($result); 
    $action       = t('Edit');    
    $cloud_type   = $template_obj->cloud_type;
  }  
  
  $cloud_type = $cloud_type ? $cloud_type : $_REQUEST['cloud_type'] ;

  $form['name']['name_label'] = array( '#type' => 'item'     , '#title' => t('Name')  );
  $form['name']['name_text' ] = array( '#type' => 'textfield', '#size'  =>   100   );
  
  $form['description']['description_label'] = array( '#type' => 'item', '#title' => t('Description') );
  $form['description']['description_text' ] = array( '#type' => 'textarea' );
  
  $cloud_type_options = array( $cloud_type ) ;

  $form['cloud_type']['cloud_type_label' ] = array( '#type' => 'item'  , '#title'   => t('Cloud Type')     );
  $form['cloud_type']['cloud_type_select'] = array( '#type' => 'select', '#options' => $cloud_type_options );
  
  $ssh_key_options = cloud_get_users() ;
  $form['ssh_keys_details']['ssh_keys_label' ] = array( '#type' => 'item'  , '#title'   => t('User')        );
  $form['ssh_keys_details']['ssh_keys_select'] = array( '#type' => 'select', '#options' => $ssh_key_options );
  
  $zone_options = _xcp_get_pool_options() ;
  $form['zone_details']['zone_label' ] = array( '#type' => 'item'  , '#title'   => t('Pool')     );
  $form['zone_details']['zone_select'] = array( '#type' => 'select', '#options' => $zone_options );
  
  
  $image_options = _xcp_get_image_options($cloud_type) ;
  $image_options_keys = array_keys($image_options);
  
  $form['image_id']['image_id_label' ] = array( '#type' => 'item'  , '#title'   => t('Image')  );
  $form['image_id']['image_id_select'] = array( '#type' => 'select', '#options' => $image_options);
  
  
  if ($server_template_id) { // edit case

    $cloud_type = cloud_server_templates_get_cloud_type($server_template_id);
    $template_name = $template_obj->templatenickname;
    $cloud_type = $template_obj->cloud_type;
    $cloud_name_list = cloud_get_all_clouds_display_name();
    $form['id'] = array( '#type' => 'hidden', '#value' => $server_template_id );
    $form['name'       ]['name_text'        ] = array( array('#value' => t( isset_variable($template_obj->templatenickname  ) ) ) ) ;
    $form['description']['description_text' ] = array( array('#value' => t( isset_variable($template_obj->description       ) ) ) ) ;
    $form['cloud_type' ]['cloud_type_select'] = array( array('#value' => t( isset_variable($cloud_name_list[$cloud_context] ) ) ) ) ;

    // $nodes =  _cloud_server_templates_get_cloud_info_byid($template_obj->image_id, $cloud_type) ;
    $node_name =  $nodes->vm_name . ' ( ' .  $nodes->host_ip . ' )'; ;
    
    $form['image_id'        ]['image_id_select'] = array( array('#value' => t( isset_variable($template_obj->image_id      ) ) ) ) ;
    $form['ssh_keys_details']['ssh_keys_select'    ] = array( array('#value' => t( isset_variable($template_obj->key_name  ) ) ) ) ;
    $form['zone_details'    ]['zone_select'        ] = array( array('#value' => t( isset_variable($template_obj->placement)  ) ) ) ;
    
/*
    if (module_exists('cloud_scripting')) {
    
      $selected_scripts = array();
      $selected_alerts  = array();
      $result1 = db_query( $query, $query_args );

      while ($template_obj = db_fetch_object($result1)) {

        $selected_scripts[$template_obj->type][$template_obj->script_id] = $template_obj->script_name;
        $selected_scripts_ids[] = $template_obj->script_id;
        $selected_alerts[$template_obj->alert_id] = $template_obj->alert_name;
        $selected_alertsIds[] = $template_obj->alert_id;
      }
      $scripting_options = cloud_server_templates_get_scripting_options();
      foreach ($scripting_options['CLOUD_SCRIPTING_TYPE_OPTIONS'] as $script => $script_val) {
       
        $form[$script][$script . '_label'] = array(
             '#type'  =>  'item', '#title'  =>  $script_val . ' Script'  );
        $script_elem = array(
          '#type'   => 'fieldset',
          '#prefix' => '<div class="container-inline">',
          '#suffix' => '</div>',
        );  
        $script_elem[$script . '_selected'] =  array( array('#value'  =>  t( isset_variable(@implode(',', $selected_scripts[$script])) ) ) );
        $form[$script][$script . '_content'] = $script_elem;
      }
    }   
     
    if (module_exists('cloud_alerts')) {

      $form['alert_id']['alert_id_label'] = array('#type'  =>  'item', '#title'  =>  t('Alerts')  );
      $alert_elem = array();
      $alert_elem = array(
             '#type'   => 'fieldset',
             '#prefix' => '<div class="container-inline">',
             '#suffix' => '</div>',
      );
      $alert_elem['alert_id_selected'] =  array( array('#value'  =>  t( isset_variable(implode(',', $selected_alerts)) ) ) );
      $form['alert_id']['alert_id_content'] = $alert_elem;
    }
*/ 
  }

  //on change cloud type case
  if ($_REQUEST['cloud_type']
  && $action != t('Edit')) {
    
    $form['name'       ]['name_text'        ]['#default_value'] = isset_variable($_REQUEST['name_text'        ]);
    $form['description']['description_text' ]['#default_value'] = isset_variable($_REQUEST['description_text' ]);
    $form['cloud_type' ]['cloud_type_select']['#default_value'] = isset_variable($_REQUEST['cloud_type'       ]);
  }  
  
  $form['submit_buttons'] = array(
          '#type'   => 'fieldset',  
          '#prefix' => '<span class="clear"></span><div class="container-inline"><div class="buttons">',
          '#suffix' => '</div></div>',
          );
  
  if (user_access('delete server template')) {

    $confirm_msg = cloud_get_messagebox('Are you sure you want to delete the template "' . $template_name . '" ?') ;    
    $location    = check_url(url(CLOUD_SERVER_TEMPLATES_PATH . '/delete/' . $cloud_context)) . '&id=' . $server_template_id;
    $action      = "document.forms[0].action='" . $location . "';";
    $onclick     = $action . $confirm_msg;
    $form['submit_buttons']['Delete'] = array( '#type' => 'submit', '#value' => t('Delete'),  '#attributes' => array('onclick' => $onclick) );
   }

  if (user_access('edit server template')) {

    $location = check_url(url(CLOUD_SERVER_TEMPLATES_PATH . '/create/' . $cloud_context)) . '&id=' . $server_template_id;
    $action   = "document.forms[0].action='" . $location . "';";
    $onclick  = $action;
    $form['submit_buttons']['Edit'] = array( '#type' => 'submit', '#value' => t('Edit'),  '#attributes' => array('onclick' => $onclick) );
  }  
          
  $form['submit_buttons']['List VMs'] = array( '#type' => 'submit', '#value' => t('List VMs') );

  return $form ;
}

function xcp_server_templates_view_validate($form_id, $form_values) {

  $form_values = $form_values['values'];
  _cloud_server_templates_view_submit($form_id, $form_values);
}

/*
 * Update host entries in the monitoring file
 *
 */ 
function _xcp_update_snmp_host_entries_with_os($op, $dns, $osstr, $host_str, $vm_str, $master, $xcp_userID, $xcp_password ) {

  cloud_log_to_db('instance_monitor_url' , XCP_MONITOR_URL);
  $data = array(
    'op'           => $op       , 
    'dns'          => $dns      , 
    'osstr'        => $osstr    , 
    'xcp_host_str' => $host_str , 
    'xcp_vm_str'   => $vm_str   , 
    'master'       => $master   , 
    XCP_CONTEXT . '_user_id'  => $xcp_userID, 
    XCP_CONTEXT . '_password' => $xcp_password, 
  );

  $url = XCP_MONITOR_URL;

  if ( empty(    $url)
  ||   valid_url($url, TRUE ) === FALSE ) {
    cloud_log_to_db('INSTANCE_MONITOR_URL IS EMPTY' , XCP_MONITOR_URL);

    return ;
  }

  $url  = parse_url($url);
  $host = $url['host'];
  $host = 'http://' . $host . '/';

  list($header, $content) = cloud_post_request(
    $host . XCP_MONITORING_SERVER_MANAGER_FILE , 
       'drupal server', 
        $data
  );
  cloud_log_to_db('RRD_SERVER_CONTENT', $content);

  return $content;
}


function _xcp_cloud_terminate_array_instance($instance_id) {


  $terminate_instances = array(
    $instance_id,
  ) ;
  
  $result = _xcp_shutdown_vm($instance_id) ;
  _xcp_destroy_vm($instance_id) ;
  
  if ($result->code == 200
  ||  $result) {
      _xcp_save_terminate_instance($result) ;
  }
  else {
    drupal_set_message( check_plain( t('There was a problem while trying to terminate the instance: @instance_name', array('@instance_name' => $instance_name) ) ), 'error' );
  }

  return;
}

/**
 * Display the Queue items.
 * Queue is for XCP Tasks
 * 
 * @return
 */
function _xcp_display_queue_items() {

  $out =  '' ;

  $task_list = _xcp_get_task_list() ;
  
  $xcp_task_status_message = _xcp_get_task_status_message() ;
  $xcp_task_message        = _xcp_get_task_message() ; 
  
  foreach ($task_list as $key => $task_details) {

    $date_updated   = date_create(             $task_details['updated']) ;
    $operation_name = $xcp_task_message[       $task_details['task'   ]] ;
    $status         = $xcp_task_status_message[$task_details['status' ]] ;

    $vm_name        = ' ' . _xcp_get_vm_by_id($task_details['uuid']) . ' - ' ;
    $operation_name = $vm_name . $operation_name;
    $str_msg        = date_format($date_updated, 'Y-m-d H:i') . '<br />'
                                . $operation_name . ': ' . $status ;
    if (strlen($str_msg) > 24 ) {
      $str_msg = wordwrap( $str_msg, 24, "\n", TRUE ) ;
    }

    $out .= "<div class=\"xcp-line-height-160\">$str_msg</div>" ;
    $out .= "<div class=\"xcp-line-height-80\"><br /></div>"    ;
  }

  return $out;
}


/**
 * XCP has a Task Queue.
 * Check whether there is any task in progress.
 * Process the Next Task in Queue
 * 
 * @return
 */
function _xcp_process_queue() {
  
  $prev_task    = NULL ;
  $task_details = NULL ;

  while (TRUE) {

    $in_progress_task =  _xcp_get_next_task_in_progress() ;

    if (empty($in_progress_task) == FALSE
    &&  count($in_progress_task) > 0 ) {
      if ($in_progress_task['time_running'] > 5 ) {
        _xcp_update_task_status( $in_progress_task['qid'], 'Task failed. Timestamp expierd. Took more time than expected. ' ,  XCP_TASK_STATUS_FAILED) ;
      }
      else {
        // Already one task in Progress.
        _xcp_check_progress($in_progress_task) ;

        return ;
      }
    }

    $prev_task = $task_details ;
    $task_details = _xcp_get_next_task_to_exec() ;
    if (empty($task_details)
    || count($task_details) === 0 ) {

      return ;
    }

    $qid  = $task_details['qid' ] ;
    $uuid = $task_details['uuid'] ;

    if ($task_details['task'] ===  XCP_VM_TERMINATE  ) {

      _xcp_update_task_status($qid, 'Termination of $uuid in progress ' ,  XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_shutdown_vm_task($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_HARD_SHUTDOWN  ) {

      _xcp_update_task_status($qid, 'Termination of $uuid in progress ' ,  XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_hard_shutdown_vm_task($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_HARD_REBOOT  ) {

      _xcp_update_task_status($qid, 'Reboot of $uuid in progress ' , XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_hard_reboot_vm_task($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_REBOOT  ) {

      _xcp_update_task_status($qid, 'Reboot of $uuid in progress ' , XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_reboot_vm_task($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_CLONE  ) {

      _xcp_update_task_status($qid, 'Cloning of $uuid in progress ' , XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_clone_vm_task($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_DESTROY  ) {

      _xcp_update_task_status($qid, 'Destroying $uuid in progress ' , XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_destroy_vm_task($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_SUSPEND  ) {

      _xcp_update_task_status($qid, 'Suspension of $uuid in progress ' , XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_suspend_vm_task($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_LAUNCH  ) {

      _xcp_update_task_status($qid, 'Launch of $uuid in progress ' , XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_launch_vm_task($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_RESUME ) {

      _xcp_update_task_status($qid, 'Resume of $uuid in progress ' ,  XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_resume_vm_task($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_SS_REVERT  ) {

      _xcp_update_task_status($qid, 'Revert of $uuid in progress ' , XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_revert_ss_task($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_SNAPSHOT  ) {

      _xcp_update_task_status($qid, 'Snapshot of $uuid in progress ' , XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_snapshot_vm($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_INFO_DOWNLOAD  ) {

      // In case Previous task was also Download then skip that Task
      if ($prev_task !== NULL
      && $prev_task['task'] ===  XCP_VM_INFO_DOWNLOAD  ) {

        if (isset($prev_task['operation_result']) && $prev_task['operation_result'] === FALSE ) {

          _xcp_update_task_status($qid, 'Download of VM Info Failed '  , XCP_TASK_STATUS_SKIPPED ) ;
        }
        else {

          _xcp_update_task_status($qid, 'Download of VM Info Complete ',  XCP_TASK_STATUS_SKIPPED ) ;
        }
        
        continue ;
      }

      _xcp_update_task_status($qid, 'Download of VM Info in progress ', XCP_TASK_STATUS_IN_PROGRESS) ;
      $task_details['operation_result'] = _xcp_exec_download_vm_info($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_NETWORK_ASSIGN  ) {

      _xcp_update_task_status($qid, 'Assign network to VM in progress ' , XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_assign_network_vm($task_details) ;
      
      continue ;
    }
    elseif ($task_details['task'] ===  XCP_VM_NETWORK_RELEASE  ) {

      _xcp_update_task_status($qid, 'Release network in progress ' , XCP_TASK_STATUS_IN_PROGRESS) ;
      _xcp_exec_release_network_vm($task_details) ;

      continue ;
    }
  }
}


function _xcp_fetch_data($module) {

  // jshaikh : Commented for Queue implementation
  _xcp_add_download_vm_info_task() ;

  drupal_goto( XCP_PATH ) ;
}



function _xcp_schedule_snapshot_tasks() {

  $current_day = date('l') ;
  $current_hh  = date('G') ;
  $current_mm  = date('i') ; 
  $ss_record   = _xcp_get_snapshot_schedule_by_weekday($current_day, $current_hh, $current_mm) ;

  foreach ($ss_record as $ss_schedule_record) {
    $vm_id = $ss_schedule_record->vmid ;
    _xcp_update_last_scheduled_snapshot($vm_id) ;
    _xcp_add_snapshot_vm_task($vm_id) ;
  }
}


function _xcp_get_task_message() {

  $xcp_task_message  = array(

    XCP_VM_LAUNCH               => 'Launch'          , 
    XCP_VM_TERMINATE            => 'Terminate'       , 
    XCP_VM_HARD_SHUTDOWN        => 'Hard Shutdown'   , 
    XCP_VM_HARD_REBOOT          => 'Hard Reboot'     , 
    XCP_VM_SUSPEND              => 'Suspend'         ,
    XCP_VM_RESUME               => 'Resume'          ,
    XCP_VM_REBOOT               => 'Reboot'          , 
    XCP_VM_CLONE                => 'Clone'           , 
    XCP_VM_DESTROY              => 'Destroy'         , 
    XCP_VM_INFO_DOWNLOAD        => 'Info Download'   , 
    XCP_VM_SNAPSHOT             => 'Snapshot'        , 
    XCP_SS_REVERT               => 'Snapshot Restore',
    XCP_VM_NETWORK_ASSIGN       => 'Assign Network'  ,
    XCP_VM_NETWORK_RELEASE      => 'Release Network' ,
  );
                      
  return $xcp_task_message ;
}


function _xcp_get_task_status_message() {
   
  $xcp_task_status_message = array(

    XCP_TASK_STATUS_INITIATED   => 'Initiated'   , 
    XCP_TASK_STATUS_IN_PROGRESS => 'In Progress' , 
    XCP_TASK_STATUS_COMPLETE    => 'Complete'    , 
    XCP_TASK_STATUS_FAILED      => 'Failed'      , 
    XCP_TASK_STATUS_CANCELED    => 'Canceled'    , 
    XCP_TASK_STATUS_SKIPPED     => 'Skipped'     ,
  );
          
  return $xcp_task_status_message ;        
}


function xcp_get_instances_action($instance_info_arr) {

//$sesid = _xcp_login() ;
  $sesid = _xcp_session_get() ;
  
  if ( empty($sesid) )
        return '' ;
  
  $key      = $instance_info_arr['instance_id'] ;
  $name     = trim($instance_info_arr['name'])  ;
  $state    = $instance_info_arr['state'    ]   ;   
  $user_key = $instance_info_arr['user'     ]   ; 
  $hostname = $instance_info_arr['hostname' ]   ; 
  $xcp_relative_path = drupal_get_path('module', XCP_CONTEXT ) ;
  $console_url = $xcp_relative_path .  "/xcp_console.inc" ;

  $query        = _xcp_get_instance_by_id_query() ;
  $query_args   = array() ;
  $query_args[] = $key ;

  $results = db_query( $query , $query_args );

  $vm = db_fetch_object($results)  ;
  
  // Fetch Console information
  $console_arr = _xcp_get_console_info_query() ;
  if (isset($console_arr[$vm->opaquereference]['location']) )  {
  
    $console_location = $console_arr[$vm->opaquereference]['location']  ;
  }
  else {

    $console_location = ''  ;
  }

  $action_data = '' ;
  $prop['onclick'] = cloud_get_messagebox('Are you sure you want to destroy the VM?') ;
  //if (user_access('administer xcp')) {
  $action_data  .= cloud_display_action( 'images/icon_clear', t('Edit') , XCP_PATH . '/describe/' . $key . '/vm_details',  array('html' => TRUE));
    //}
     
  if ($state == 'Halted' ) {

    if (user_access('administer xcp') ) {

      $action_data  .= cloud_display_action( 'images/icon_play', 'Launch' , XCP_PATH . '/' . $key . '/launch' ,  array( 'html' => TRUE));
      $action_data  .= cloud_display_action( 'images/icon_copy', 'Clone' , XCP_PATH  . '/' . $key . '/clone_vm' , array( 'html' => TRUE));
    }
    else {

      $action_data  .= cloud_display_action( 'images/icon_play', 'Launch' , XCP_PATH . '/' . $key . '/launch_default' ,  array('query' => 'name=' . urlencode($name) , 'html' => TRUE));
    }
     
  }
  elseif ($state == 'Running'
       || $state == 'Suspended') {
     
    $monitor_enabled = 'gray monitor disabled' ;
    //monitor actions
    $vm_ip = $hostname ;
    if ( empty($vm_monitor_info) === FALSE && isset($vm_monitor_info[$vm_ip] ) &&  $vm_monitor_info[$vm_ip] ) {
      $monitor_enabled = 'Monitor Enabled' ;
    }

    $action_data  .= cloud_display_action( 'images/icon_monitor' , $monitor_enabled , XCP_PATH . '/describe/' . $key . '/vm_monitor' ,  array('query' => 'name=' . urlencode($name) . "&action=Monitor", 'html' => TRUE));

    //console should be available for running state only
    if ($state == 'Running'
    && user_access('administer xcp')) {

      $xcp_relative_path = drupal_get_path('module', XCP_CONTEXT ) ;
      $console_data = '<H1>Console : ' . $name . '</H1>';
      $close_window = "<input type=button value=\"Close Console\" onClick=\"javascript:window.close();\">" ;
        
      $console_applet = "<applet archive=\"/" . $xcp_relative_path . "/XenServerConsole.jar\" code=com.citrix.xenserver.console.Initialize.class width=800 height=600><param name=SESSION value=\"$sesid\"><param name=URL value=\"$console_location\"><PARAM NAME=USEURL VALUE=\"true\"></applet>" ;
        
      $arr = array() ;
      $arr['onclick'] = ' popWin = open(\'' . $console_url . '\', \'Console\', \'width=900, height=800\');  popWin.focus();
      popWin.document.write(\'' . $console_data . $close_window . $console_applet . '\') ; return false ; ' ;

      $action_data  .= cloud_display_action(
                        'images/icon_ssh', 
                        'Console', 
                        $console_url, 
                         array('query' => 'id=' . urlencode($key), 
                        'html' => TRUE), $arr['onclick']
                      );
    } //end console condition

    if ($state == 'Suspended') {
      $action_data  .= cloud_display_action(
                        'images/icon_failover_up', 
                        'Resume', 
                         XCP_PATH . '/' . $key . '/resume', 
                         array( 'html' => TRUE)
                      );
    }
    if ($state == 'Running') {
      $action_data  .= cloud_display_action(
                        'images/icon_failover_up', 
                        'Reboot', 
                         XCP_PATH . '/' . $key . '/reboot', 
                         array('html' => TRUE)
                       );
       $action_data  .= cloud_display_action(
                         'images/icon_failover_up', 
                         'Hard Reboot', 
                         XCP_PATH . '/' . $key . '/hard_reboot', 
                         array( 'html' => TRUE)
                       );
    }

    if ($state != 'Suspended') {
      $action_data  .= cloud_display_action(
                        'images/action_stop', 
                        'Suspend', 
                         XCP_PATH . '/' . $key . '/suspend', 
                         array('html' => TRUE)
                      );
    }

    $action_data  .= cloud_display_action(
                        'images/action_stop', 
                        'Shutdown', 
                         XCP_PATH . '/' . $key . '/shutdown', 
                         array( 'html' => TRUE)
                      );

    $action_data  .= cloud_display_action(
                        'images/icon_failover_down', 
                        'Hard Shutdown', 
                         XCP_PATH . '/' . $key . '/hard_shutdown', 
                         array('html' => TRUE)
                      );
  }
   
  if ($state == 'Halted' ) {

    $action_data  .= cloud_display_action(
                      'images/icon_delete', 
                      'Destroy', 
                       XCP_PATH . '/' . $key . '/destroy', 
                       array('html' => TRUE), $prop['onclick']
                    );
  }
   
  if (isset($task_list[$key] ) === FALSE ) {
    
  }
  else {

    //$action_data = 'Operation in Progress' ;
    $action_data = '';
  }

  $lock_status = _xcp_get_lock_status($key) ;
  if ($lock_status ===  'Lock' )
    $action_data = '' ;

  return  $action_data ;  
}



function xcp_get_admin_settings($cloud_context) {

  $form = array() ;  

  $form['api_version'] = array(
    '#type'            => 'textfield',
    '#title'           => t('XCP Version'),
    '#description'     => t('The XCP Version (e.g. 0.5)'),
    '#size'            => 15,
    '#default_value'   => '',
    '#required'        => TRUE,
  ) ;
  
  $form[ 'host_uri'] = array(
    '#type'            => 'textfield', 
    '#title'           => t('XCP Host URL'), 
    '#description'     => t('XCP Host URL (e.g. http://192.168.0.1)') ,
    '#default_value'   => t('http://') ,
    '#size'            => 50,
    '#required'        => TRUE,
  );

  $form[ 'user_id'] = array(
    '#type'            => 'textfield', 
    '#title'           => t('XCP User ID'), 
    '#description'     => t('XCP Master Host user (NOT equal to a Linux user)'),
    '#size'            => 50,
    '#required'        => TRUE,
  );

  $form[ 'user_password'] = array(
    '#type'            => 'password', 
    '#title'           => t('XCP Password'), 
    '#description'     => t('XCP Password (For the above specified user)'),
    '#size'            => 50,
    '#required'        => TRUE,
  );

  // Since XCP doesn't require these values we set dummy values for XCP
  variable_set( XCP_CONTEXT . '_' . 'aws_access_key' , XCP_CONTEXT . '_aws_access_key' ) ;
  variable_set( XCP_CONTEXT . '_' . 'aws_secret_key' , XCP_CONTEXT . '_aws_secret_key' ) ;

 /*
  $form[ 'monitor_url'] = array(
    '#type'        => 'textfield', 
    '#title'       => t('Monitor URL'), 
    '#description' => t('URL of monitoring server (e.g. 192.168.0.1)'),  
    '#size'            => 50
  );

  $form[ 'subnet'] = array(
    '#type'        => 'textfield', 
    '#title'       => t('XCP Network IP Range (CIDR)'), 
    '#description' => t('XCP Subnet (CIDR)') ,  
    '#size'        => 50
  );


  $form[ 'monitoring_subnet'] = array(
    '#type'         => 'textfield', 
    '#title'        => t('XCP Monitoring Network IP Range (CIDR)'), 
    '#description'  => t('XCP Monitoring Subnet (CIDR)'),  
    '#size'         => 50
  );
*/
  
  return cloud_settings_form($form , $cloud_context ) ;
} 
